/* screen-notification.c generated by valac 0.56.14, the Vala compiler
 * generated from screen-notification.vala, do not modify */

/*
 * Copyright (c) 2016 gnome-pomodoro contributors
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Authors: Kamil Prusko <kamilprusko@gmail.com>
 *
 */
#if !defined VALA_STRICT_C && defined __GNUC__ && __GNUC__ >= 14
#pragma GCC diagnostic warning "-Wimplicit-function-declaration"
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#pragma GCC diagnostic warning "-Wint-conversion"
#pragma GCC diagnostic warning "-Wreturn-mismatch"
#endif

#include "gnome-pomodoro.h"
#include <glib-object.h>
#include <glib.h>
#include <gtk/gtk.h>
#include <float.h>
#include <math.h>
#include <gdk/gdk.h>
#include <cairo-gobject.h>
#include <stdlib.h>
#include <string.h>

#define POMODORO_SCREEN_NOTIFICATION_IDLE_TIME_TO_CLOSE ((guint) 600)
#define POMODORO_SCREEN_NOTIFICATION_MIN_DISPLAY_TIME ((guint) 500)
#define POMODORO_SCREEN_NOTIFICATION_FADE_IN_TIME ((guint) 180)
#define POMODORO_SCREEN_NOTIFICATION_FADE_OUT_TIME ((guint) 180)
#define POMODORO_SCREEN_NOTIFICATION_MOTION_DISTANCE_TO_CLOSE ((guint) 20)

enum  {
	POMODORO_SCREEN_NOTIFICATION_0_PROPERTY,
	POMODORO_SCREEN_NOTIFICATION_NUM_PROPERTIES
};
static GParamSpec* pomodoro_screen_notification_properties[POMODORO_SCREEN_NOTIFICATION_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _cairo_region_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_region_destroy (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

struct _PomodoroScreenNotificationPrivate {
	GObject* idle_monitor;
	gboolean _close_on_activity;
	GtkLabel* minutes_label;
	GtkLabel* seconds_label;
	guint fade_in_timeout_id;
	guint fade_out_timeout_id;
	PomodoroTimer* timer;
	gulong timer_elapsed_id;
	guint close_on_activity_id;
	guint32 last_event_time;
	gdouble last_motion_x;
	gdouble last_motion_y;
	gboolean _pass_through;
};

static gint PomodoroScreenNotification_private_offset;
static gpointer pomodoro_screen_notification_parent_class = NULL;
static GtkBuildableIface * pomodoro_screen_notification_gtk_buildable_parent_iface = NULL;

static void pomodoro_screen_notification_unschedule_close_on_activity (PomodoroScreenNotification* self);
static void pomodoro_screen_notification_do_set_pass_through (PomodoroScreenNotification* self,
                                                       gboolean value);
static void pomodoro_screen_notification_real_realize (GtkWidget* base);
static gboolean pomodoro_screen_notification_get_pass_through (PomodoroScreenNotification* self);
static void pomodoro_screen_notification_real_parser_finished (GtkBuildable* base,
                                                        GtkBuilder* builder);
static void pomodoro_screen_notification_on_timer_state_changed (PomodoroScreenNotification* self);
static void pomodoro_screen_notification_on_timer_elapsed_notify (PomodoroScreenNotification* self);
static void _pomodoro_screen_notification_on_timer_elapsed_notify_g_object_notify (GObject* _sender,
                                                                            GParamSpec* pspec,
                                                                            gpointer self);
static void pomodoro_screen_notification_real_show (GtkWidget* base);
static void pomodoro_screen_notification_fade_in (PomodoroScreenNotification* self);
static void pomodoro_screen_notification_fade_out (PomodoroScreenNotification* self);
static gboolean pomodoro_screen_notification_on_fade_in_timeout (PomodoroScreenNotification* self);
static void pomodoro_screen_notification_set_pass_through (PomodoroScreenNotification* self,
                                                    gboolean value);
static gboolean pomodoro_screen_notification_on_fade_out_timeout (PomodoroScreenNotification* self);
static gboolean _pomodoro_screen_notification_on_fade_in_timeout_gsource_func (gpointer self);
static void pomodoro_screen_notification_schedule_close_on_activity (PomodoroScreenNotification* self);
static void pomodoro_screen_notification_set_close_on_activity (PomodoroScreenNotification* self,
                                                         gboolean value);
static gboolean _pomodoro_screen_notification_on_fade_out_timeout_gsource_func (gpointer self);
static guint32 pomodoro_screen_notification_get_idle_time (PomodoroScreenNotification* self);
static gboolean pomodoro_screen_notification_real_event (GtkWidget* base,
                                                  GdkEvent* event);
static gboolean pomodoro_screen_notification_get_close_on_activity (PomodoroScreenNotification* self);
static gboolean pomodoro_screen_notification_on_close_on_activity_timeout (PomodoroScreenNotification* self);
static gboolean _pomodoro_screen_notification_on_close_on_activity_timeout_gsource_func (gpointer self);
static GObject * pomodoro_screen_notification_constructor (GType type,
                                                    guint n_construct_properties,
                                                    GObjectConstructParam * construct_properties);
static void _pomodoro_screen_notification_on_timer_state_changed_pomodoro_timer_state_changed (PomodoroTimer* _sender,
                                                                                        PomodoroTimerState* state,
                                                                                        PomodoroTimerState* previous_state,
                                                                                        gpointer self);
static void pomodoro_screen_notification_finalize (GObject * obj);
static GType pomodoro_screen_notification_get_type_once (void);
static void _vala_pomodoro_screen_notification_get_property (GObject * object,
                                                      guint property_id,
                                                      GValue * value,
                                                      GParamSpec * pspec);
static void _vala_pomodoro_screen_notification_set_property (GObject * object,
                                                      guint property_id,
                                                      const GValue * value,
                                                      GParamSpec * pspec);

static inline gpointer
pomodoro_screen_notification_get_instance_private (PomodoroScreenNotification* self)
{
	return G_STRUCT_MEMBER_P (self, PomodoroScreenNotification_private_offset);
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 108 "../src/screen-notification.vala"
	return self ? g_object_ref (self) : NULL;
#line 136 "screen-notification.c"
}

static void
pomodoro_screen_notification_do_set_pass_through (PomodoroScreenNotification* self,
                                                  gboolean value)
{
#line 92 "../src/screen-notification.vala"
	g_return_if_fail (self != NULL);
#line 94 "../src/screen-notification.vala"
	self->priv->_pass_through = value;
#line 96 "../src/screen-notification.vala"
	self->priv->last_event_time = (guint32) (g_get_real_time () / 1000);
#line 97 "../src/screen-notification.vala"
	self->priv->last_motion_x = -1.0;
#line 98 "../src/screen-notification.vala"
	self->priv->last_motion_y = -1.0;
#line 100 "../src/screen-notification.vala"
	if (value) {
#line 155 "screen-notification.c"
		cairo_region_t* _tmp0_;
		cairo_region_t* _tmp1_;
#line 101 "../src/screen-notification.vala"
		_tmp0_ = cairo_region_create ();
#line 101 "../src/screen-notification.vala"
		_tmp1_ = _tmp0_;
#line 101 "../src/screen-notification.vala"
		gtk_widget_input_shape_combine_region ((GtkWidget*) self, _tmp1_);
#line 101 "../src/screen-notification.vala"
		_cairo_region_destroy0 (_tmp1_);
#line 166 "screen-notification.c"
	} else {
#line 104 "../src/screen-notification.vala"
		gtk_widget_input_shape_combine_region ((GtkWidget*) self, NULL);
#line 170 "screen-notification.c"
	}
#line 107 "../src/screen-notification.vala"
	if (gtk_widget_get_realized ((GtkWidget*) self)) {
#line 174 "screen-notification.c"
		GdkWindow* window = NULL;
		GdkWindow* _tmp2_;
		GdkWindow* _tmp3_;
		GdkCursor* _tmp4_ = NULL;
		GdkCursor* cursor = NULL;
		GdkCursor* _tmp8_;
		GdkWindow* _tmp9_;
		GdkCursor* _tmp10_;
#line 108 "../src/screen-notification.vala"
		_tmp2_ = gtk_widget_get_window ((GtkWidget*) self);
#line 108 "../src/screen-notification.vala"
		_tmp3_ = _g_object_ref0 (_tmp2_);
#line 108 "../src/screen-notification.vala"
		window = _tmp3_;
#line 110 "../src/screen-notification.vala"
		if (value) {
#line 110 "../src/screen-notification.vala"
			_g_object_unref0 (_tmp4_);
#line 110 "../src/screen-notification.vala"
			_tmp4_ = NULL;
#line 195 "screen-notification.c"
		} else {
			GdkWindow* _tmp5_;
			GdkDisplay* _tmp6_;
			GdkCursor* _tmp7_;
#line 110 "../src/screen-notification.vala"
			_tmp5_ = window;
#line 110 "../src/screen-notification.vala"
			_tmp6_ = gdk_window_get_display (_tmp5_);
#line 110 "../src/screen-notification.vala"
			_tmp7_ = gdk_cursor_new_from_name (_tmp6_, "none");
#line 110 "../src/screen-notification.vala"
			_g_object_unref0 (_tmp4_);
#line 110 "../src/screen-notification.vala"
			_tmp4_ = _tmp7_;
#line 210 "screen-notification.c"
		}
#line 110 "../src/screen-notification.vala"
		_tmp8_ = _g_object_ref0 (_tmp4_);
#line 110 "../src/screen-notification.vala"
		cursor = _tmp8_;
#line 111 "../src/screen-notification.vala"
		_tmp9_ = window;
#line 111 "../src/screen-notification.vala"
		_tmp10_ = cursor;
#line 111 "../src/screen-notification.vala"
		gdk_window_set_cursor (_tmp9_, _tmp10_);
#line 107 "../src/screen-notification.vala"
		_g_object_unref0 (cursor);
#line 107 "../src/screen-notification.vala"
		_g_object_unref0 (_tmp4_);
#line 107 "../src/screen-notification.vala"
		_g_object_unref0 (window);
#line 228 "screen-notification.c"
	}
}

static void
pomodoro_screen_notification_real_realize (GtkWidget* base)
{
	PomodoroScreenNotification * self;
	gboolean _tmp0_;
	gboolean _tmp1_;
#line 115 "../src/screen-notification.vala"
	self = (PomodoroScreenNotification*) base;
#line 117 "../src/screen-notification.vala"
	GTK_WIDGET_CLASS (pomodoro_screen_notification_parent_class)->realize ((GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (self, gtk_window_get_type (), GtkWindow));
#line 119 "../src/screen-notification.vala"
	_tmp0_ = pomodoro_screen_notification_get_pass_through (self);
#line 119 "../src/screen-notification.vala"
	_tmp1_ = _tmp0_;
#line 119 "../src/screen-notification.vala"
	pomodoro_screen_notification_do_set_pass_through (self, _tmp1_);
#line 248 "screen-notification.c"
}

static void
pomodoro_screen_notification_real_parser_finished (GtkBuildable* base,
                                                   GtkBuilder* builder)
{
	PomodoroScreenNotification * self;
	GtkStyleContext* style_context = NULL;
	GtkStyleContext* _tmp0_;
	GtkStyleContext* _tmp1_;
#line 126 "../src/screen-notification.vala"
	self = (PomodoroScreenNotification*) base;
#line 126 "../src/screen-notification.vala"
	g_return_if_fail (builder != NULL);
#line 128 "../src/screen-notification.vala"
	pomodoro_screen_notification_gtk_buildable_parent_iface->parser_finished ((GtkBuildable*) G_TYPE_CHECK_INSTANCE_CAST (self, gtk_window_get_type (), GtkWindow), builder);
#line 130 "../src/screen-notification.vala"
	_tmp0_ = gtk_widget_get_style_context ((GtkWidget*) self);
#line 130 "../src/screen-notification.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 130 "../src/screen-notification.vala"
	style_context = _tmp1_;
#line 131 "../src/screen-notification.vala"
	gtk_style_context_add_class (style_context, "hidden");
#line 126 "../src/screen-notification.vala"
	_g_object_unref0 (style_context);
#line 275 "screen-notification.c"
}

static void
_pomodoro_screen_notification_on_timer_elapsed_notify_g_object_notify (GObject* _sender,
                                                                       GParamSpec* pspec,
                                                                       gpointer self)
{
#line 143 "../src/screen-notification.vala"
	pomodoro_screen_notification_on_timer_elapsed_notify ((PomodoroScreenNotification*) self);
#line 285 "screen-notification.c"
}

static void
pomodoro_screen_notification_on_timer_state_changed (PomodoroScreenNotification* self)
{
	PomodoroTimer* _tmp1_;
	PomodoroTimerState* _tmp2_;
	PomodoroTimerState* _tmp3_;
#line 134 "../src/screen-notification.vala"
	g_return_if_fail (self != NULL);
#line 136 "../src/screen-notification.vala"
	if (self->priv->timer_elapsed_id != ((gulong) 0)) {
#line 298 "screen-notification.c"
		PomodoroTimer* _tmp0_;
#line 137 "../src/screen-notification.vala"
		_tmp0_ = self->priv->timer;
#line 137 "../src/screen-notification.vala"
		g_signal_handler_disconnect ((GObject*) _tmp0_, self->priv->timer_elapsed_id);
#line 138 "../src/screen-notification.vala"
		self->priv->timer_elapsed_id = (gulong) 0;
#line 306 "screen-notification.c"
	}
#line 142 "../src/screen-notification.vala"
	_tmp1_ = self->priv->timer;
#line 142 "../src/screen-notification.vala"
	_tmp2_ = pomodoro_timer_get_state (_tmp1_);
#line 142 "../src/screen-notification.vala"
	_tmp3_ = _tmp2_;
#line 142 "../src/screen-notification.vala"
	if (POMODORO_IS_BREAK_STATE (_tmp3_)) {
#line 316 "screen-notification.c"
		PomodoroTimer* _tmp4_;
		gulong _tmp5_;
#line 143 "../src/screen-notification.vala"
		_tmp4_ = self->priv->timer;
#line 143 "../src/screen-notification.vala"
		_tmp5_ = g_signal_connect_object ((GObject*) _tmp4_, "notify::elapsed", (GCallback) _pomodoro_screen_notification_on_timer_elapsed_notify_g_object_notify, self, G_CONNECT_AFTER);
#line 143 "../src/screen-notification.vala"
		self->priv->timer_elapsed_id = _tmp5_;
#line 145 "../src/screen-notification.vala"
		pomodoro_screen_notification_on_timer_elapsed_notify (self);
#line 327 "screen-notification.c"
	}
}

static void
pomodoro_screen_notification_on_timer_elapsed_notify (PomodoroScreenNotification* self)
{
	guint remaining = 0U;
	PomodoroTimer* _tmp0_;
	gdouble _tmp1_;
	gdouble _tmp2_;
	guint minutes = 0U;
	guint seconds = 0U;
	GtkLabel* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	GtkLabel* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
#line 149 "../src/screen-notification.vala"
	g_return_if_fail (self != NULL);
#line 151 "../src/screen-notification.vala"
	_tmp0_ = self->priv->timer;
#line 151 "../src/screen-notification.vala"
	_tmp1_ = pomodoro_timer_get_remaining (_tmp0_);
#line 151 "../src/screen-notification.vala"
	_tmp2_ = _tmp1_;
#line 151 "../src/screen-notification.vala"
	remaining = (guint) MAX (ceil (_tmp2_), 0.0);
#line 152 "../src/screen-notification.vala"
	minutes = remaining / 60;
#line 153 "../src/screen-notification.vala"
	seconds = remaining % 60;
#line 155 "../src/screen-notification.vala"
	_tmp3_ = self->priv->minutes_label;
#line 155 "../src/screen-notification.vala"
	_tmp4_ = g_strdup_printf ("%02u", minutes);
#line 155 "../src/screen-notification.vala"
	_tmp5_ = _tmp4_;
#line 155 "../src/screen-notification.vala"
	gtk_label_set_label (_tmp3_, _tmp5_);
#line 155 "../src/screen-notification.vala"
	_g_free0 (_tmp5_);
#line 156 "../src/screen-notification.vala"
	_tmp6_ = self->priv->seconds_label;
#line 156 "../src/screen-notification.vala"
	_tmp7_ = g_strdup_printf ("%02u", seconds);
#line 156 "../src/screen-notification.vala"
	_tmp8_ = _tmp7_;
#line 156 "../src/screen-notification.vala"
	gtk_label_set_label (_tmp6_, _tmp8_);
#line 156 "../src/screen-notification.vala"
	_g_free0 (_tmp8_);
#line 380 "screen-notification.c"
}

static void
pomodoro_screen_notification_real_show (GtkWidget* base)
{
	PomodoroScreenNotification * self;
#line 159 "../src/screen-notification.vala"
	self = (PomodoroScreenNotification*) base;
#line 161 "../src/screen-notification.vala"
	pomodoro_screen_notification_fade_in (self);
#line 391 "screen-notification.c"
}

void
pomodoro_screen_notification_close (PomodoroScreenNotification* self)
{
#line 164 "../src/screen-notification.vala"
	g_return_if_fail (self != NULL);
#line 166 "../src/screen-notification.vala"
	pomodoro_screen_notification_fade_out (self);
#line 401 "screen-notification.c"
}

static gboolean
pomodoro_screen_notification_on_fade_in_timeout (PomodoroScreenNotification* self)
{
	GObject* _tmp0_;
	gboolean result;
#line 169 "../src/screen-notification.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 171 "../src/screen-notification.vala"
	self->priv->fade_in_timeout_id = (guint) 0;
#line 173 "../src/screen-notification.vala"
	_tmp0_ = self->priv->idle_monitor;
#line 173 "../src/screen-notification.vala"
	if (_tmp0_ == NULL) {
#line 174 "../src/screen-notification.vala"
		pomodoro_screen_notification_set_pass_through (self, FALSE);
#line 419 "screen-notification.c"
	}
#line 177 "../src/screen-notification.vala"
	result = FALSE;
#line 177 "../src/screen-notification.vala"
	return result;
#line 425 "screen-notification.c"
}

static gboolean
pomodoro_screen_notification_on_fade_out_timeout (PomodoroScreenNotification* self)
{
	gboolean result;
#line 180 "../src/screen-notification.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 182 "../src/screen-notification.vala"
	self->priv->fade_out_timeout_id = (guint) 0;
#line 184 "../src/screen-notification.vala"
	gtk_window_close (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_window_get_type (), GtkWindow));
#line 186 "../src/screen-notification.vala"
	result = FALSE;
#line 186 "../src/screen-notification.vala"
	return result;
#line 442 "screen-notification.c"
}

static gboolean
_pomodoro_screen_notification_on_fade_in_timeout_gsource_func (gpointer self)
{
	gboolean result;
	result = pomodoro_screen_notification_on_fade_in_timeout ((PomodoroScreenNotification*) self);
#line 202 "../src/screen-notification.vala"
	return result;
#line 452 "screen-notification.c"
}

static void
pomodoro_screen_notification_fade_in (PomodoroScreenNotification* self)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
	GtkStyleContext* _tmp2_;
#line 189 "../src/screen-notification.vala"
	g_return_if_fail (self != NULL);
#line 191 "../src/screen-notification.vala"
	_tmp0_ = gtk_widget_get_visible ((GtkWidget*) self);
#line 191 "../src/screen-notification.vala"
	_tmp1_ = _tmp0_;
#line 191 "../src/screen-notification.vala"
	if (!_tmp1_) {
#line 192 "../src/screen-notification.vala"
		GTK_WIDGET_CLASS (pomodoro_screen_notification_parent_class)->show ((GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (self, gtk_window_get_type (), GtkWindow));
#line 471 "screen-notification.c"
	}
#line 196 "../src/screen-notification.vala"
	gtk_window_present (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_window_get_type (), GtkWindow));
#line 198 "../src/screen-notification.vala"
	_tmp2_ = gtk_widget_get_style_context ((GtkWidget*) self);
#line 198 "../src/screen-notification.vala"
	gtk_style_context_remove_class (_tmp2_, "hidden");
#line 199 "../src/screen-notification.vala"
	pomodoro_screen_notification_set_pass_through (self, TRUE);
#line 201 "../src/screen-notification.vala"
	if (self->priv->fade_in_timeout_id == ((guint) 0)) {
#line 202 "../src/screen-notification.vala"
		self->priv->fade_in_timeout_id = g_timeout_add_full (G_PRIORITY_DEFAULT, POMODORO_SCREEN_NOTIFICATION_FADE_IN_TIME, _pomodoro_screen_notification_on_fade_in_timeout_gsource_func, g_object_ref (self), g_object_unref);
#line 485 "screen-notification.c"
	}
#line 206 "../src/screen-notification.vala"
	pomodoro_screen_notification_schedule_close_on_activity (self);
#line 489 "screen-notification.c"
}

static gboolean
_pomodoro_screen_notification_on_fade_out_timeout_gsource_func (gpointer self)
{
	gboolean result;
	result = pomodoro_screen_notification_on_fade_out_timeout ((PomodoroScreenNotification*) self);
#line 218 "../src/screen-notification.vala"
	return result;
#line 499 "screen-notification.c"
}

static void
pomodoro_screen_notification_fade_out (PomodoroScreenNotification* self)
{
	GtkStyleContext* _tmp0_;
#line 209 "../src/screen-notification.vala"
	g_return_if_fail (self != NULL);
#line 211 "../src/screen-notification.vala"
	_tmp0_ = gtk_widget_get_style_context ((GtkWidget*) self);
#line 211 "../src/screen-notification.vala"
	gtk_style_context_add_class (_tmp0_, "hidden");
#line 212 "../src/screen-notification.vala"
	pomodoro_screen_notification_set_pass_through (self, TRUE);
#line 214 "../src/screen-notification.vala"
	pomodoro_screen_notification_set_close_on_activity (self, FALSE);
#line 215 "../src/screen-notification.vala"
	pomodoro_screen_notification_unschedule_close_on_activity (self);
#line 217 "../src/screen-notification.vala"
	if (self->priv->fade_out_timeout_id == ((guint) 0)) {
#line 218 "../src/screen-notification.vala"
		self->priv->fade_out_timeout_id = g_timeout_add_full (G_PRIORITY_DEFAULT, POMODORO_SCREEN_NOTIFICATION_FADE_OUT_TIME, _pomodoro_screen_notification_on_fade_out_timeout_gsource_func, g_object_ref (self), g_object_unref);
#line 522 "screen-notification.c"
	}
}

static guint32
pomodoro_screen_notification_get_idle_time (PomodoroScreenNotification* self)
{
	guint32 _tmp0_ = 0U;
	guint32 result;
#line 223 "../src/screen-notification.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 225 "../src/screen-notification.vala"
	if (self->priv->last_event_time != ((guint32) 0)) {
#line 226 "../src/screen-notification.vala"
		_tmp0_ = gtk_get_current_event_time () - self->priv->last_event_time;
#line 537 "screen-notification.c"
	} else {
#line 227 "../src/screen-notification.vala"
		_tmp0_ = (guint32) 0;
#line 541 "screen-notification.c"
	}
#line 225 "../src/screen-notification.vala"
	result = _tmp0_;
#line 225 "../src/screen-notification.vala"
	return result;
#line 547 "screen-notification.c"
}

static gboolean
pomodoro_screen_notification_real_event (GtkWidget* base,
                                         GdkEvent* event)
{
	PomodoroScreenNotification * self;
	gboolean _tmp0_;
	guint32 event_time = 0U;
	guint32 idle_time = 0U;
	gboolean result;
#line 230 "../src/screen-notification.vala"
	self = (PomodoroScreenNotification*) base;
#line 230 "../src/screen-notification.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 232 "../src/screen-notification.vala"
	_tmp0_ = self->priv->_close_on_activity;
#line 232 "../src/screen-notification.vala"
	if (!_tmp0_) {
#line 233 "../src/screen-notification.vala"
		result = GTK_WIDGET_CLASS (pomodoro_screen_notification_parent_class)->event ((GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (self, gtk_window_get_type (), GtkWindow), event);
#line 233 "../src/screen-notification.vala"
		return result;
#line 571 "screen-notification.c"
	}
#line 236 "../src/screen-notification.vala"
	event_time = gdk_event_get_time (event);
#line 237 "../src/screen-notification.vala"
	idle_time = pomodoro_screen_notification_get_idle_time (self);
#line 239 "../src/screen-notification.vala"
	switch (event->type) {
#line 239 "../src/screen-notification.vala"
		case GDK_MOTION_NOTIFY:
#line 581 "screen-notification.c"
		{
			GdkEventMotion* _tmp1_;
			GdkEventMotion* _tmp2_;
			gdouble _tmp3_ = 0.0;
			gdouble dx = 0.0;
			gdouble _tmp6_ = 0.0;
			gdouble dy = 0.0;
			gdouble distance = 0.0;
			GdkEventMotion* _tmp9_;
			GdkEventMotion* _tmp10_;
			GdkEventMotion* _tmp11_;
			GdkEventMotion* _tmp12_;
#line 242 "../src/screen-notification.vala"
			_tmp1_ = (GdkEventMotion *) (event);
#line 242 "../src/screen-notification.vala"
			_tmp2_ = _tmp1_;
#line 242 "../src/screen-notification.vala"
			if (((gint) _tmp2_->is_hint) == 1) {
#line 243 "../src/screen-notification.vala"
				result = TRUE;
#line 243 "../src/screen-notification.vala"
				return result;
#line 604 "screen-notification.c"
			}
#line 246 "../src/screen-notification.vala"
			if (self->priv->last_motion_x >= 0.0) {
#line 608 "screen-notification.c"
				GdkEventMotion* _tmp4_;
				GdkEventMotion* _tmp5_;
#line 246 "../src/screen-notification.vala"
				_tmp4_ = (GdkEventMotion *) (event);
#line 246 "../src/screen-notification.vala"
				_tmp5_ = _tmp4_;
#line 246 "../src/screen-notification.vala"
				_tmp3_ = _tmp5_->x_root - self->priv->last_motion_x;
#line 617 "screen-notification.c"
			} else {
#line 246 "../src/screen-notification.vala"
				_tmp3_ = 0.0;
#line 621 "screen-notification.c"
			}
#line 246 "../src/screen-notification.vala"
			dx = _tmp3_;
#line 247 "../src/screen-notification.vala"
			if (self->priv->last_motion_y >= 0.0) {
#line 627 "screen-notification.c"
				GdkEventMotion* _tmp7_;
				GdkEventMotion* _tmp8_;
#line 247 "../src/screen-notification.vala"
				_tmp7_ = (GdkEventMotion *) (event);
#line 247 "../src/screen-notification.vala"
				_tmp8_ = _tmp7_;
#line 247 "../src/screen-notification.vala"
				_tmp6_ = _tmp8_->y_root - self->priv->last_motion_y;
#line 636 "screen-notification.c"
			} else {
#line 247 "../src/screen-notification.vala"
				_tmp6_ = 0.0;
#line 640 "screen-notification.c"
			}
#line 247 "../src/screen-notification.vala"
			dy = _tmp6_;
#line 248 "../src/screen-notification.vala"
			distance = (dx * dx) + (dy * dy);
#line 250 "../src/screen-notification.vala"
			_tmp9_ = (GdkEventMotion *) (event);
#line 250 "../src/screen-notification.vala"
			_tmp10_ = _tmp9_;
#line 250 "../src/screen-notification.vala"
			self->priv->last_motion_x = _tmp10_->x_root;
#line 251 "../src/screen-notification.vala"
			_tmp11_ = (GdkEventMotion *) (event);
#line 251 "../src/screen-notification.vala"
			_tmp12_ = _tmp11_;
#line 251 "../src/screen-notification.vala"
			self->priv->last_motion_y = _tmp12_->y_root;
#line 252 "../src/screen-notification.vala"
			self->priv->last_event_time = event_time;
#line 254 "../src/screen-notification.vala"
			if (distance > ((gdouble) (POMODORO_SCREEN_NOTIFICATION_MOTION_DISTANCE_TO_CLOSE * POMODORO_SCREEN_NOTIFICATION_MOTION_DISTANCE_TO_CLOSE))) {
#line 255 "../src/screen-notification.vala"
				pomodoro_screen_notification_close (self);
#line 664 "screen-notification.c"
			}
#line 258 "../src/screen-notification.vala"
			break;
#line 668 "screen-notification.c"
		}
#line 239 "../src/screen-notification.vala"
		case GDK_BUTTON_PRESS:
#line 239 "../src/screen-notification.vala"
		case GDK_KEY_PRESS:
#line 239 "../src/screen-notification.vala"
		case GDK_TOUCH_BEGIN:
#line 676 "screen-notification.c"
		{
#line 263 "../src/screen-notification.vala"
			self->priv->last_event_time = event_time;
#line 265 "../src/screen-notification.vala"
			if (idle_time > ((guint32) POMODORO_SCREEN_NOTIFICATION_IDLE_TIME_TO_CLOSE)) {
#line 266 "../src/screen-notification.vala"
				pomodoro_screen_notification_close (self);
#line 684 "screen-notification.c"
			}
#line 269 "../src/screen-notification.vala"
			break;
#line 688 "screen-notification.c"
		}
#line 239 "../src/screen-notification.vala"
		case GDK_FOCUS_CHANGE:
#line 692 "screen-notification.c"
		{
#line 272 "../src/screen-notification.vala"
			self->priv->last_event_time = event_time;
#line 274 "../src/screen-notification.vala"
			pomodoro_screen_notification_close (self);
#line 276 "../src/screen-notification.vala"
			break;
#line 700 "screen-notification.c"
		}
		default:
		{
#line 279 "../src/screen-notification.vala"
			break;
#line 706 "screen-notification.c"
		}
	}
#line 282 "../src/screen-notification.vala"
	result = TRUE;
#line 282 "../src/screen-notification.vala"
	return result;
#line 713 "screen-notification.c"
}

static gboolean
pomodoro_screen_notification_on_close_on_activity_timeout (PomodoroScreenNotification* self)
{
	gboolean result;
#line 285 "../src/screen-notification.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 287 "../src/screen-notification.vala"
	self->priv->close_on_activity_id = (guint) 0;
#line 289 "../src/screen-notification.vala"
	pomodoro_screen_notification_set_close_on_activity (self, TRUE);
#line 291 "../src/screen-notification.vala"
	result = G_SOURCE_REMOVE;
#line 291 "../src/screen-notification.vala"
	return result;
#line 730 "screen-notification.c"
}

static void
pomodoro_screen_notification_unschedule_close_on_activity (PomodoroScreenNotification* self)
{
#line 294 "../src/screen-notification.vala"
	g_return_if_fail (self != NULL);
#line 296 "../src/screen-notification.vala"
	if (self->priv->close_on_activity_id != ((guint) 0)) {
#line 297 "../src/screen-notification.vala"
		g_source_remove (self->priv->close_on_activity_id);
#line 298 "../src/screen-notification.vala"
		self->priv->close_on_activity_id = (guint) 0;
#line 744 "screen-notification.c"
	}
}

static gboolean
_pomodoro_screen_notification_on_close_on_activity_timeout_gsource_func (gpointer self)
{
	gboolean result;
	result = pomodoro_screen_notification_on_close_on_activity_timeout ((PomodoroScreenNotification*) self);
#line 306 "../src/screen-notification.vala"
	return result;
#line 755 "screen-notification.c"
}

static void
pomodoro_screen_notification_schedule_close_on_activity (PomodoroScreenNotification* self)
{
#line 302 "../src/screen-notification.vala"
	g_return_if_fail (self != NULL);
#line 304 "../src/screen-notification.vala"
	pomodoro_screen_notification_unschedule_close_on_activity (self);
#line 306 "../src/screen-notification.vala"
	self->priv->close_on_activity_id = g_timeout_add_full (G_PRIORITY_DEFAULT, POMODORO_SCREEN_NOTIFICATION_MIN_DISPLAY_TIME, _pomodoro_screen_notification_on_close_on_activity_timeout_gsource_func, g_object_ref (self), g_object_unref);
#line 767 "screen-notification.c"
}

PomodoroScreenNotification*
pomodoro_screen_notification_construct (GType object_type)
{
	PomodoroScreenNotification * self = NULL;
#line 31 "../src/screen-notification.vala"
	self = (PomodoroScreenNotification*) g_object_new (object_type, NULL);
#line 31 "../src/screen-notification.vala"
	return self;
#line 778 "screen-notification.c"
}

PomodoroScreenNotification*
pomodoro_screen_notification_new (void)
{
#line 31 "../src/screen-notification.vala"
	return pomodoro_screen_notification_construct (POMODORO_TYPE_SCREEN_NOTIFICATION);
#line 786 "screen-notification.c"
}

static gboolean
pomodoro_screen_notification_get_pass_through (PomodoroScreenNotification* self)
{
	gboolean result;
#line 50 "../src/screen-notification.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 51 "../src/screen-notification.vala"
	result = self->priv->_pass_through;
#line 51 "../src/screen-notification.vala"
	return result;
#line 799 "screen-notification.c"
}

static void
pomodoro_screen_notification_set_pass_through (PomodoroScreenNotification* self,
                                               gboolean value)
{
#line 53 "../src/screen-notification.vala"
	g_return_if_fail (self != NULL);
#line 54 "../src/screen-notification.vala"
	pomodoro_screen_notification_do_set_pass_through (self, value);
#line 810 "screen-notification.c"
}

static gboolean
pomodoro_screen_notification_get_close_on_activity (PomodoroScreenNotification* self)
{
	gboolean result;
#line 58 "../src/screen-notification.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 58 "../src/screen-notification.vala"
	result = self->priv->_close_on_activity;
#line 58 "../src/screen-notification.vala"
	return result;
#line 823 "screen-notification.c"
}

static void
pomodoro_screen_notification_set_close_on_activity (PomodoroScreenNotification* self,
                                                    gboolean value)
{
#line 58 "../src/screen-notification.vala"
	g_return_if_fail (self != NULL);
#line 58 "../src/screen-notification.vala"
	self->priv->_close_on_activity = value;
#line 834 "screen-notification.c"
}

static void
_pomodoro_screen_notification_on_timer_state_changed_pomodoro_timer_state_changed (PomodoroTimer* _sender,
                                                                                   PomodoroTimerState* state,
                                                                                   PomodoroTimerState* previous_state,
                                                                                   gpointer self)
{
#line 78 "../src/screen-notification.vala"
	pomodoro_screen_notification_on_timer_state_changed ((PomodoroScreenNotification*) self);
#line 845 "screen-notification.c"
}

static GObject *
pomodoro_screen_notification_constructor (GType type,
                                          guint n_construct_properties,
                                          GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	PomodoroScreenNotification * self;
	PomodoroTimer* _tmp0_;
	PomodoroTimer* _tmp1_;
#line 75 "../src/screen-notification.vala"
	parent_class = G_OBJECT_CLASS (pomodoro_screen_notification_parent_class);
#line 75 "../src/screen-notification.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 75 "../src/screen-notification.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, POMODORO_TYPE_SCREEN_NOTIFICATION, PomodoroScreenNotification);
#line 77 "../src/screen-notification.vala"
	_tmp0_ = pomodoro_timer_get_default ();
#line 77 "../src/screen-notification.vala"
	self->priv->timer = _tmp0_;
#line 78 "../src/screen-notification.vala"
	_tmp1_ = self->priv->timer;
#line 78 "../src/screen-notification.vala"
	g_signal_connect_object (_tmp1_, "state-changed", (GCallback) _pomodoro_screen_notification_on_timer_state_changed_pomodoro_timer_state_changed, self, 0);
#line 80 "../src/screen-notification.vala"
	pomodoro_screen_notification_on_timer_state_changed (self);
#line 82 "../src/screen-notification.vala"
	gtk_window_fullscreen ((GtkWindow*) self);
#line 83 "../src/screen-notification.vala"
	gtk_window_stick ((GtkWindow*) self);
#line 84 "../src/screen-notification.vala"
	gtk_window_set_keep_above ((GtkWindow*) self, TRUE);
#line 75 "../src/screen-notification.vala"
	return obj;
#line 882 "screen-notification.c"
}

static void
pomodoro_screen_notification_class_init (PomodoroScreenNotificationClass * klass,
                                         gpointer klass_data)
{
#line 31 "../src/screen-notification.vala"
	pomodoro_screen_notification_parent_class = g_type_class_peek_parent (klass);
#line 31 "../src/screen-notification.vala"
	g_type_class_adjust_private_offset (klass, &PomodoroScreenNotification_private_offset);
#line 31 "../src/screen-notification.vala"
	((GtkWidgetClass *) klass)->realize = (void (*) (GtkWidget*)) pomodoro_screen_notification_real_realize;
#line 31 "../src/screen-notification.vala"
	((GtkWidgetClass *) klass)->show = (void (*) (GtkWidget*)) pomodoro_screen_notification_real_show;
#line 31 "../src/screen-notification.vala"
	((GtkWidgetClass *) klass)->event = (gboolean (*) (GtkWidget*, GdkEvent*)) pomodoro_screen_notification_real_event;
#line 31 "../src/screen-notification.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_pomodoro_screen_notification_get_property;
#line 31 "../src/screen-notification.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_pomodoro_screen_notification_set_property;
#line 31 "../src/screen-notification.vala"
	G_OBJECT_CLASS (klass)->constructor = pomodoro_screen_notification_constructor;
#line 31 "../src/screen-notification.vala"
	G_OBJECT_CLASS (klass)->finalize = pomodoro_screen_notification_finalize;
#line 31 "../src/screen-notification.vala"
	gtk_widget_class_set_template_from_resource (GTK_WIDGET_CLASS (klass), "/org/gnome/pomodoro/screen-notification.ui");
#line 31 "../src/screen-notification.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "minutes_label", FALSE, PomodoroScreenNotification_private_offset + G_STRUCT_OFFSET (PomodoroScreenNotificationPrivate, minutes_label));
#line 31 "../src/screen-notification.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "seconds_label", FALSE, PomodoroScreenNotification_private_offset + G_STRUCT_OFFSET (PomodoroScreenNotificationPrivate, seconds_label));
#line 913 "screen-notification.c"
}

static void
pomodoro_screen_notification_gtk_buildable_interface_init (GtkBuildableIface * iface,
                                                           gpointer iface_data)
{
#line 31 "../src/screen-notification.vala"
	pomodoro_screen_notification_gtk_buildable_parent_iface = g_type_interface_peek_parent (iface);
#line 31 "../src/screen-notification.vala"
	iface->parser_finished = (void (*) (GtkBuildable*, GtkBuilder*)) pomodoro_screen_notification_real_parser_finished;
#line 924 "screen-notification.c"
}

static void
pomodoro_screen_notification_instance_init (PomodoroScreenNotification * self,
                                            gpointer klass)
{
#line 31 "../src/screen-notification.vala"
	self->priv = pomodoro_screen_notification_get_instance_private (self);
#line 58 "../src/screen-notification.vala"
	self->priv->_close_on_activity = FALSE;
#line 65 "../src/screen-notification.vala"
	self->priv->fade_in_timeout_id = (guint) 0;
#line 66 "../src/screen-notification.vala"
	self->priv->fade_out_timeout_id = (guint) 0;
#line 68 "../src/screen-notification.vala"
	self->priv->timer_elapsed_id = (gulong) 0;
#line 69 "../src/screen-notification.vala"
	self->priv->close_on_activity_id = (guint) 0;
#line 70 "../src/screen-notification.vala"
	self->priv->last_event_time = (guint32) 0;
#line 71 "../src/screen-notification.vala"
	self->priv->last_motion_x = -1.0;
#line 72 "../src/screen-notification.vala"
	self->priv->last_motion_y = -1.0;
#line 73 "../src/screen-notification.vala"
	self->priv->_pass_through = TRUE;
#line 31 "../src/screen-notification.vala"
	gtk_widget_init_template (GTK_WIDGET (self));
#line 953 "screen-notification.c"
}

static void
pomodoro_screen_notification_finalize (GObject * obj)
{
	PomodoroScreenNotification * self;
#line 31 "../src/screen-notification.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, POMODORO_TYPE_SCREEN_NOTIFICATION, PomodoroScreenNotification);
#line 89 "../src/screen-notification.vala"
	pomodoro_screen_notification_unschedule_close_on_activity (self);
#line 39 "../src/screen-notification.vala"
	_g_object_unref0 (self->priv->idle_monitor);
#line 31 "../src/screen-notification.vala"
	G_OBJECT_CLASS (pomodoro_screen_notification_parent_class)->finalize (obj);
#line 968 "screen-notification.c"
}

/**
     * A fullscreen notification.
     *
     * If idle_monitor is available, window blocks input events after user becomes idle for 600ms.
     * Otherwise, delay blocking until window is shown.
     *
     */
static GType
pomodoro_screen_notification_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (PomodoroScreenNotificationClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) pomodoro_screen_notification_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PomodoroScreenNotification), 0, (GInstanceInitFunc) pomodoro_screen_notification_instance_init, NULL };
	static const GInterfaceInfo gtk_buildable_info = { (GInterfaceInitFunc) pomodoro_screen_notification_gtk_buildable_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	GType pomodoro_screen_notification_type_id;
	pomodoro_screen_notification_type_id = g_type_register_static (gtk_window_get_type (), "PomodoroScreenNotification", &g_define_type_info, 0);
	g_type_add_interface_static (pomodoro_screen_notification_type_id, gtk_buildable_get_type (), &gtk_buildable_info);
	PomodoroScreenNotification_private_offset = g_type_add_instance_private (pomodoro_screen_notification_type_id, sizeof (PomodoroScreenNotificationPrivate));
	return pomodoro_screen_notification_type_id;
}

GType
pomodoro_screen_notification_get_type (void)
{
	static volatile gsize pomodoro_screen_notification_type_id__once = 0;
	if (g_once_init_enter (&pomodoro_screen_notification_type_id__once)) {
		GType pomodoro_screen_notification_type_id;
		pomodoro_screen_notification_type_id = pomodoro_screen_notification_get_type_once ();
		g_once_init_leave (&pomodoro_screen_notification_type_id__once, pomodoro_screen_notification_type_id);
	}
	return pomodoro_screen_notification_type_id__once;
}

static void
_vala_pomodoro_screen_notification_get_property (GObject * object,
                                                 guint property_id,
                                                 GValue * value,
                                                 GParamSpec * pspec)
{
	PomodoroScreenNotification * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, POMODORO_TYPE_SCREEN_NOTIFICATION, PomodoroScreenNotification);
#line 31 "../src/screen-notification.vala"
	switch (property_id) {
#line 1012 "screen-notification.c"
		default:
#line 31 "../src/screen-notification.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 31 "../src/screen-notification.vala"
		break;
#line 1018 "screen-notification.c"
	}
}

static void
_vala_pomodoro_screen_notification_set_property (GObject * object,
                                                 guint property_id,
                                                 const GValue * value,
                                                 GParamSpec * pspec)
{
	PomodoroScreenNotification * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, POMODORO_TYPE_SCREEN_NOTIFICATION, PomodoroScreenNotification);
#line 31 "../src/screen-notification.vala"
	switch (property_id) {
#line 1032 "screen-notification.c"
		default:
#line 31 "../src/screen-notification.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 31 "../src/screen-notification.vala"
		break;
#line 1038 "screen-notification.c"
	}
}

