/* preferences-dialog.c generated by valac 0.56.14, the Vala compiler
 * generated from preferences-dialog.vala, do not modify */

/*
 * Copyright (c) 2013,2014,2016 gnome-pomodoro contributors
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Authors: Kamil Prusko <kamilprusko@gmail.com>
 *
 */
#if !defined VALA_STRICT_C && defined __GNUC__ && __GNUC__ >= 14
#pragma GCC diagnostic warning "-Wimplicit-function-declaration"
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#pragma GCC diagnostic warning "-Wint-conversion"
#pragma GCC diagnostic warning "-Wreturn-mismatch"
#endif

#include <glib.h>
#include <float.h>
#include <math.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gtk/gtk.h>
#include "gnome-pomodoro.h"
#include <gio/gio.h>
#include <glib/gi18n-lib.h>
#include <gdk/gdk.h>
#include <libpeas/peas.h>

#define POMODORO_TIMER_SCALE_LOWER 60.0
#define POMODORO_TIMER_SCALE_UPPER (60.0 * 120.0)
#define POMODORO_LONG_BREAK_INTERVAL_LOWER 1.0
#define POMODORO_LONG_BREAK_INTERVAL_UPPER 10.0
#define POMODORO_PREFERENCES_DIALOG_DEFAULT_WIDTH 600
#define POMODORO_PREFERENCES_DIALOG_DEFAULT_HEIGHT 720

#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define POMODORO_TYPE_ACCELERATOR (pomodoro_accelerator_get_type ())
#define POMODORO_ACCELERATOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), POMODORO_TYPE_ACCELERATOR, PomodoroAccelerator))
#define POMODORO_ACCELERATOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), POMODORO_TYPE_ACCELERATOR, PomodoroAcceleratorClass))
#define POMODORO_IS_ACCELERATOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), POMODORO_TYPE_ACCELERATOR))
#define POMODORO_IS_ACCELERATOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), POMODORO_TYPE_ACCELERATOR))
#define POMODORO_ACCELERATOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), POMODORO_TYPE_ACCELERATOR, PomodoroAcceleratorClass))

typedef struct _PomodoroAccelerator PomodoroAccelerator;
typedef struct _PomodoroAcceleratorClass PomodoroAcceleratorClass;
enum  {
	POMODORO_PREFERENCES_KEYBOARD_SHORTCUT_PAGE_0_PROPERTY,
	POMODORO_PREFERENCES_KEYBOARD_SHORTCUT_PAGE_NUM_PROPERTIES
};
static GParamSpec* pomodoro_preferences_keyboard_shortcut_page_properties[POMODORO_PREFERENCES_KEYBOARD_SHORTCUT_PAGE_NUM_PROPERTIES];

#define POMODORO_TYPE_ACCELERATOR_ERROR (pomodoro_accelerator_error_get_type ())
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
enum  {
	POMODORO_PREFERENCES_PLUGINS_PAGE_0_PROPERTY,
	POMODORO_PREFERENCES_PLUGINS_PAGE_NUM_PROPERTIES
};
static GParamSpec* pomodoro_preferences_plugins_page_properties[POMODORO_PREFERENCES_PLUGINS_PAGE_NUM_PROPERTIES];
#define _g_hash_table_unref0(var) ((var == NULL) ? NULL : (var = (g_hash_table_unref (var), NULL)))
#define __vala_PeasPluginInfo_free0(var) ((var == NULL) ? NULL : (var = (_vala_PeasPluginInfo_free (var), NULL)))
typedef struct _Block8Data Block8Data;
enum  {
	POMODORO_PREFERENCES_MAIN_PAGE_0_PROPERTY,
	POMODORO_PREFERENCES_MAIN_PAGE_NUM_PROPERTIES
};
static GParamSpec* pomodoro_preferences_main_page_properties[POMODORO_PREFERENCES_MAIN_PAGE_NUM_PROPERTIES];
typedef struct _Block9Data Block9Data;
typedef struct _Block10Data Block10Data;
typedef struct _Block11Data Block11Data;
typedef struct _Block12Data Block12Data;
typedef struct _Block13Data Block13Data;

#define POMODORO_PREFERENCES_DIALOG_TYPE_PAGE_META (pomodoro_preferences_dialog_page_meta_get_type ())
typedef struct _PomodoroPreferencesDialogPageMeta PomodoroPreferencesDialogPageMeta;
enum  {
	POMODORO_PREFERENCES_DIALOG_0_PROPERTY,
	POMODORO_PREFERENCES_DIALOG_NUM_PROPERTIES
};
static GParamSpec* pomodoro_preferences_dialog_properties[POMODORO_PREFERENCES_DIALOG_NUM_PROPERTIES];
#define _pomodoro_preferences_dialog_page_meta_free0(var) ((var == NULL) ? NULL : (var = (pomodoro_preferences_dialog_page_meta_free (var), NULL)))
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _PomodoroPreferencesKeyboardShortcutPagePrivate {
	PomodoroAccelerator* _accelerator;
	GtkBox* preview_box;
	GtkButton* disable_button;
	GtkLabel* error_label;
	GSettings* settings;
	gulong key_press_event_id;
	gulong key_release_event_id;
	gulong focus_out_event_id;
};

typedef enum  {
	POMODORO_ACCELERATOR_ERROR_INVALID,
	POMODORO_ACCELERATOR_ERROR_FORBIDDEN,
	POMODORO_ACCELERATOR_ERROR_TYPING_COLLISION
} PomodoroAcceleratorError;
#define POMODORO_ACCELERATOR_ERROR pomodoro_accelerator_error_quark ()

struct _PomodoroPreferencesPluginsPagePrivate {
	GtkListBox* plugins_listbox;
	GSettings* settings;
	PeasEngine* engine;
	GHashTable* toggles;
};

struct _Block8Data {
	int _ref_count_;
	PomodoroPreferencesPluginsPage* self;
	GtkSwitch* toggle;
	PeasPluginInfo* plugin_info;
};

struct _PomodoroPreferencesMainPagePrivate {
	GtkListBoxRow* listboxrow_accelerator;
	GtkListBoxRow* listboxrow_idle_monitor;
	GSettings* settings;
	PomodoroAccelerator* accelerator;
};

struct _Block9Data {
	int _ref_count_;
	PomodoroPreferencesMainPage* self;
	GtkAdjustment* adjustment;
	GtkLabel* label;
};

struct _Block10Data {
	int _ref_count_;
	PomodoroPreferencesMainPage* self;
	GtkLabel* accelerator_label;
};

struct _Block11Data {
	int _ref_count_;
	PomodoroPreferencesMainPage* self;
	GtkListBox* listbox;
};

struct _Block12Data {
	int _ref_count_;
	PomodoroPreferencesMainPage* self;
	gboolean visible;
};

struct _Block13Data {
	int _ref_count_;
	PomodoroPreferencesMainPage* self;
	gboolean visible;
};

struct _PomodoroPreferencesDialogPageMeta {
	GType type;
	gchar* name;
	gchar* title;
};

struct _PomodoroPreferencesDialogPrivate {
	GtkHeaderBar* header_bar;
	GtkStack* stack;
	GtkButton* back_button;
	GHashTable* pages;
	GList* history;
	PeasExtensionSet* extensions;
};

static gint PomodoroPreferencesKeyboardShortcutPage_private_offset;
static gpointer pomodoro_preferences_keyboard_shortcut_page_parent_class = NULL;
static GtkBuildableIface * pomodoro_preferences_keyboard_shortcut_page_gtk_buildable_parent_iface = NULL;
static PomodoroPreferencesPageIface * pomodoro_preferences_keyboard_shortcut_page_pomodoro_preferences_page_parent_iface = NULL;
static gint PomodoroPreferencesPluginsPage_private_offset;
static gpointer pomodoro_preferences_plugins_page_parent_class = NULL;
static GtkBuildableIface * pomodoro_preferences_plugins_page_gtk_buildable_parent_iface = NULL;
static PomodoroPreferencesPageIface * pomodoro_preferences_plugins_page_pomodoro_preferences_page_parent_iface = NULL;
static gint PomodoroPreferencesMainPage_private_offset;
static gpointer pomodoro_preferences_main_page_parent_class = NULL;
static GtkBuildableIface * pomodoro_preferences_main_page_gtk_buildable_parent_iface = NULL;
static PomodoroPreferencesPageIface * pomodoro_preferences_main_page_pomodoro_preferences_page_parent_iface = NULL;
static gint PomodoroPreferencesDialog_private_offset;
static gpointer pomodoro_preferences_dialog_parent_class = NULL;
static PomodoroPreferencesDialog* pomodoro_preferences_dialog_instance;
static PomodoroPreferencesDialog* pomodoro_preferences_dialog_instance = NULL;
static GtkBuildableIface * pomodoro_preferences_dialog_gtk_buildable_parent_iface = NULL;

VALA_EXTERN gboolean pomodoro_get_accelerator_mapping (GValue* value,
                                           GVariant* variant,
                                           void* user_data);
VALA_EXTERN GVariant* pomodoro_set_accelerator_mapping (GValue* value,
                                            const GVariantType* expected_type,
                                            void* user_data);
VALA_EXTERN void pomodoro_list_box_separator_func (GtkListBoxRow* row,
                                       GtkListBoxRow* before);
static GType pomodoro_preferences_dialog_extension_get_type_once (void);
static void pomodoro_preferences_page_real_configure_header_bar (PomodoroPreferencesPage* self,
                                                          GtkHeaderBar* header_bar);
static GType pomodoro_preferences_page_get_type_once (void);
VALA_EXTERN GType pomodoro_accelerator_get_type (void) G_GNUC_CONST ;
static gboolean pomodoro_preferences_keyboard_shortcut_page_validate_accelerator (PomodoroPreferencesKeyboardShortcutPage* self);
static PomodoroAccelerator* pomodoro_preferences_keyboard_shortcut_page_get_accelerator (PomodoroPreferencesKeyboardShortcutPage* self);
VALA_EXTERN GQuark pomodoro_accelerator_error_quark (void);
VALA_EXTERN GType pomodoro_accelerator_error_get_type (void) G_GNUC_CONST ;
VALA_EXTERN void pomodoro_accelerator_validate (PomodoroAccelerator* self,
                                    GError** error);
VALA_EXTERN gchar* pomodoro_accelerator_get_display_name (PomodoroAccelerator* self);
static void pomodoro_preferences_keyboard_shortcut_page_update_preview (PomodoroPreferencesKeyboardShortcutPage* self);
static void __lambda26_ (PomodoroPreferencesKeyboardShortcutPage* self,
                  GtkWidget* child);
static void ___lambda26__gtk_callback (GtkWidget* widget,
                                gpointer self);
VALA_EXTERN gchar** pomodoro_accelerator_get_keys (PomodoroAccelerator* self,
                                       gint* result_length1);
static void pomodoro_preferences_keyboard_shortcut_page_on_disable_clicked (PomodoroPreferencesKeyboardShortcutPage* self);
VALA_EXTERN void pomodoro_accelerator_unset (PomodoroAccelerator* self);
static void _pomodoro_preferences_keyboard_shortcut_page_on_disable_clicked_gtk_button_clicked (GtkButton* _sender,
                                                                                         gpointer self);
static void pomodoro_preferences_keyboard_shortcut_page_on_accelerator_changed (PomodoroPreferencesKeyboardShortcutPage* self);
static gboolean pomodoro_preferences_keyboard_shortcut_page_on_key_press_event (PomodoroPreferencesKeyboardShortcutPage* self,
                                                                         GdkEventKey* event);
VALA_EXTERN void pomodoro_accelerator_set_keyval (PomodoroAccelerator* self,
                                      guint keyval,
                                      GdkModifierType modifiers);
static gboolean pomodoro_preferences_keyboard_shortcut_page_on_key_release_event (PomodoroPreferencesKeyboardShortcutPage* self,
                                                                           GdkEventKey* event);
static gboolean pomodoro_preferences_keyboard_shortcut_page_on_focus_out_event (PomodoroPreferencesKeyboardShortcutPage* self,
                                                                         GdkEventFocus* event);
static void pomodoro_preferences_keyboard_shortcut_page_real_map (GtkWidget* base);
static gboolean _pomodoro_preferences_keyboard_shortcut_page_on_key_press_event_gtk_widget_key_press_event (GtkWidget* _sender,
                                                                                                     GdkEventKey* event,
                                                                                                     gpointer self);
static gboolean _pomodoro_preferences_keyboard_shortcut_page_on_key_release_event_gtk_widget_key_release_event (GtkWidget* _sender,
                                                                                                         GdkEventKey* event,
                                                                                                         gpointer self);
static gboolean _pomodoro_preferences_keyboard_shortcut_page_on_focus_out_event_gtk_widget_focus_out_event (GtkWidget* _sender,
                                                                                                     GdkEventFocus* event,
                                                                                                     gpointer self);
static void pomodoro_preferences_keyboard_shortcut_page_real_unmap (GtkWidget* base);
static void pomodoro_preferences_keyboard_shortcut_page_set_accelerator (PomodoroPreferencesKeyboardShortcutPage* self,
                                                                  PomodoroAccelerator* value);
static GObject * pomodoro_preferences_keyboard_shortcut_page_constructor (GType type,
                                                                   guint n_construct_properties,
                                                                   GObjectConstructParam * construct_properties);
VALA_EXTERN PomodoroAccelerator* pomodoro_accelerator_new (void);
VALA_EXTERN PomodoroAccelerator* pomodoro_accelerator_construct (GType object_type);
static void _pomodoro_preferences_keyboard_shortcut_page_on_accelerator_changed_pomodoro_accelerator_changed (PomodoroAccelerator* _sender,
                                                                                                       gpointer self);
static void pomodoro_preferences_keyboard_shortcut_page_finalize (GObject * obj);
static GType pomodoro_preferences_keyboard_shortcut_page_get_type_once (void);
static void _vala_pomodoro_preferences_keyboard_shortcut_page_get_property (GObject * object,
                                                                     guint property_id,
                                                                     GValue * value,
                                                                     GParamSpec * pspec);
static void _vala_pomodoro_preferences_keyboard_shortcut_page_set_property (GObject * object,
                                                                     guint property_id,
                                                                     const GValue * value,
                                                                     GParamSpec * pspec);
static gint pomodoro_preferences_plugins_page_list_box_sort_func (GtkListBoxRow* row1,
                                                           GtkListBoxRow* row2);
static void pomodoro_preferences_plugins_page_on_settings_changed (PomodoroPreferencesPluginsPage* self,
                                                            GSettings* settings,
                                                            const gchar* key);
static PeasPluginInfo* _vala_PeasPluginInfo_copy (PeasPluginInfo* self);
static gboolean pomodoro_preferences_plugins_page_get_plugin_enabled (PomodoroPreferencesPluginsPage* self,
                                                               const gchar* name);
static void _vala_PeasPluginInfo_free (PeasPluginInfo* self);
static void pomodoro_preferences_plugins_page_set_plugin_enabled (PomodoroPreferencesPluginsPage* self,
                                                           const gchar* name,
                                                           gboolean value);
static void _vala_array_add7 (gchar** * array,
                       gint* length,
                       gint* size,
                       gchar* value);
static void _vala_array_add8 (gchar** * array,
                       gint* length,
                       gint* size,
                       gchar* value);
static GtkListBoxRow* pomodoro_preferences_plugins_page_create_row (PomodoroPreferencesPluginsPage* self,
                                                             PeasPluginInfo* plugin_info);
static Block8Data* block8_data_ref (Block8Data* _data8_);
static void block8_data_unref (void * _userdata_);
static void __lambda24_ (Block8Data* _data8_);
static void ___lambda24__g_object_notify (GObject* _sender,
                                   GParamSpec* pspec,
                                   gpointer self);
static gboolean __lambda25_ (Block8Data* _data8_,
                      gboolean state);
static gboolean ___lambda25__gtk_switch_state_set (GtkSwitch* _sender,
                                            gboolean state,
                                            gpointer self);
static gboolean pomodoro_preferences_plugins_page_is_legacy_plugin (PomodoroPreferencesPluginsPage* self,
                                                             const gchar* plugin_name);
static void pomodoro_preferences_plugins_page_populate (PomodoroPreferencesPluginsPage* self);
static GObject * pomodoro_preferences_plugins_page_constructor (GType type,
                                                         guint n_construct_properties,
                                                         GObjectConstructParam * construct_properties);
static void _pomodoro_preferences_plugins_page_on_settings_changed_g_settings_changed (GSettings* _sender,
                                                                                const gchar* key,
                                                                                gpointer self);
static void _pomodoro_list_box_separator_func_gtk_list_box_update_header_func (GtkListBoxRow* row,
                                                                        GtkListBoxRow* before,
                                                                        gpointer self);
static gint _pomodoro_preferences_plugins_page_list_box_sort_func_gtk_list_box_sort_func (GtkListBoxRow* row1,
                                                                                   GtkListBoxRow* row2,
                                                                                   gpointer self);
static void _g_free0_ (gpointer var);
static void pomodoro_preferences_plugins_page_finalize (GObject * obj);
static GType pomodoro_preferences_plugins_page_get_type_once (void);
static PomodoroWidgetsLogScale* pomodoro_preferences_main_page_setup_time_scale (PomodoroPreferencesMainPage* self,
                                                                          GtkBuilder* builder,
                                                                          const gchar* grid_name,
                                                                          const gchar* label_name);
static Block9Data* block9_data_ref (Block9Data* _data9_);
static void block9_data_unref (void * _userdata_);
static void __lambda16_ (Block9Data* _data9_);
VALA_EXTERN gchar* pomodoro_format_time (gint seconds);
static void ___lambda16__gtk_adjustment_value_changed (GtkAdjustment* _sender,
                                                gpointer self);
static void pomodoro_preferences_main_page_setup_timer_section (PomodoroPreferencesMainPage* self,
                                                         GtkBuilder* builder);
static Block10Data* block10_data_ref (Block10Data* _data10_);
static void block10_data_unref (void * _userdata_);
static void __lambda17_ (Block10Data* _data10_);
static void ___lambda17__pomodoro_accelerator_changed (PomodoroAccelerator* _sender,
                                                gpointer self);
static void pomodoro_preferences_main_page_setup_notifications_section (PomodoroPreferencesMainPage* self,
                                                                 GtkBuilder* builder);
static void pomodoro_preferences_main_page_setup_other_section (PomodoroPreferencesMainPage* self,
                                                         GtkBuilder* builder);
static void pomodoro_preferences_main_page_setup_plugins_section (PomodoroPreferencesMainPage* self,
                                                           GtkBuilder* builder);
static void pomodoro_preferences_main_page_real_parser_finished (GtkBuildable* base,
                                                          GtkBuilder* builder);
static void pomodoro_preferences_main_page_on_row_activated (PomodoroPreferencesMainPage* self,
                                                      GtkListBox* listbox,
                                                      GtkListBoxRow* row);
static void _pomodoro_preferences_main_page_on_row_activated_gtk_list_box_row_activated (GtkListBox* _sender,
                                                                                  GtkListBoxRow* row,
                                                                                  gpointer self);
static void pomodoro_preferences_main_page_update_capabilities (PomodoroPreferencesMainPage* self);
static void pomodoro_preferences_main_page_on_capability_enabled (PomodoroPreferencesMainPage* self,
                                                           const gchar* capability_name);
static void pomodoro_preferences_main_page_on_capability_disabled (PomodoroPreferencesMainPage* self,
                                                            const gchar* capability_name);
static void pomodoro_preferences_main_page_setup_listbox (PomodoroPreferencesMainPage* self,
                                                   GtkListBox* listbox);
static Block11Data* block11_data_ref (Block11Data* _data11_);
static void block11_data_unref (void * _userdata_);
static void __lambda21_ (Block11Data* _data11_,
                  GtkWidget* child);
static void pomodoro_preferences_main_page_on_listbox_add (PomodoroPreferencesMainPage* self,
                                                    GtkWidget* widget,
                                                    GtkWidget* child);
static void ___lambda21__gtk_callback (GtkWidget* widget,
                                gpointer self);
static void _pomodoro_preferences_main_page_on_listbox_add_gtk_container_add (GtkContainer* _sender,
                                                                       GtkWidget* widget,
                                                                       gpointer self);
static void pomodoro_preferences_main_page_on_listbox_remove (PomodoroPreferencesMainPage* self,
                                                       GtkWidget* widget,
                                                       GtkWidget* child);
static void _pomodoro_preferences_main_page_on_listbox_remove_gtk_container_remove (GtkContainer* _sender,
                                                                             GtkWidget* widget,
                                                                             gpointer self);
static void pomodoro_preferences_main_page_on_listboxrow_visible_notify (PomodoroPreferencesMainPage* self,
                                                                  GObject* object,
                                                                  GParamSpec* pspec);
static Block12Data* block12_data_ref (Block12Data* _data12_);
static void block12_data_unref (void * _userdata_);
static void ___lambda22_ (Block12Data* _data12_,
                   GtkWidget* child);
static void ____lambda22__gtk_callback (GtkWidget* widget,
                                 gpointer self);
static void _pomodoro_preferences_main_page_on_listboxrow_visible_notify_g_object_notify (GObject* _sender,
                                                                                   GParamSpec* pspec,
                                                                                   gpointer self);
static Block13Data* block13_data_ref (Block13Data* _data13_);
static void block13_data_unref (void * _userdata_);
static void ___lambda23_ (Block13Data* _data13_,
                   GtkWidget* child);
static void ____lambda23__gtk_callback (GtkWidget* widget,
                                 gpointer self);
static void pomodoro_preferences_main_page_real_dispose (GObject* base);
static void _pomodoro_preferences_main_page_on_capability_enabled_pomodoro_capability_manager_capability_enabled (PomodoroCapabilityManager* _sender,
                                                                                                           const gchar* capability_name,
                                                                                                           gpointer self);
static void _pomodoro_preferences_main_page_on_capability_disabled_pomodoro_capability_manager_capability_disabled (PomodoroCapabilityManager* _sender,
                                                                                                             const gchar* capability_name,
                                                                                                             gpointer self);
static GObject * pomodoro_preferences_main_page_constructor (GType type,
                                                      guint n_construct_properties,
                                                      GObjectConstructParam * construct_properties);
static void pomodoro_preferences_main_page_finalize (GObject * obj);
static GType pomodoro_preferences_main_page_get_type_once (void);
static GType pomodoro_preferences_dialog_page_meta_get_type (void) G_GNUC_CONST  G_GNUC_UNUSED ;
static PomodoroPreferencesDialogPageMeta* pomodoro_preferences_dialog_page_meta_dup (const PomodoroPreferencesDialogPageMeta* self);
static void pomodoro_preferences_dialog_page_meta_free (PomodoroPreferencesDialogPageMeta* self);
static void pomodoro_preferences_dialog_page_meta_copy (const PomodoroPreferencesDialogPageMeta* self,
                                                 PomodoroPreferencesDialogPageMeta* dest);
static void pomodoro_preferences_dialog_page_meta_destroy (PomodoroPreferencesDialogPageMeta* self);
static void pomodoro_preferences_dialog_on_back_activate (PomodoroPreferencesDialog* self,
                                                   GSimpleAction* action,
                                                   GVariant* parameter);
static void _pomodoro_preferences_dialog_on_back_activate_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                     GVariant* parameter,
                                                                                     gpointer self);
static inline void _g_list_free__g_free0_ (GList* self);
static void pomodoro_preferences_dialog_real_parser_finished (GtkBuildable* base,
                                                       GtkBuilder* builder);
static void pomodoro_preferences_dialog_on_page_notify (PomodoroPreferencesDialog* self,
                                                 PomodoroPreferencesPage* page);
static void pomodoro_preferences_dialog_history_push (PomodoroPreferencesDialog* self,
                                               const gchar* name);
static void __lambda15_ (PomodoroPreferencesDialog* self,
                  GtkWidget* child);
static void ___lambda15__gtk_callback (GtkWidget* widget,
                                gpointer self);
static void pomodoro_preferences_dialog_on_visible_child_notify (PomodoroPreferencesDialog* self);
static gchar* pomodoro_preferences_dialog_history_pop (PomodoroPreferencesDialog* self);
static void pomodoro_preferences_dialog_history_clear (PomodoroPreferencesDialog* self);
static GObject * pomodoro_preferences_dialog_constructor (GType type,
                                                   guint n_construct_properties,
                                                   GObjectConstructParam * construct_properties);
static void _pomodoro_preferences_dialog_page_meta_free0_ (gpointer var);
static void _pomodoro_preferences_dialog_on_visible_child_notify_g_object_notify (GObject* _sender,
                                                                           GParamSpec* pspec,
                                                                           gpointer self);
static void pomodoro_preferences_dialog_finalize (GObject * obj);
static GType pomodoro_preferences_dialog_get_type_once (void);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);

VALA_EXTERN const gchar* POMODORO_APPLICATION_LEGACY_PLUGINS[2];
static const GActionEntry POMODORO_PREFERENCES_DIALOG_ACTION_ENTRIES[1] = {{"back", _pomodoro_preferences_dialog_on_back_activate_gsimple_action_activate_callback}};

/**
     * Mapping from settings to accelerator
     */
gboolean
pomodoro_get_accelerator_mapping (GValue* value,
                                  GVariant* variant,
                                  void* user_data)
{
	const gchar** accelerators = NULL;
	gsize _tmp0_ = 0;
	const gchar** _tmp1_;
	gint accelerators_length1;
	gint _accelerators_size_;
	const gchar** _tmp2_;
	gint _tmp2__length1;
	gboolean result;
#line 35 "../src/preferences-dialog.vala"
	g_return_val_if_fail (value != NULL, FALSE);
#line 35 "../src/preferences-dialog.vala"
	g_return_val_if_fail (variant != NULL, FALSE);
#line 39 "../src/preferences-dialog.vala"
	_tmp1_ = g_variant_get_strv (variant, &_tmp0_);
#line 39 "../src/preferences-dialog.vala"
	accelerators = _tmp1_;
#line 39 "../src/preferences-dialog.vala"
	accelerators_length1 = _tmp0_;
#line 39 "../src/preferences-dialog.vala"
	_accelerators_size_ = accelerators_length1;
#line 41 "../src/preferences-dialog.vala"
	_tmp2_ = accelerators;
#line 41 "../src/preferences-dialog.vala"
	_tmp2__length1 = accelerators_length1;
#line 492 "preferences-dialog.c"
	{
		const gchar** accelerator_collection = NULL;
		gint accelerator_collection_length1 = 0;
		gint _accelerator_collection_size_ = 0;
		gint accelerator_it = 0;
#line 41 "../src/preferences-dialog.vala"
		accelerator_collection = _tmp2_;
#line 41 "../src/preferences-dialog.vala"
		accelerator_collection_length1 = _tmp2__length1;
#line 41 "../src/preferences-dialog.vala"
		for (accelerator_it = 0; accelerator_it < accelerator_collection_length1; accelerator_it = accelerator_it + 1) {
#line 504 "preferences-dialog.c"
			const gchar* accelerator = NULL;
#line 41 "../src/preferences-dialog.vala"
			accelerator = accelerator_collection[accelerator_it];
#line 508 "preferences-dialog.c"
			{
				const gchar* _tmp3_;
#line 43 "../src/preferences-dialog.vala"
				_tmp3_ = accelerator;
#line 43 "../src/preferences-dialog.vala"
				g_value_set_string (value, _tmp3_);
#line 45 "../src/preferences-dialog.vala"
				result = TRUE;
#line 45 "../src/preferences-dialog.vala"
				accelerators = (g_free (accelerators), NULL);
#line 45 "../src/preferences-dialog.vala"
				return result;
#line 521 "preferences-dialog.c"
			}
		}
	}
#line 48 "../src/preferences-dialog.vala"
	g_value_set_string (value, "");
#line 50 "../src/preferences-dialog.vala"
	result = TRUE;
#line 50 "../src/preferences-dialog.vala"
	accelerators = (g_free (accelerators), NULL);
#line 50 "../src/preferences-dialog.vala"
	return result;
#line 533 "preferences-dialog.c"
}

/**
     * Mapping from accelerator to settings
     */
GVariant*
pomodoro_set_accelerator_mapping (GValue* value,
                                  const GVariantType* expected_type,
                                  void* user_data)
{
	gchar* accelerator_name = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	GVariant* result;
#line 57 "../src/preferences-dialog.vala"
	g_return_val_if_fail (value != NULL, NULL);
#line 57 "../src/preferences-dialog.vala"
	g_return_val_if_fail (expected_type != NULL, NULL);
#line 61 "../src/preferences-dialog.vala"
	_tmp0_ = g_value_get_string (value);
#line 61 "../src/preferences-dialog.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 61 "../src/preferences-dialog.vala"
	accelerator_name = _tmp1_;
#line 63 "../src/preferences-dialog.vala"
	_tmp2_ = accelerator_name;
#line 63 "../src/preferences-dialog.vala"
	if (g_strcmp0 (_tmp2_, "") == 0) {
#line 563 "preferences-dialog.c"
		gchar** strv = NULL;
		gchar** _tmp3_;
		gint strv_length1;
		gint _strv_size_;
		gchar** _tmp4_;
		gint _tmp4__length1;
		GVariant* _tmp5_;
#line 65 "../src/preferences-dialog.vala"
		_tmp3_ = g_new0 (gchar*, 0 + 1);
#line 65 "../src/preferences-dialog.vala"
		strv = _tmp3_;
#line 65 "../src/preferences-dialog.vala"
		strv_length1 = 0;
#line 65 "../src/preferences-dialog.vala"
		_strv_size_ = strv_length1;
#line 67 "../src/preferences-dialog.vala"
		_tmp4_ = strv;
#line 67 "../src/preferences-dialog.vala"
		_tmp4__length1 = strv_length1;
#line 67 "../src/preferences-dialog.vala"
		_tmp5_ = g_variant_new_strv (_tmp4_, _tmp4__length1);
#line 67 "../src/preferences-dialog.vala"
		g_variant_ref_sink (_tmp5_);
#line 67 "../src/preferences-dialog.vala"
		result = _tmp5_;
#line 67 "../src/preferences-dialog.vala"
		strv = (_vala_array_free (strv, strv_length1, (GDestroyNotify) g_free), NULL);
#line 67 "../src/preferences-dialog.vala"
		_g_free0 (accelerator_name);
#line 67 "../src/preferences-dialog.vala"
		return result;
#line 595 "preferences-dialog.c"
	} else {
		gchar** strv = NULL;
		const gchar* _tmp6_;
		gchar* _tmp7_;
		gchar** _tmp8_;
		gint strv_length1;
		gint _strv_size_;
		gchar** _tmp9_;
		gint _tmp9__length1;
		GVariant* _tmp10_;
#line 70 "../src/preferences-dialog.vala"
		_tmp6_ = accelerator_name;
#line 70 "../src/preferences-dialog.vala"
		_tmp7_ = g_strdup (_tmp6_);
#line 70 "../src/preferences-dialog.vala"
		_tmp8_ = g_new0 (gchar*, 1 + 1);
#line 70 "../src/preferences-dialog.vala"
		_tmp8_[0] = _tmp7_;
#line 70 "../src/preferences-dialog.vala"
		strv = _tmp8_;
#line 70 "../src/preferences-dialog.vala"
		strv_length1 = 1;
#line 70 "../src/preferences-dialog.vala"
		_strv_size_ = strv_length1;
#line 72 "../src/preferences-dialog.vala"
		_tmp9_ = strv;
#line 72 "../src/preferences-dialog.vala"
		_tmp9__length1 = strv_length1;
#line 72 "../src/preferences-dialog.vala"
		_tmp10_ = g_variant_new_strv (_tmp9_, _tmp9__length1);
#line 72 "../src/preferences-dialog.vala"
		g_variant_ref_sink (_tmp10_);
#line 72 "../src/preferences-dialog.vala"
		result = _tmp10_;
#line 72 "../src/preferences-dialog.vala"
		strv = (_vala_array_free (strv, strv_length1, (GDestroyNotify) g_free), NULL);
#line 72 "../src/preferences-dialog.vala"
		_g_free0 (accelerator_name);
#line 72 "../src/preferences-dialog.vala"
		return result;
#line 636 "preferences-dialog.c"
	}
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 80 "../src/preferences-dialog.vala"
	return self ? g_object_ref (self) : NULL;
#line 645 "preferences-dialog.c"
}

void
pomodoro_list_box_separator_func (GtkListBoxRow* row,
                                  GtkListBoxRow* before)
{
#line 76 "../src/preferences-dialog.vala"
	g_return_if_fail (row != NULL);
#line 79 "../src/preferences-dialog.vala"
	if (before != NULL) {
#line 656 "preferences-dialog.c"
		GtkWidget* header = NULL;
		GtkWidget* _tmp0_;
		GtkWidget* _tmp1_;
		GtkWidget* _tmp2_;
#line 80 "../src/preferences-dialog.vala"
		_tmp0_ = gtk_list_box_row_get_header (row);
#line 80 "../src/preferences-dialog.vala"
		_tmp1_ = _g_object_ref0 (_tmp0_);
#line 80 "../src/preferences-dialog.vala"
		header = _tmp1_;
#line 82 "../src/preferences-dialog.vala"
		_tmp2_ = header;
#line 82 "../src/preferences-dialog.vala"
		if (_tmp2_ == NULL) {
#line 671 "preferences-dialog.c"
			GtkSeparator* _tmp3_;
			GtkWidget* _tmp4_;
			GtkWidget* _tmp5_;
#line 83 "../src/preferences-dialog.vala"
			_tmp3_ = (GtkSeparator*) gtk_separator_new (GTK_ORIENTATION_HORIZONTAL);
#line 83 "../src/preferences-dialog.vala"
			g_object_ref_sink (_tmp3_);
#line 83 "../src/preferences-dialog.vala"
			_g_object_unref0 (header);
#line 83 "../src/preferences-dialog.vala"
			header = (GtkWidget*) _tmp3_;
#line 84 "../src/preferences-dialog.vala"
			_tmp4_ = header;
#line 84 "../src/preferences-dialog.vala"
			gtk_widget_show (_tmp4_);
#line 85 "../src/preferences-dialog.vala"
			_tmp5_ = header;
#line 85 "../src/preferences-dialog.vala"
			gtk_list_box_row_set_header (row, _tmp5_);
#line 691 "preferences-dialog.c"
		}
#line 79 "../src/preferences-dialog.vala"
		_g_object_unref0 (header);
#line 695 "preferences-dialog.c"
	}
}

static void
pomodoro_preferences_dialog_extension_default_init (PomodoroPreferencesDialogExtensionIface * iface,
                                                    gpointer iface_data)
{
}

static GType
pomodoro_preferences_dialog_extension_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (PomodoroPreferencesDialogExtensionIface), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) pomodoro_preferences_dialog_extension_default_init, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
	GType pomodoro_preferences_dialog_extension_type_id;
	pomodoro_preferences_dialog_extension_type_id = g_type_register_static (G_TYPE_INTERFACE, "PomodoroPreferencesDialogExtension", &g_define_type_info, 0);
	g_type_interface_add_prerequisite (pomodoro_preferences_dialog_extension_type_id, peas_extension_base_get_type ());
	return pomodoro_preferences_dialog_extension_type_id;
}

GType
pomodoro_preferences_dialog_extension_get_type (void)
{
	static volatile gsize pomodoro_preferences_dialog_extension_type_id__once = 0;
	if (g_once_init_enter (&pomodoro_preferences_dialog_extension_type_id__once)) {
		GType pomodoro_preferences_dialog_extension_type_id;
		pomodoro_preferences_dialog_extension_type_id = pomodoro_preferences_dialog_extension_get_type_once ();
		g_once_init_leave (&pomodoro_preferences_dialog_extension_type_id__once, pomodoro_preferences_dialog_extension_type_id);
	}
	return pomodoro_preferences_dialog_extension_type_id__once;
}

PomodoroPreferencesDialog*
pomodoro_preferences_page_get_preferences_dialog (PomodoroPreferencesPage* self)
{
	GtkWidget* _tmp0_;
	PomodoroPreferencesDialog* result;
#line 98 "../src/preferences-dialog.vala"
	_tmp0_ = gtk_widget_get_toplevel ((GtkWidget*) self);
#line 98 "../src/preferences-dialog.vala"
	result = POMODORO_IS_PREFERENCES_DIALOG (_tmp0_) ? ((PomodoroPreferencesDialog*) _tmp0_) : NULL;
#line 98 "../src/preferences-dialog.vala"
	return result;
#line 738 "preferences-dialog.c"
}

static void
pomodoro_preferences_page_real_configure_header_bar (PomodoroPreferencesPage* self,
                                                     GtkHeaderBar* header_bar)
{
#line 101 "../src/preferences-dialog.vala"
	g_return_if_fail (header_bar != NULL);
#line 747 "preferences-dialog.c"
}

void
pomodoro_preferences_page_configure_header_bar (PomodoroPreferencesPage* self,
                                                GtkHeaderBar* header_bar)
{
	PomodoroPreferencesPageIface* _iface_;
#line 101 "../src/preferences-dialog.vala"
	g_return_if_fail (self != NULL);
#line 101 "../src/preferences-dialog.vala"
	_iface_ = POMODORO_PREFERENCES_PAGE_GET_INTERFACE (self);
#line 101 "../src/preferences-dialog.vala"
	if (_iface_->configure_header_bar) {
#line 101 "../src/preferences-dialog.vala"
		_iface_->configure_header_bar (self, header_bar);
#line 763 "preferences-dialog.c"
	}
}

static void
pomodoro_preferences_page_default_init (PomodoroPreferencesPageIface * iface,
                                        gpointer iface_data)
{
#line 94 "../src/preferences-dialog.vala"
	iface->configure_header_bar = pomodoro_preferences_page_real_configure_header_bar;
#line 773 "preferences-dialog.c"
}

static GType
pomodoro_preferences_page_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (PomodoroPreferencesPageIface), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) pomodoro_preferences_page_default_init, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
	GType pomodoro_preferences_page_type_id;
	pomodoro_preferences_page_type_id = g_type_register_static (G_TYPE_INTERFACE, "PomodoroPreferencesPage", &g_define_type_info, 0);
	g_type_interface_add_prerequisite (pomodoro_preferences_page_type_id, gtk_widget_get_type ());
	return pomodoro_preferences_page_type_id;
}

GType
pomodoro_preferences_page_get_type (void)
{
	static volatile gsize pomodoro_preferences_page_type_id__once = 0;
	if (g_once_init_enter (&pomodoro_preferences_page_type_id__once)) {
		GType pomodoro_preferences_page_type_id;
		pomodoro_preferences_page_type_id = pomodoro_preferences_page_get_type_once ();
		g_once_init_leave (&pomodoro_preferences_page_type_id__once, pomodoro_preferences_page_type_id);
	}
	return pomodoro_preferences_page_type_id__once;
}

static inline gpointer
pomodoro_preferences_keyboard_shortcut_page_get_instance_private (PomodoroPreferencesKeyboardShortcutPage* self)
{
	return G_STRUCT_MEMBER_P (self, PomodoroPreferencesKeyboardShortcutPage_private_offset);
}

static gboolean
pomodoro_preferences_keyboard_shortcut_page_validate_accelerator (PomodoroPreferencesKeyboardShortcutPage* self)
{
	gboolean is_valid = FALSE;
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 143 "../src/preferences-dialog.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 145 "../src/preferences-dialog.vala"
	is_valid = FALSE;
#line 814 "preferences-dialog.c"
	{
		PomodoroAccelerator* _tmp0_;
		GtkLabel* _tmp2_;
#line 148 "../src/preferences-dialog.vala"
		_tmp0_ = self->priv->_accelerator;
#line 148 "../src/preferences-dialog.vala"
		pomodoro_accelerator_validate (_tmp0_, &_inner_error0_);
#line 148 "../src/preferences-dialog.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 824 "preferences-dialog.c"
			gboolean _tmp1_ = FALSE;
#line 148 "../src/preferences-dialog.vala"
			if (_inner_error0_->domain == POMODORO_ACCELERATOR_ERROR) {
#line 828 "preferences-dialog.c"
				goto __catch0_pomodoro_accelerator_error;
			}
#line 148 "../src/preferences-dialog.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 148 "../src/preferences-dialog.vala"
			g_clear_error (&_inner_error0_);
#line 148 "../src/preferences-dialog.vala"
			return _tmp1_;
#line 837 "preferences-dialog.c"
		}
#line 150 "../src/preferences-dialog.vala"
		_tmp2_ = self->priv->error_label;
#line 150 "../src/preferences-dialog.vala"
		gtk_widget_hide ((GtkWidget*) _tmp2_);
#line 152 "../src/preferences-dialog.vala"
		is_valid = TRUE;
#line 845 "preferences-dialog.c"
	}
	goto __finally0;
	__catch0_pomodoro_accelerator_error:
	{
		GError* _error_ = NULL;
		GError* _tmp3_;
#line 147 "../src/preferences-dialog.vala"
		_error_ = _inner_error0_;
#line 147 "../src/preferences-dialog.vala"
		_inner_error0_ = NULL;
#line 156 "../src/preferences-dialog.vala"
		_tmp3_ = _error_;
#line 156 "../src/preferences-dialog.vala"
		if (g_error_matches (_tmp3_, POMODORO_ACCELERATOR_ERROR, POMODORO_ACCELERATOR_ERROR_TYPING_COLLISION)) {
#line 860 "preferences-dialog.c"
			GtkLabel* _tmp4_;
			PomodoroAccelerator* _tmp5_;
			gchar* _tmp6_;
			gchar* _tmp7_;
			gchar* _tmp8_;
			gchar* _tmp9_;
			gchar* _tmp10_;
			GtkLabel* _tmp11_;
#line 158 "../src/preferences-dialog.vala"
			_tmp4_ = self->priv->error_label;
#line 158 "../src/preferences-dialog.vala"
			_tmp5_ = self->priv->_accelerator;
#line 158 "../src/preferences-dialog.vala"
			_tmp6_ = pomodoro_accelerator_get_display_name (_tmp5_);
#line 158 "../src/preferences-dialog.vala"
			_tmp7_ = _tmp6_;
#line 158 "../src/preferences-dialog.vala"
			_tmp8_ = _tmp7_;
#line 158 "../src/preferences-dialog.vala"
			_tmp9_ = g_strdup_printf (_ ("Using \"%s\" as shortcut will interfere with typing. Try adding anothe" \
"r key, such as Control, Alt or Shift."), _tmp8_);
#line 158 "../src/preferences-dialog.vala"
			_tmp10_ = _tmp9_;
#line 158 "../src/preferences-dialog.vala"
			gtk_label_set_label (_tmp4_, _tmp10_);
#line 158 "../src/preferences-dialog.vala"
			_g_free0 (_tmp10_);
#line 158 "../src/preferences-dialog.vala"
			_g_free0 (_tmp8_);
#line 159 "../src/preferences-dialog.vala"
			_tmp11_ = self->priv->error_label;
#line 159 "../src/preferences-dialog.vala"
			gtk_widget_show ((GtkWidget*) _tmp11_);
#line 893 "preferences-dialog.c"
		}
#line 147 "../src/preferences-dialog.vala"
		_g_error_free0 (_error_);
#line 897 "preferences-dialog.c"
	}
	__finally0:
#line 147 "../src/preferences-dialog.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 902 "preferences-dialog.c"
		gboolean _tmp12_ = FALSE;
#line 147 "../src/preferences-dialog.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 147 "../src/preferences-dialog.vala"
		g_clear_error (&_inner_error0_);
#line 147 "../src/preferences-dialog.vala"
		return _tmp12_;
#line 910 "preferences-dialog.c"
	}
#line 163 "../src/preferences-dialog.vala"
	result = is_valid;
#line 163 "../src/preferences-dialog.vala"
	return result;
#line 916 "preferences-dialog.c"
}

static void
__lambda26_ (PomodoroPreferencesKeyboardShortcutPage* self,
             GtkWidget* child)
{
#line 170 "../src/preferences-dialog.vala"
	g_return_if_fail (child != NULL);
#line 171 "../src/preferences-dialog.vala"
	gtk_widget_destroy (child);
#line 927 "preferences-dialog.c"
}

static void
___lambda26__gtk_callback (GtkWidget* widget,
                           gpointer self)
{
#line 170 "../src/preferences-dialog.vala"
	__lambda26_ ((PomodoroPreferencesKeyboardShortcutPage*) self, widget);
#line 936 "preferences-dialog.c"
}

static void
pomodoro_preferences_keyboard_shortcut_page_update_preview (PomodoroPreferencesKeyboardShortcutPage* self)
{
	gint index = 0;
	GtkBox* _tmp0_;
	PomodoroAccelerator* _tmp1_;
	gint _tmp2_ = 0;
	gchar** _tmp3_;
	GtkButton* _tmp16_;
	GtkBox* _tmp17_;
#line 166 "../src/preferences-dialog.vala"
	g_return_if_fail (self != NULL);
#line 168 "../src/preferences-dialog.vala"
	index = 0;
#line 170 "../src/preferences-dialog.vala"
	_tmp0_ = self->priv->preview_box;
#line 170 "../src/preferences-dialog.vala"
	gtk_container_forall ((GtkContainer*) _tmp0_, ___lambda26__gtk_callback, self);
#line 174 "../src/preferences-dialog.vala"
	_tmp1_ = self->priv->_accelerator;
#line 174 "../src/preferences-dialog.vala"
	_tmp3_ = pomodoro_accelerator_get_keys (_tmp1_, &_tmp2_);
#line 961 "preferences-dialog.c"
	{
		gchar** element_collection = NULL;
		gint element_collection_length1 = 0;
		gint _element_collection_size_ = 0;
		gint element_it = 0;
#line 174 "../src/preferences-dialog.vala"
		element_collection = _tmp3_;
#line 174 "../src/preferences-dialog.vala"
		element_collection_length1 = _tmp2_;
#line 174 "../src/preferences-dialog.vala"
		for (element_it = 0; element_it < element_collection_length1; element_it = element_it + 1) {
#line 973 "preferences-dialog.c"
			gchar* _tmp4_;
			gchar* element = NULL;
#line 174 "../src/preferences-dialog.vala"
			_tmp4_ = g_strdup (element_collection[element_it]);
#line 174 "../src/preferences-dialog.vala"
			element = _tmp4_;
#line 980 "preferences-dialog.c"
			{
				GtkLabel* key_label = NULL;
				const gchar* _tmp8_;
				GtkLabel* _tmp9_;
				GtkLabel* _tmp10_;
				GtkLabel* _tmp11_;
				GtkStyleContext* _tmp12_;
				GtkBox* _tmp13_;
				GtkLabel* _tmp14_;
				gint _tmp15_;
#line 176 "../src/preferences-dialog.vala"
				if (index > 0) {
#line 993 "preferences-dialog.c"
					GtkBox* _tmp5_;
					GtkLabel* _tmp6_;
					GtkLabel* _tmp7_;
#line 177 "../src/preferences-dialog.vala"
					_tmp5_ = self->priv->preview_box;
#line 177 "../src/preferences-dialog.vala"
					_tmp6_ = (GtkLabel*) gtk_label_new ("+");
#line 177 "../src/preferences-dialog.vala"
					g_object_ref_sink (_tmp6_);
#line 177 "../src/preferences-dialog.vala"
					_tmp7_ = _tmp6_;
#line 177 "../src/preferences-dialog.vala"
					gtk_box_pack_start (_tmp5_, (GtkWidget*) _tmp7_, FALSE, FALSE, (guint) 0);
#line 177 "../src/preferences-dialog.vala"
					_g_object_unref0 (_tmp7_);
#line 1009 "preferences-dialog.c"
				}
#line 183 "../src/preferences-dialog.vala"
				_tmp8_ = element;
#line 183 "../src/preferences-dialog.vala"
				_tmp9_ = (GtkLabel*) gtk_label_new (_tmp8_);
#line 183 "../src/preferences-dialog.vala"
				g_object_ref_sink (_tmp9_);
#line 183 "../src/preferences-dialog.vala"
				key_label = _tmp9_;
#line 184 "../src/preferences-dialog.vala"
				_tmp10_ = key_label;
#line 184 "../src/preferences-dialog.vala"
				gtk_widget_set_valign ((GtkWidget*) _tmp10_, GTK_ALIGN_CENTER);
#line 185 "../src/preferences-dialog.vala"
				_tmp11_ = key_label;
#line 185 "../src/preferences-dialog.vala"
				_tmp12_ = gtk_widget_get_style_context ((GtkWidget*) _tmp11_);
#line 185 "../src/preferences-dialog.vala"
				gtk_style_context_add_class (_tmp12_, "key");
#line 187 "../src/preferences-dialog.vala"
				_tmp13_ = self->priv->preview_box;
#line 187 "../src/preferences-dialog.vala"
				_tmp14_ = key_label;
#line 187 "../src/preferences-dialog.vala"
				gtk_box_pack_start (_tmp13_, (GtkWidget*) _tmp14_, FALSE, FALSE, (guint) 0);
#line 189 "../src/preferences-dialog.vala"
				_tmp15_ = index;
#line 189 "../src/preferences-dialog.vala"
				index = _tmp15_ + 1;
#line 174 "../src/preferences-dialog.vala"
				_g_object_unref0 (key_label);
#line 174 "../src/preferences-dialog.vala"
				_g_free0 (element);
#line 1043 "preferences-dialog.c"
			}
		}
#line 174 "../src/preferences-dialog.vala"
		element_collection = (_vala_array_free (element_collection, element_collection_length1, (GDestroyNotify) g_free), NULL);
#line 1048 "preferences-dialog.c"
	}
#line 192 "../src/preferences-dialog.vala"
	_tmp16_ = self->priv->disable_button;
#line 192 "../src/preferences-dialog.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp16_, index > 0);
#line 194 "../src/preferences-dialog.vala"
	_tmp17_ = self->priv->preview_box;
#line 194 "../src/preferences-dialog.vala"
	gtk_widget_show_all ((GtkWidget*) _tmp17_);
#line 1058 "preferences-dialog.c"
}

static void
pomodoro_preferences_keyboard_shortcut_page_on_disable_clicked (PomodoroPreferencesKeyboardShortcutPage* self)
{
	PomodoroAccelerator* _tmp0_;
	GSettings* _tmp1_;
#line 198 "../src/preferences-dialog.vala"
	g_return_if_fail (self != NULL);
#line 200 "../src/preferences-dialog.vala"
	_tmp0_ = self->priv->_accelerator;
#line 200 "../src/preferences-dialog.vala"
	pomodoro_accelerator_unset (_tmp0_);
#line 202 "../src/preferences-dialog.vala"
	_tmp1_ = self->priv->settings;
#line 202 "../src/preferences-dialog.vala"
	g_settings_apply (_tmp1_);
#line 1076 "preferences-dialog.c"
}

static void
_pomodoro_preferences_keyboard_shortcut_page_on_disable_clicked_gtk_button_clicked (GtkButton* _sender,
                                                                                    gpointer self)
{
#line 107 "../src/preferences-dialog.vala"
	pomodoro_preferences_keyboard_shortcut_page_on_disable_clicked ((PomodoroPreferencesKeyboardShortcutPage*) self);
#line 1085 "preferences-dialog.c"
}

static void
pomodoro_preferences_keyboard_shortcut_page_on_accelerator_changed (PomodoroPreferencesKeyboardShortcutPage* self)
{
#line 205 "../src/preferences-dialog.vala"
	g_return_if_fail (self != NULL);
#line 207 "../src/preferences-dialog.vala"
	pomodoro_preferences_keyboard_shortcut_page_validate_accelerator (self);
#line 208 "../src/preferences-dialog.vala"
	pomodoro_preferences_keyboard_shortcut_page_update_preview (self);
#line 1097 "preferences-dialog.c"
}

static gboolean
pomodoro_preferences_keyboard_shortcut_page_on_key_press_event (PomodoroPreferencesKeyboardShortcutPage* self,
                                                                GdkEventKey* event)
{
	PomodoroAccelerator* _tmp4_;
	gboolean result;
#line 211 "../src/preferences-dialog.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 211 "../src/preferences-dialog.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 213 "../src/preferences-dialog.vala"
	switch (event->keyval) {
#line 213 "../src/preferences-dialog.vala"
		case GDK_KEY_Tab:
#line 213 "../src/preferences-dialog.vala"
		case GDK_KEY_space:
#line 213 "../src/preferences-dialog.vala"
		case GDK_KEY_Return:
#line 1118 "preferences-dialog.c"
		{
#line 218 "../src/preferences-dialog.vala"
			result = GTK_WIDGET_CLASS (pomodoro_preferences_keyboard_shortcut_page_parent_class)->key_press_event ((GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (self, gtk_box_get_type (), GtkBox), event);
#line 218 "../src/preferences-dialog.vala"
			return result;
#line 1124 "preferences-dialog.c"
		}
#line 213 "../src/preferences-dialog.vala"
		case GDK_KEY_BackSpace:
#line 1128 "preferences-dialog.c"
		{
			GSettings* _tmp0_;
			gboolean _tmp1_;
			gboolean _tmp2_;
#line 221 "../src/preferences-dialog.vala"
			_tmp0_ = self->priv->settings;
#line 221 "../src/preferences-dialog.vala"
			_tmp1_ = g_settings_get_has_unapplied (_tmp0_);
#line 221 "../src/preferences-dialog.vala"
			_tmp2_ = _tmp1_;
#line 221 "../src/preferences-dialog.vala"
			if (!_tmp2_) {
#line 222 "../src/preferences-dialog.vala"
				pomodoro_preferences_keyboard_shortcut_page_on_disable_clicked (self);
#line 1143 "preferences-dialog.c"
			}
#line 225 "../src/preferences-dialog.vala"
			result = TRUE;
#line 225 "../src/preferences-dialog.vala"
			return result;
#line 1149 "preferences-dialog.c"
		}
#line 213 "../src/preferences-dialog.vala"
		case GDK_KEY_Escape:
#line 1153 "preferences-dialog.c"
		{
			GActionGroup* _tmp3_;
#line 228 "../src/preferences-dialog.vala"
			_tmp3_ = gtk_widget_get_action_group ((GtkWidget*) self, "win");
#line 228 "../src/preferences-dialog.vala"
			g_action_group_activate_action (_tmp3_, "back", NULL);
#line 230 "../src/preferences-dialog.vala"
			result = TRUE;
#line 230 "../src/preferences-dialog.vala"
			return result;
#line 1164 "preferences-dialog.c"
		}
		default:
#line 213 "../src/preferences-dialog.vala"
		break;
#line 1169 "preferences-dialog.c"
	}
#line 233 "../src/preferences-dialog.vala"
	_tmp4_ = self->priv->_accelerator;
#line 233 "../src/preferences-dialog.vala"
	pomodoro_accelerator_set_keyval (_tmp4_, event->keyval, event->state);
#line 236 "../src/preferences-dialog.vala"
	result = TRUE;
#line 236 "../src/preferences-dialog.vala"
	return result;
#line 1179 "preferences-dialog.c"
}

static gboolean
pomodoro_preferences_keyboard_shortcut_page_on_key_release_event (PomodoroPreferencesKeyboardShortcutPage* self,
                                                                  GdkEventKey* event)
{
	gboolean _tmp0_ = FALSE;
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 239 "../src/preferences-dialog.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 239 "../src/preferences-dialog.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 241 "../src/preferences-dialog.vala"
	switch (event->keyval) {
#line 241 "../src/preferences-dialog.vala"
		case GDK_KEY_Tab:
#line 241 "../src/preferences-dialog.vala"
		case GDK_KEY_space:
#line 241 "../src/preferences-dialog.vala"
		case GDK_KEY_Return:
#line 241 "../src/preferences-dialog.vala"
		case GDK_KEY_BackSpace:
#line 1203 "preferences-dialog.c"
		{
#line 247 "../src/preferences-dialog.vala"
			result = TRUE;
#line 247 "../src/preferences-dialog.vala"
			return result;
#line 1209 "preferences-dialog.c"
		}
		default:
#line 241 "../src/preferences-dialog.vala"
		break;
#line 1214 "preferences-dialog.c"
	}
#line 250 "../src/preferences-dialog.vala"
	if (event->state == 0) {
#line 250 "../src/preferences-dialog.vala"
		_tmp0_ = TRUE;
#line 1220 "preferences-dialog.c"
	} else {
#line 250 "../src/preferences-dialog.vala"
		_tmp0_ = event->length == 0;
#line 1224 "preferences-dialog.c"
	}
#line 250 "../src/preferences-dialog.vala"
	if (_tmp0_) {
#line 1228 "preferences-dialog.c"
		{
			PomodoroAccelerator* _tmp1_;
			GSettings* _tmp3_;
#line 253 "../src/preferences-dialog.vala"
			_tmp1_ = self->priv->_accelerator;
#line 253 "../src/preferences-dialog.vala"
			pomodoro_accelerator_validate (_tmp1_, &_inner_error0_);
#line 253 "../src/preferences-dialog.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1238 "preferences-dialog.c"
				gboolean _tmp2_ = FALSE;
#line 253 "../src/preferences-dialog.vala"
				if (_inner_error0_->domain == POMODORO_ACCELERATOR_ERROR) {
#line 1242 "preferences-dialog.c"
					goto __catch0_pomodoro_accelerator_error;
				}
#line 253 "../src/preferences-dialog.vala"
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 253 "../src/preferences-dialog.vala"
				g_clear_error (&_inner_error0_);
#line 253 "../src/preferences-dialog.vala"
				return _tmp2_;
#line 1251 "preferences-dialog.c"
			}
#line 255 "../src/preferences-dialog.vala"
			_tmp3_ = self->priv->settings;
#line 255 "../src/preferences-dialog.vala"
			g_settings_apply (_tmp3_);
#line 1257 "preferences-dialog.c"
		}
		goto __finally0;
		__catch0_pomodoro_accelerator_error:
		{
			GSettings* _tmp4_;
#line 252 "../src/preferences-dialog.vala"
			g_clear_error (&_inner_error0_);
#line 259 "../src/preferences-dialog.vala"
			_tmp4_ = self->priv->settings;
#line 259 "../src/preferences-dialog.vala"
			g_settings_revert (_tmp4_);
#line 1269 "preferences-dialog.c"
		}
		__finally0:
#line 252 "../src/preferences-dialog.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1274 "preferences-dialog.c"
			gboolean _tmp5_ = FALSE;
#line 252 "../src/preferences-dialog.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 252 "../src/preferences-dialog.vala"
			g_clear_error (&_inner_error0_);
#line 252 "../src/preferences-dialog.vala"
			return _tmp5_;
#line 1282 "preferences-dialog.c"
		}
	}
#line 263 "../src/preferences-dialog.vala"
	result = TRUE;
#line 263 "../src/preferences-dialog.vala"
	return result;
#line 1289 "preferences-dialog.c"
}

static gboolean
pomodoro_preferences_keyboard_shortcut_page_on_focus_out_event (PomodoroPreferencesKeyboardShortcutPage* self,
                                                                GdkEventFocus* event)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
	GSettings* _tmp2_;
	gboolean result;
#line 266 "../src/preferences-dialog.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 266 "../src/preferences-dialog.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 268 "../src/preferences-dialog.vala"
	_tmp0_ = gtk_widget_get_visible ((GtkWidget*) self);
#line 268 "../src/preferences-dialog.vala"
	_tmp1_ = _tmp0_;
#line 268 "../src/preferences-dialog.vala"
	if (!_tmp1_) {
#line 269 "../src/preferences-dialog.vala"
		result = FALSE;
#line 269 "../src/preferences-dialog.vala"
		return result;
#line 1314 "preferences-dialog.c"
	}
#line 272 "../src/preferences-dialog.vala"
	_tmp2_ = self->priv->settings;
#line 272 "../src/preferences-dialog.vala"
	g_settings_revert (_tmp2_);
#line 274 "../src/preferences-dialog.vala"
	result = TRUE;
#line 274 "../src/preferences-dialog.vala"
	return result;
#line 1324 "preferences-dialog.c"
}

static gboolean
_pomodoro_preferences_keyboard_shortcut_page_on_key_press_event_gtk_widget_key_press_event (GtkWidget* _sender,
                                                                                            GdkEventKey* event,
                                                                                            gpointer self)
{
	gboolean result;
	result = pomodoro_preferences_keyboard_shortcut_page_on_key_press_event ((PomodoroPreferencesKeyboardShortcutPage*) self, event);
#line 284 "../src/preferences-dialog.vala"
	return result;
#line 1336 "preferences-dialog.c"
}

static gboolean
_pomodoro_preferences_keyboard_shortcut_page_on_key_release_event_gtk_widget_key_release_event (GtkWidget* _sender,
                                                                                                GdkEventKey* event,
                                                                                                gpointer self)
{
	gboolean result;
	result = pomodoro_preferences_keyboard_shortcut_page_on_key_release_event ((PomodoroPreferencesKeyboardShortcutPage*) self, event);
#line 288 "../src/preferences-dialog.vala"
	return result;
#line 1348 "preferences-dialog.c"
}

static gboolean
_pomodoro_preferences_keyboard_shortcut_page_on_focus_out_event_gtk_widget_focus_out_event (GtkWidget* _sender,
                                                                                            GdkEventFocus* event,
                                                                                            gpointer self)
{
	gboolean result;
	result = pomodoro_preferences_keyboard_shortcut_page_on_focus_out_event ((PomodoroPreferencesKeyboardShortcutPage*) self, event);
#line 292 "../src/preferences-dialog.vala"
	return result;
#line 1360 "preferences-dialog.c"
}

static void
pomodoro_preferences_keyboard_shortcut_page_real_map (GtkWidget* base)
{
	PomodoroPreferencesKeyboardShortcutPage * self;
	GtkWidget* toplevel = NULL;
	GtkWidget* _tmp0_;
	GtkWidget* _tmp1_;
	PomodoroApplication* application = NULL;
	PomodoroApplication* _tmp8_;
	PomodoroApplication* _tmp9_;
	PomodoroCapabilityManager* _tmp10_;
#line 277 "../src/preferences-dialog.vala"
	self = (PomodoroPreferencesKeyboardShortcutPage*) base;
#line 279 "../src/preferences-dialog.vala"
	GTK_WIDGET_CLASS (pomodoro_preferences_keyboard_shortcut_page_parent_class)->map ((GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (self, gtk_box_get_type (), GtkBox));
#line 281 "../src/preferences-dialog.vala"
	_tmp0_ = gtk_widget_get_toplevel ((GtkWidget*) self);
#line 281 "../src/preferences-dialog.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 281 "../src/preferences-dialog.vala"
	toplevel = _tmp1_;
#line 283 "../src/preferences-dialog.vala"
	if (self->priv->key_press_event_id == ((gulong) 0)) {
#line 1386 "preferences-dialog.c"
		GtkWidget* _tmp2_;
		gulong _tmp3_;
#line 284 "../src/preferences-dialog.vala"
		_tmp2_ = toplevel;
#line 284 "../src/preferences-dialog.vala"
		_tmp3_ = g_signal_connect_object (_tmp2_, "key-press-event", (GCallback) _pomodoro_preferences_keyboard_shortcut_page_on_key_press_event_gtk_widget_key_press_event, self, 0);
#line 284 "../src/preferences-dialog.vala"
		self->priv->key_press_event_id = _tmp3_;
#line 1395 "preferences-dialog.c"
	}
#line 287 "../src/preferences-dialog.vala"
	if (self->priv->key_release_event_id == ((gulong) 0)) {
#line 1399 "preferences-dialog.c"
		GtkWidget* _tmp4_;
		gulong _tmp5_;
#line 288 "../src/preferences-dialog.vala"
		_tmp4_ = toplevel;
#line 288 "../src/preferences-dialog.vala"
		_tmp5_ = g_signal_connect_object (_tmp4_, "key-release-event", (GCallback) _pomodoro_preferences_keyboard_shortcut_page_on_key_release_event_gtk_widget_key_release_event, self, 0);
#line 288 "../src/preferences-dialog.vala"
		self->priv->key_release_event_id = _tmp5_;
#line 1408 "preferences-dialog.c"
	}
#line 291 "../src/preferences-dialog.vala"
	if (self->priv->focus_out_event_id == ((gulong) 0)) {
#line 1412 "preferences-dialog.c"
		GtkWidget* _tmp6_;
		gulong _tmp7_;
#line 292 "../src/preferences-dialog.vala"
		_tmp6_ = toplevel;
#line 292 "../src/preferences-dialog.vala"
		_tmp7_ = g_signal_connect_object (_tmp6_, "focus-out-event", (GCallback) _pomodoro_preferences_keyboard_shortcut_page_on_focus_out_event_gtk_widget_focus_out_event, self, 0);
#line 292 "../src/preferences-dialog.vala"
		self->priv->focus_out_event_id = _tmp7_;
#line 1421 "preferences-dialog.c"
	}
#line 295 "../src/preferences-dialog.vala"
	_tmp8_ = pomodoro_application_get_default ();
#line 295 "../src/preferences-dialog.vala"
	_tmp9_ = _g_object_ref0 (_tmp8_);
#line 295 "../src/preferences-dialog.vala"
	application = _tmp9_;
#line 296 "../src/preferences-dialog.vala"
	_tmp10_ = application->capabilities;
#line 296 "../src/preferences-dialog.vala"
	pomodoro_capability_manager_disable (_tmp10_, "accelerator");
#line 277 "../src/preferences-dialog.vala"
	_g_object_unref0 (application);
#line 277 "../src/preferences-dialog.vala"
	_g_object_unref0 (toplevel);
#line 1437 "preferences-dialog.c"
}

static void
pomodoro_preferences_keyboard_shortcut_page_real_unmap (GtkWidget* base)
{
	PomodoroPreferencesKeyboardShortcutPage * self;
	GtkWidget* toplevel = NULL;
	GtkWidget* _tmp0_;
	GtkWidget* _tmp1_;
	PomodoroApplication* application = NULL;
	PomodoroApplication* _tmp8_;
	PomodoroApplication* _tmp9_;
	PomodoroCapabilityManager* _tmp10_;
#line 299 "../src/preferences-dialog.vala"
	self = (PomodoroPreferencesKeyboardShortcutPage*) base;
#line 301 "../src/preferences-dialog.vala"
	GTK_WIDGET_CLASS (pomodoro_preferences_keyboard_shortcut_page_parent_class)->unmap ((GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (self, gtk_box_get_type (), GtkBox));
#line 303 "../src/preferences-dialog.vala"
	_tmp0_ = gtk_widget_get_toplevel ((GtkWidget*) self);
#line 303 "../src/preferences-dialog.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 303 "../src/preferences-dialog.vala"
	toplevel = _tmp1_;
#line 305 "../src/preferences-dialog.vala"
	if (self->priv->key_press_event_id != ((gulong) 0)) {
#line 1463 "preferences-dialog.c"
		GtkWidget* _tmp2_;
		guint _tmp3_;
#line 306 "../src/preferences-dialog.vala"
		_tmp2_ = toplevel;
#line 306 "../src/preferences-dialog.vala"
		g_signal_parse_name ("key-press-event", gtk_widget_get_type (), &_tmp3_, NULL, FALSE);
#line 306 "../src/preferences-dialog.vala"
		g_signal_handlers_disconnect_matched (_tmp2_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp3_, 0, NULL, (GCallback) _pomodoro_preferences_keyboard_shortcut_page_on_key_press_event_gtk_widget_key_press_event, self);
#line 307 "../src/preferences-dialog.vala"
		self->priv->key_press_event_id = (gulong) 0;
#line 1474 "preferences-dialog.c"
	}
#line 310 "../src/preferences-dialog.vala"
	if (self->priv->key_release_event_id != ((gulong) 0)) {
#line 1478 "preferences-dialog.c"
		GtkWidget* _tmp4_;
		guint _tmp5_;
#line 311 "../src/preferences-dialog.vala"
		_tmp4_ = toplevel;
#line 311 "../src/preferences-dialog.vala"
		g_signal_parse_name ("key-release-event", gtk_widget_get_type (), &_tmp5_, NULL, FALSE);
#line 311 "../src/preferences-dialog.vala"
		g_signal_handlers_disconnect_matched (_tmp4_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp5_, 0, NULL, (GCallback) _pomodoro_preferences_keyboard_shortcut_page_on_key_release_event_gtk_widget_key_release_event, self);
#line 312 "../src/preferences-dialog.vala"
		self->priv->key_release_event_id = (gulong) 0;
#line 1489 "preferences-dialog.c"
	}
#line 315 "../src/preferences-dialog.vala"
	if (self->priv->focus_out_event_id != ((gulong) 0)) {
#line 1493 "preferences-dialog.c"
		GtkWidget* _tmp6_;
		guint _tmp7_;
#line 316 "../src/preferences-dialog.vala"
		_tmp6_ = toplevel;
#line 316 "../src/preferences-dialog.vala"
		g_signal_parse_name ("focus-out-event", gtk_widget_get_type (), &_tmp7_, NULL, FALSE);
#line 316 "../src/preferences-dialog.vala"
		g_signal_handlers_disconnect_matched (_tmp6_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp7_, 0, NULL, (GCallback) _pomodoro_preferences_keyboard_shortcut_page_on_focus_out_event_gtk_widget_focus_out_event, self);
#line 1502 "preferences-dialog.c"
	}
#line 320 "../src/preferences-dialog.vala"
	_tmp8_ = pomodoro_application_get_default ();
#line 320 "../src/preferences-dialog.vala"
	_tmp9_ = _g_object_ref0 (_tmp8_);
#line 320 "../src/preferences-dialog.vala"
	application = _tmp9_;
#line 321 "../src/preferences-dialog.vala"
	_tmp10_ = application->capabilities;
#line 321 "../src/preferences-dialog.vala"
	pomodoro_capability_manager_enable (_tmp10_, "accelerator");
#line 299 "../src/preferences-dialog.vala"
	_g_object_unref0 (application);
#line 299 "../src/preferences-dialog.vala"
	_g_object_unref0 (toplevel);
#line 1518 "preferences-dialog.c"
}

PomodoroPreferencesKeyboardShortcutPage*
pomodoro_preferences_keyboard_shortcut_page_construct (GType object_type)
{
	PomodoroPreferencesKeyboardShortcutPage * self = NULL;
#line 107 "../src/preferences-dialog.vala"
	self = (PomodoroPreferencesKeyboardShortcutPage*) g_object_new (object_type, NULL);
#line 107 "../src/preferences-dialog.vala"
	return self;
#line 1529 "preferences-dialog.c"
}

PomodoroPreferencesKeyboardShortcutPage*
pomodoro_preferences_keyboard_shortcut_page_new (void)
{
#line 107 "../src/preferences-dialog.vala"
	return pomodoro_preferences_keyboard_shortcut_page_construct (POMODORO_TYPE_PREFERENCES_KEYBOARD_SHORTCUT_PAGE);
#line 1537 "preferences-dialog.c"
}

static PomodoroAccelerator*
pomodoro_preferences_keyboard_shortcut_page_get_accelerator (PomodoroPreferencesKeyboardShortcutPage* self)
{
	PomodoroAccelerator* result;
	PomodoroAccelerator* _tmp0_;
#line 109 "../src/preferences-dialog.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 109 "../src/preferences-dialog.vala"
	_tmp0_ = self->priv->_accelerator;
#line 109 "../src/preferences-dialog.vala"
	result = _tmp0_;
#line 109 "../src/preferences-dialog.vala"
	return result;
#line 1553 "preferences-dialog.c"
}

static void
pomodoro_preferences_keyboard_shortcut_page_set_accelerator (PomodoroPreferencesKeyboardShortcutPage* self,
                                                             PomodoroAccelerator* value)
{
	PomodoroAccelerator* _tmp0_;
#line 109 "../src/preferences-dialog.vala"
	g_return_if_fail (self != NULL);
#line 109 "../src/preferences-dialog.vala"
	_tmp0_ = _g_object_ref0 (value);
#line 109 "../src/preferences-dialog.vala"
	_g_object_unref0 (self->priv->_accelerator);
#line 109 "../src/preferences-dialog.vala"
	self->priv->_accelerator = _tmp0_;
#line 1569 "preferences-dialog.c"
}

static void
_pomodoro_preferences_keyboard_shortcut_page_on_accelerator_changed_pomodoro_accelerator_changed (PomodoroAccelerator* _sender,
                                                                                                  gpointer self)
{
#line 126 "../src/preferences-dialog.vala"
	pomodoro_preferences_keyboard_shortcut_page_on_accelerator_changed ((PomodoroPreferencesKeyboardShortcutPage*) self);
#line 1578 "preferences-dialog.c"
}

static GObject *
pomodoro_preferences_keyboard_shortcut_page_constructor (GType type,
                                                         guint n_construct_properties,
                                                         GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	PomodoroPreferencesKeyboardShortcutPage * self;
	PomodoroAccelerator* _tmp0_;
	PomodoroAccelerator* _tmp1_;
	PomodoroAccelerator* _tmp2_;
	GSettings* _tmp3_;
	GSettings* _tmp4_;
	GSettings* _tmp5_;
	GSettings* _tmp6_;
	PomodoroAccelerator* _tmp7_;
#line 123 "../src/preferences-dialog.vala"
	parent_class = G_OBJECT_CLASS (pomodoro_preferences_keyboard_shortcut_page_parent_class);
#line 123 "../src/preferences-dialog.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 123 "../src/preferences-dialog.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, POMODORO_TYPE_PREFERENCES_KEYBOARD_SHORTCUT_PAGE, PomodoroPreferencesKeyboardShortcutPage);
#line 125 "../src/preferences-dialog.vala"
	_tmp0_ = pomodoro_accelerator_new ();
#line 125 "../src/preferences-dialog.vala"
	_tmp1_ = _tmp0_;
#line 125 "../src/preferences-dialog.vala"
	pomodoro_preferences_keyboard_shortcut_page_set_accelerator (self, _tmp1_);
#line 125 "../src/preferences-dialog.vala"
	_g_object_unref0 (_tmp1_);
#line 126 "../src/preferences-dialog.vala"
	_tmp2_ = self->priv->_accelerator;
#line 126 "../src/preferences-dialog.vala"
	g_signal_connect_object (_tmp2_, "changed", (GCallback) _pomodoro_preferences_keyboard_shortcut_page_on_accelerator_changed_pomodoro_accelerator_changed, self, 0);
#line 128 "../src/preferences-dialog.vala"
	_tmp3_ = pomodoro_get_settings ();
#line 128 "../src/preferences-dialog.vala"
	_tmp4_ = g_settings_get_child (_tmp3_, "preferences");
#line 128 "../src/preferences-dialog.vala"
	_g_object_unref0 (self->priv->settings);
#line 128 "../src/preferences-dialog.vala"
	self->priv->settings = _tmp4_;
#line 130 "../src/preferences-dialog.vala"
	_tmp5_ = self->priv->settings;
#line 130 "../src/preferences-dialog.vala"
	g_settings_delay (_tmp5_);
#line 132 "../src/preferences-dialog.vala"
	_tmp6_ = self->priv->settings;
#line 132 "../src/preferences-dialog.vala"
	_tmp7_ = self->priv->_accelerator;
#line 132 "../src/preferences-dialog.vala"
	g_settings_bind_with_mapping (_tmp6_, "toggle-timer-key", (GObject*) _tmp7_, "name", G_SETTINGS_BIND_DEFAULT, (GSettingsBindGetMapping) pomodoro_get_accelerator_mapping, (GSettingsBindSetMapping) pomodoro_set_accelerator_mapping, NULL, NULL);
#line 140 "../src/preferences-dialog.vala"
	pomodoro_preferences_keyboard_shortcut_page_on_accelerator_changed (self);
#line 123 "../src/preferences-dialog.vala"
	return obj;
#line 1637 "preferences-dialog.c"
}

static void
pomodoro_preferences_keyboard_shortcut_page_class_init (PomodoroPreferencesKeyboardShortcutPageClass * klass,
                                                        gpointer klass_data)
{
#line 107 "../src/preferences-dialog.vala"
	pomodoro_preferences_keyboard_shortcut_page_parent_class = g_type_class_peek_parent (klass);
#line 107 "../src/preferences-dialog.vala"
	g_type_class_adjust_private_offset (klass, &PomodoroPreferencesKeyboardShortcutPage_private_offset);
#line 107 "../src/preferences-dialog.vala"
	((GtkWidgetClass *) klass)->map = (void (*) (GtkWidget*)) pomodoro_preferences_keyboard_shortcut_page_real_map;
#line 107 "../src/preferences-dialog.vala"
	((GtkWidgetClass *) klass)->unmap = (void (*) (GtkWidget*)) pomodoro_preferences_keyboard_shortcut_page_real_unmap;
#line 107 "../src/preferences-dialog.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_pomodoro_preferences_keyboard_shortcut_page_get_property;
#line 107 "../src/preferences-dialog.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_pomodoro_preferences_keyboard_shortcut_page_set_property;
#line 107 "../src/preferences-dialog.vala"
	G_OBJECT_CLASS (klass)->constructor = pomodoro_preferences_keyboard_shortcut_page_constructor;
#line 107 "../src/preferences-dialog.vala"
	G_OBJECT_CLASS (klass)->finalize = pomodoro_preferences_keyboard_shortcut_page_finalize;
#line 107 "../src/preferences-dialog.vala"
	gtk_widget_class_set_template_from_resource (GTK_WIDGET_CLASS (klass), "/org/gnome/pomodoro/preferences-keyboard-shortcut-page.ui");
#line 107 "../src/preferences-dialog.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "preview_box", FALSE, PomodoroPreferencesKeyboardShortcutPage_private_offset + G_STRUCT_OFFSET (PomodoroPreferencesKeyboardShortcutPagePrivate, preview_box));
#line 107 "../src/preferences-dialog.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "disable_button", FALSE, PomodoroPreferencesKeyboardShortcutPage_private_offset + G_STRUCT_OFFSET (PomodoroPreferencesKeyboardShortcutPagePrivate, disable_button));
#line 107 "../src/preferences-dialog.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "error_label", FALSE, PomodoroPreferencesKeyboardShortcutPage_private_offset + G_STRUCT_OFFSET (PomodoroPreferencesKeyboardShortcutPagePrivate, error_label));
#line 107 "../src/preferences-dialog.vala"
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "on_disable_clicked", G_CALLBACK(_pomodoro_preferences_keyboard_shortcut_page_on_disable_clicked_gtk_button_clicked));
#line 1670 "preferences-dialog.c"
}

static void
pomodoro_preferences_keyboard_shortcut_page_gtk_buildable_interface_init (GtkBuildableIface * iface,
                                                                          gpointer iface_data)
{
#line 107 "../src/preferences-dialog.vala"
	pomodoro_preferences_keyboard_shortcut_page_gtk_buildable_parent_iface = g_type_interface_peek_parent (iface);
#line 1679 "preferences-dialog.c"
}

static void
pomodoro_preferences_keyboard_shortcut_page_pomodoro_preferences_page_interface_init (PomodoroPreferencesPageIface * iface,
                                                                                      gpointer iface_data)
{
#line 107 "../src/preferences-dialog.vala"
	pomodoro_preferences_keyboard_shortcut_page_pomodoro_preferences_page_parent_iface = g_type_interface_peek_parent (iface);
#line 1688 "preferences-dialog.c"
}

static void
pomodoro_preferences_keyboard_shortcut_page_instance_init (PomodoroPreferencesKeyboardShortcutPage * self,
                                                           gpointer klass)
{
#line 107 "../src/preferences-dialog.vala"
	self->priv = pomodoro_preferences_keyboard_shortcut_page_get_instance_private (self);
#line 119 "../src/preferences-dialog.vala"
	self->priv->key_press_event_id = (gulong) 0;
#line 120 "../src/preferences-dialog.vala"
	self->priv->key_release_event_id = (gulong) 0;
#line 121 "../src/preferences-dialog.vala"
	self->priv->focus_out_event_id = (gulong) 0;
#line 107 "../src/preferences-dialog.vala"
	gtk_widget_init_template (GTK_WIDGET (self));
#line 1705 "preferences-dialog.c"
}

static void
pomodoro_preferences_keyboard_shortcut_page_finalize (GObject * obj)
{
	PomodoroPreferencesKeyboardShortcutPage * self;
#line 107 "../src/preferences-dialog.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, POMODORO_TYPE_PREFERENCES_KEYBOARD_SHORTCUT_PAGE, PomodoroPreferencesKeyboardShortcutPage);
#line 109 "../src/preferences-dialog.vala"
	_g_object_unref0 (self->priv->_accelerator);
#line 118 "../src/preferences-dialog.vala"
	_g_object_unref0 (self->priv->settings);
#line 107 "../src/preferences-dialog.vala"
	G_OBJECT_CLASS (pomodoro_preferences_keyboard_shortcut_page_parent_class)->finalize (obj);
#line 1720 "preferences-dialog.c"
}

static GType
pomodoro_preferences_keyboard_shortcut_page_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (PomodoroPreferencesKeyboardShortcutPageClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) pomodoro_preferences_keyboard_shortcut_page_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PomodoroPreferencesKeyboardShortcutPage), 0, (GInstanceInitFunc) pomodoro_preferences_keyboard_shortcut_page_instance_init, NULL };
	static const GInterfaceInfo gtk_buildable_info = { (GInterfaceInitFunc) pomodoro_preferences_keyboard_shortcut_page_gtk_buildable_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	static const GInterfaceInfo pomodoro_preferences_page_info = { (GInterfaceInitFunc) pomodoro_preferences_keyboard_shortcut_page_pomodoro_preferences_page_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	GType pomodoro_preferences_keyboard_shortcut_page_type_id;
	pomodoro_preferences_keyboard_shortcut_page_type_id = g_type_register_static (gtk_box_get_type (), "PomodoroPreferencesKeyboardShortcutPage", &g_define_type_info, 0);
	g_type_add_interface_static (pomodoro_preferences_keyboard_shortcut_page_type_id, gtk_buildable_get_type (), &gtk_buildable_info);
	g_type_add_interface_static (pomodoro_preferences_keyboard_shortcut_page_type_id, POMODORO_TYPE_PREFERENCES_PAGE, &pomodoro_preferences_page_info);
	PomodoroPreferencesKeyboardShortcutPage_private_offset = g_type_add_instance_private (pomodoro_preferences_keyboard_shortcut_page_type_id, sizeof (PomodoroPreferencesKeyboardShortcutPagePrivate));
	return pomodoro_preferences_keyboard_shortcut_page_type_id;
}

GType
pomodoro_preferences_keyboard_shortcut_page_get_type (void)
{
	static volatile gsize pomodoro_preferences_keyboard_shortcut_page_type_id__once = 0;
	if (g_once_init_enter (&pomodoro_preferences_keyboard_shortcut_page_type_id__once)) {
		GType pomodoro_preferences_keyboard_shortcut_page_type_id;
		pomodoro_preferences_keyboard_shortcut_page_type_id = pomodoro_preferences_keyboard_shortcut_page_get_type_once ();
		g_once_init_leave (&pomodoro_preferences_keyboard_shortcut_page_type_id__once, pomodoro_preferences_keyboard_shortcut_page_type_id);
	}
	return pomodoro_preferences_keyboard_shortcut_page_type_id__once;
}

static void
_vala_pomodoro_preferences_keyboard_shortcut_page_get_property (GObject * object,
                                                                guint property_id,
                                                                GValue * value,
                                                                GParamSpec * pspec)
{
	PomodoroPreferencesKeyboardShortcutPage * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, POMODORO_TYPE_PREFERENCES_KEYBOARD_SHORTCUT_PAGE, PomodoroPreferencesKeyboardShortcutPage);
#line 107 "../src/preferences-dialog.vala"
	switch (property_id) {
#line 1759 "preferences-dialog.c"
		default:
#line 107 "../src/preferences-dialog.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 107 "../src/preferences-dialog.vala"
		break;
#line 1765 "preferences-dialog.c"
	}
}

static void
_vala_pomodoro_preferences_keyboard_shortcut_page_set_property (GObject * object,
                                                                guint property_id,
                                                                const GValue * value,
                                                                GParamSpec * pspec)
{
	PomodoroPreferencesKeyboardShortcutPage * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, POMODORO_TYPE_PREFERENCES_KEYBOARD_SHORTCUT_PAGE, PomodoroPreferencesKeyboardShortcutPage);
#line 107 "../src/preferences-dialog.vala"
	switch (property_id) {
#line 1779 "preferences-dialog.c"
		default:
#line 107 "../src/preferences-dialog.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 107 "../src/preferences-dialog.vala"
		break;
#line 1785 "preferences-dialog.c"
	}
}

static inline gpointer
pomodoro_preferences_plugins_page_get_instance_private (PomodoroPreferencesPluginsPage* self)
{
	return G_STRUCT_MEMBER_P (self, PomodoroPreferencesPluginsPage_private_offset);
}

static gint
pomodoro_preferences_plugins_page_list_box_sort_func (GtkListBoxRow* row1,
                                                      GtkListBoxRow* row2)
{
	gchar* name1 = NULL;
	gconstpointer _tmp0_;
	gchar* _tmp1_;
	gchar* name2 = NULL;
	gconstpointer _tmp2_;
	gchar* _tmp3_;
	GCompareFunc _tmp4_;
	gint result;
#line 351 "../src/preferences-dialog.vala"
	g_return_val_if_fail (row1 != NULL, 0);
#line 351 "../src/preferences-dialog.vala"
	g_return_val_if_fail (row2 != NULL, 0);
#line 354 "../src/preferences-dialog.vala"
	_tmp0_ = g_object_get_data ((GObject*) row1, "name");
#line 354 "../src/preferences-dialog.vala"
	_tmp1_ = g_strdup ((const gchar*) _tmp0_);
#line 354 "../src/preferences-dialog.vala"
	name1 = _tmp1_;
#line 355 "../src/preferences-dialog.vala"
	_tmp2_ = g_object_get_data ((GObject*) row2, "name");
#line 355 "../src/preferences-dialog.vala"
	_tmp3_ = g_strdup ((const gchar*) _tmp2_);
#line 355 "../src/preferences-dialog.vala"
	name2 = _tmp3_;
#line 357 "../src/preferences-dialog.vala"
	_tmp4_ = ((GCompareFunc) g_strcmp0);
#line 357 "../src/preferences-dialog.vala"
	result = _tmp4_ (name1, name2);
#line 357 "../src/preferences-dialog.vala"
	_g_free0 (name2);
#line 357 "../src/preferences-dialog.vala"
	_g_free0 (name1);
#line 357 "../src/preferences-dialog.vala"
	return result;
#line 1833 "preferences-dialog.c"
}

static PeasPluginInfo*
_vala_PeasPluginInfo_copy (PeasPluginInfo* self)
{
#line 363 "../src/preferences-dialog.vala"
	return g_boxed_copy (peas_plugin_info_get_type (), self);
#line 1841 "preferences-dialog.c"
}

static gpointer
__vala_PeasPluginInfo_copy0 (gpointer self)
{
#line 363 "../src/preferences-dialog.vala"
	return self ? _vala_PeasPluginInfo_copy (self) : NULL;
#line 1849 "preferences-dialog.c"
}

static void
_vala_PeasPluginInfo_free (PeasPluginInfo* self)
{
#line 363 "../src/preferences-dialog.vala"
	g_boxed_free (peas_plugin_info_get_type (), self);
#line 1857 "preferences-dialog.c"
}

static void
pomodoro_preferences_plugins_page_on_settings_changed (PomodoroPreferencesPluginsPage* self,
                                                       GSettings* settings,
                                                       const gchar* key)
{
	PeasEngine* _tmp0_;
	GList* _tmp1_;
#line 360 "../src/preferences-dialog.vala"
	g_return_if_fail (self != NULL);
#line 360 "../src/preferences-dialog.vala"
	g_return_if_fail (settings != NULL);
#line 360 "../src/preferences-dialog.vala"
	g_return_if_fail (key != NULL);
#line 363 "../src/preferences-dialog.vala"
	_tmp0_ = self->priv->engine;
#line 363 "../src/preferences-dialog.vala"
	_tmp1_ = peas_engine_get_plugin_list (_tmp0_);
#line 1877 "preferences-dialog.c"
	{
		GList* plugin_info_collection = NULL;
		GList* plugin_info_it = NULL;
#line 363 "../src/preferences-dialog.vala"
		plugin_info_collection = _tmp1_;
#line 363 "../src/preferences-dialog.vala"
		for (plugin_info_it = plugin_info_collection; plugin_info_it != NULL; plugin_info_it = plugin_info_it->next) {
#line 1885 "preferences-dialog.c"
			PeasPluginInfo* _tmp2_;
			PeasPluginInfo* plugin_info = NULL;
#line 363 "../src/preferences-dialog.vala"
			_tmp2_ = __vala_PeasPluginInfo_copy0 ((PeasPluginInfo*) plugin_info_it->data);
#line 363 "../src/preferences-dialog.vala"
			plugin_info = _tmp2_;
#line 1892 "preferences-dialog.c"
			{
				GtkSwitch* toggle = NULL;
				GHashTable* _tmp3_;
				PeasPluginInfo* _tmp4_;
				const gchar* _tmp5_;
				gconstpointer _tmp6_;
				GtkSwitch* _tmp7_;
				gboolean enabled = FALSE;
				GtkSwitch* _tmp8_;
#line 365 "../src/preferences-dialog.vala"
				_tmp3_ = self->priv->toggles;
#line 365 "../src/preferences-dialog.vala"
				_tmp4_ = plugin_info;
#line 365 "../src/preferences-dialog.vala"
				_tmp5_ = peas_plugin_info_get_module_name (_tmp4_);
#line 365 "../src/preferences-dialog.vala"
				_tmp6_ = g_hash_table_lookup (_tmp3_, _tmp5_);
#line 365 "../src/preferences-dialog.vala"
				_tmp7_ = _g_object_ref0 ((GtkSwitch*) _tmp6_);
#line 365 "../src/preferences-dialog.vala"
				toggle = _tmp7_;
#line 366 "../src/preferences-dialog.vala"
				enabled = FALSE;
#line 368 "../src/preferences-dialog.vala"
				_tmp8_ = toggle;
#line 368 "../src/preferences-dialog.vala"
				if (_tmp8_ != NULL) {
#line 1920 "preferences-dialog.c"
					PeasPluginInfo* _tmp9_;
					const gchar* _tmp10_;
					GtkSwitch* _tmp11_;
					gboolean _tmp12_;
					gboolean _tmp13_;
#line 369 "../src/preferences-dialog.vala"
					_tmp9_ = plugin_info;
#line 369 "../src/preferences-dialog.vala"
					_tmp10_ = peas_plugin_info_get_module_name (_tmp9_);
#line 369 "../src/preferences-dialog.vala"
					enabled = pomodoro_preferences_plugins_page_get_plugin_enabled (self, _tmp10_);
#line 371 "../src/preferences-dialog.vala"
					_tmp11_ = toggle;
#line 371 "../src/preferences-dialog.vala"
					_tmp12_ = gtk_switch_get_state (_tmp11_);
#line 371 "../src/preferences-dialog.vala"
					_tmp13_ = _tmp12_;
#line 371 "../src/preferences-dialog.vala"
					if (_tmp13_ != enabled) {
#line 1940 "preferences-dialog.c"
						GtkSwitch* _tmp14_;
#line 372 "../src/preferences-dialog.vala"
						_tmp14_ = toggle;
#line 372 "../src/preferences-dialog.vala"
						gtk_switch_set_state (_tmp14_, enabled);
#line 1946 "preferences-dialog.c"
					}
				}
#line 363 "../src/preferences-dialog.vala"
				_g_object_unref0 (toggle);
#line 363 "../src/preferences-dialog.vala"
				__vala_PeasPluginInfo_free0 (plugin_info);
#line 1953 "preferences-dialog.c"
			}
		}
	}
}

static gboolean
pomodoro_preferences_plugins_page_get_plugin_enabled (PomodoroPreferencesPluginsPage* self,
                                                      const gchar* name)
{
	gchar** enabled_plugins = NULL;
	GSettings* _tmp0_;
	gchar** _tmp1_;
	gchar** _tmp2_;
	gint enabled_plugins_length1;
	gint _enabled_plugins_size_;
	gboolean enabled_in_settings = FALSE;
	gchar** _tmp3_;
	gint _tmp3__length1;
	gboolean result;
#line 378 "../src/preferences-dialog.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 378 "../src/preferences-dialog.vala"
	g_return_val_if_fail (name != NULL, FALSE);
#line 380 "../src/preferences-dialog.vala"
	_tmp0_ = self->priv->settings;
#line 380 "../src/preferences-dialog.vala"
	_tmp2_ = _tmp1_ = g_settings_get_strv (_tmp0_, "enabled-plugins");
#line 380 "../src/preferences-dialog.vala"
	enabled_plugins = _tmp2_;
#line 380 "../src/preferences-dialog.vala"
	enabled_plugins_length1 = _vala_array_length (_tmp1_);
#line 380 "../src/preferences-dialog.vala"
	_enabled_plugins_size_ = enabled_plugins_length1;
#line 381 "../src/preferences-dialog.vala"
	enabled_in_settings = FALSE;
#line 383 "../src/preferences-dialog.vala"
	_tmp3_ = enabled_plugins;
#line 383 "../src/preferences-dialog.vala"
	_tmp3__length1 = enabled_plugins_length1;
#line 1993 "preferences-dialog.c"
	{
		gchar** plugin_name_collection = NULL;
		gint plugin_name_collection_length1 = 0;
		gint _plugin_name_collection_size_ = 0;
		gint plugin_name_it = 0;
#line 383 "../src/preferences-dialog.vala"
		plugin_name_collection = _tmp3_;
#line 383 "../src/preferences-dialog.vala"
		plugin_name_collection_length1 = _tmp3__length1;
#line 383 "../src/preferences-dialog.vala"
		for (plugin_name_it = 0; plugin_name_it < plugin_name_collection_length1; plugin_name_it = plugin_name_it + 1) {
#line 2005 "preferences-dialog.c"
			gchar* _tmp4_;
			gchar* plugin_name = NULL;
#line 383 "../src/preferences-dialog.vala"
			_tmp4_ = g_strdup (plugin_name_collection[plugin_name_it]);
#line 383 "../src/preferences-dialog.vala"
			plugin_name = _tmp4_;
#line 2012 "preferences-dialog.c"
			{
				const gchar* _tmp5_;
#line 384 "../src/preferences-dialog.vala"
				_tmp5_ = plugin_name;
#line 384 "../src/preferences-dialog.vala"
				if (g_strcmp0 (_tmp5_, name) == 0) {
#line 385 "../src/preferences-dialog.vala"
					enabled_in_settings = TRUE;
#line 387 "../src/preferences-dialog.vala"
					_g_free0 (plugin_name);
#line 387 "../src/preferences-dialog.vala"
					break;
#line 2025 "preferences-dialog.c"
				}
#line 383 "../src/preferences-dialog.vala"
				_g_free0 (plugin_name);
#line 2029 "preferences-dialog.c"
			}
		}
	}
#line 391 "../src/preferences-dialog.vala"
	result = enabled_in_settings;
#line 391 "../src/preferences-dialog.vala"
	enabled_plugins = (_vala_array_free (enabled_plugins, enabled_plugins_length1, (GDestroyNotify) g_free), NULL);
#line 391 "../src/preferences-dialog.vala"
	return result;
#line 2039 "preferences-dialog.c"
}

static void
_vala_array_add7 (gchar** * array,
                  gint* length,
                  gint* size,
                  gchar* value)
{
#line 407 "../src/preferences-dialog.vala"
	if ((*length) == (*size)) {
#line 407 "../src/preferences-dialog.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 407 "../src/preferences-dialog.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 2054 "preferences-dialog.c"
	}
#line 407 "../src/preferences-dialog.vala"
	(*array)[(*length)++] = value;
#line 407 "../src/preferences-dialog.vala"
	(*array)[*length] = NULL;
#line 2060 "preferences-dialog.c"
}

static void
_vala_array_add8 (gchar** * array,
                  gint* length,
                  gint* size,
                  gchar* value)
{
#line 412 "../src/preferences-dialog.vala"
	if ((*length) == (*size)) {
#line 412 "../src/preferences-dialog.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 412 "../src/preferences-dialog.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 2075 "preferences-dialog.c"
	}
#line 412 "../src/preferences-dialog.vala"
	(*array)[(*length)++] = value;
#line 412 "../src/preferences-dialog.vala"
	(*array)[*length] = NULL;
#line 2081 "preferences-dialog.c"
}

static void
pomodoro_preferences_plugins_page_set_plugin_enabled (PomodoroPreferencesPluginsPage* self,
                                                      const gchar* name,
                                                      gboolean value)
{
	gchar** enabled_plugins = NULL;
	GSettings* _tmp0_;
	gchar** _tmp1_;
	gchar** _tmp2_;
	gint enabled_plugins_length1;
	gint _enabled_plugins_size_;
	gboolean enabled_in_settings = FALSE;
	gchar** tmp = NULL;
	gchar** _tmp3_;
	gint tmp_length1;
	gint _tmp_size_;
	gchar** _tmp4_;
	gint _tmp4__length1;
#line 394 "../src/preferences-dialog.vala"
	g_return_if_fail (self != NULL);
#line 394 "../src/preferences-dialog.vala"
	g_return_if_fail (name != NULL);
#line 397 "../src/preferences-dialog.vala"
	_tmp0_ = self->priv->settings;
#line 397 "../src/preferences-dialog.vala"
	_tmp2_ = _tmp1_ = g_settings_get_strv (_tmp0_, "enabled-plugins");
#line 397 "../src/preferences-dialog.vala"
	enabled_plugins = _tmp2_;
#line 397 "../src/preferences-dialog.vala"
	enabled_plugins_length1 = _vala_array_length (_tmp1_);
#line 397 "../src/preferences-dialog.vala"
	_enabled_plugins_size_ = enabled_plugins_length1;
#line 398 "../src/preferences-dialog.vala"
	enabled_in_settings = FALSE;
#line 400 "../src/preferences-dialog.vala"
	_tmp3_ = g_new0 (gchar*, 0 + 1);
#line 400 "../src/preferences-dialog.vala"
	tmp = _tmp3_;
#line 400 "../src/preferences-dialog.vala"
	tmp_length1 = 0;
#line 400 "../src/preferences-dialog.vala"
	_tmp_size_ = tmp_length1;
#line 402 "../src/preferences-dialog.vala"
	_tmp4_ = enabled_plugins;
#line 402 "../src/preferences-dialog.vala"
	_tmp4__length1 = enabled_plugins_length1;
#line 2130 "preferences-dialog.c"
	{
		gchar** plugin_name_collection = NULL;
		gint plugin_name_collection_length1 = 0;
		gint _plugin_name_collection_size_ = 0;
		gint plugin_name_it = 0;
#line 402 "../src/preferences-dialog.vala"
		plugin_name_collection = _tmp4_;
#line 402 "../src/preferences-dialog.vala"
		plugin_name_collection_length1 = _tmp4__length1;
#line 402 "../src/preferences-dialog.vala"
		for (plugin_name_it = 0; plugin_name_it < plugin_name_collection_length1; plugin_name_it = plugin_name_it + 1) {
#line 2142 "preferences-dialog.c"
			gchar* _tmp5_;
			gchar* plugin_name = NULL;
#line 402 "../src/preferences-dialog.vala"
			_tmp5_ = g_strdup (plugin_name_collection[plugin_name_it]);
#line 402 "../src/preferences-dialog.vala"
			plugin_name = _tmp5_;
#line 2149 "preferences-dialog.c"
			{
				const gchar* _tmp6_;
#line 403 "../src/preferences-dialog.vala"
				_tmp6_ = plugin_name;
#line 403 "../src/preferences-dialog.vala"
				if (g_strcmp0 (_tmp6_, name) == 0) {
#line 404 "../src/preferences-dialog.vala"
					enabled_in_settings = TRUE;
#line 2158 "preferences-dialog.c"
				} else {
					const gchar* _tmp7_;
					gchar* _tmp8_;
#line 407 "../src/preferences-dialog.vala"
					_tmp7_ = plugin_name;
#line 407 "../src/preferences-dialog.vala"
					_tmp8_ = g_strdup (_tmp7_);
#line 407 "../src/preferences-dialog.vala"
					_vala_array_add7 (&tmp, &tmp_length1, &_tmp_size_, _tmp8_);
#line 2168 "preferences-dialog.c"
				}
#line 402 "../src/preferences-dialog.vala"
				_g_free0 (plugin_name);
#line 2172 "preferences-dialog.c"
			}
		}
	}
#line 411 "../src/preferences-dialog.vala"
	if (value) {
#line 2178 "preferences-dialog.c"
		gchar* _tmp9_;
#line 412 "../src/preferences-dialog.vala"
		_tmp9_ = g_strdup (name);
#line 412 "../src/preferences-dialog.vala"
		_vala_array_add8 (&tmp, &tmp_length1, &_tmp_size_, _tmp9_);
#line 2184 "preferences-dialog.c"
	}
#line 415 "../src/preferences-dialog.vala"
	if (enabled_in_settings != value) {
#line 2188 "preferences-dialog.c"
		GSettings* _tmp10_;
		gchar** _tmp11_;
		gint _tmp11__length1;
#line 416 "../src/preferences-dialog.vala"
		_tmp10_ = self->priv->settings;
#line 416 "../src/preferences-dialog.vala"
		_tmp11_ = tmp;
#line 416 "../src/preferences-dialog.vala"
		_tmp11__length1 = tmp_length1;
#line 416 "../src/preferences-dialog.vala"
		g_settings_set_strv (_tmp10_, "enabled-plugins", _tmp11_);
#line 2200 "preferences-dialog.c"
	}
#line 394 "../src/preferences-dialog.vala"
	tmp = (_vala_array_free (tmp, tmp_length1, (GDestroyNotify) g_free), NULL);
#line 394 "../src/preferences-dialog.vala"
	enabled_plugins = (_vala_array_free (enabled_plugins, enabled_plugins_length1, (GDestroyNotify) g_free), NULL);
#line 2206 "preferences-dialog.c"
}

static Block8Data*
block8_data_ref (Block8Data* _data8_)
{
#line 420 "../src/preferences-dialog.vala"
	g_atomic_int_inc (&_data8_->_ref_count_);
#line 420 "../src/preferences-dialog.vala"
	return _data8_;
#line 2216 "preferences-dialog.c"
}

static void
block8_data_unref (void * _userdata_)
{
	Block8Data* _data8_;
	_data8_ = (Block8Data*) _userdata_;
#line 420 "../src/preferences-dialog.vala"
	if (g_atomic_int_dec_and_test (&_data8_->_ref_count_)) {
#line 2226 "preferences-dialog.c"
		PomodoroPreferencesPluginsPage* self;
#line 420 "../src/preferences-dialog.vala"
		self = _data8_->self;
#line 420 "../src/preferences-dialog.vala"
		_g_object_unref0 (_data8_->toggle);
#line 420 "../src/preferences-dialog.vala"
		__vala_PeasPluginInfo_free0 (_data8_->plugin_info);
#line 420 "../src/preferences-dialog.vala"
		_g_object_unref0 (self);
#line 420 "../src/preferences-dialog.vala"
		g_slice_free (Block8Data, _data8_);
#line 2238 "preferences-dialog.c"
	}
}

static void
__lambda24_ (Block8Data* _data8_)
{
	PomodoroPreferencesPluginsPage* self;
	const gchar* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
#line 434 "../src/preferences-dialog.vala"
	self = _data8_->self;
#line 435 "../src/preferences-dialog.vala"
	_tmp0_ = peas_plugin_info_get_module_name (_data8_->plugin_info);
#line 435 "../src/preferences-dialog.vala"
	_tmp1_ = gtk_switch_get_active (_data8_->toggle);
#line 435 "../src/preferences-dialog.vala"
	_tmp2_ = _tmp1_;
#line 435 "../src/preferences-dialog.vala"
	pomodoro_preferences_plugins_page_set_plugin_enabled (self, _tmp0_, _tmp2_);
#line 2259 "preferences-dialog.c"
}

static void
___lambda24__g_object_notify (GObject* _sender,
                              GParamSpec* pspec,
                              gpointer self)
{
#line 434 "../src/preferences-dialog.vala"
	__lambda24_ (self);
#line 2269 "preferences-dialog.c"
}

static gboolean
__lambda25_ (Block8Data* _data8_,
             gboolean state)
{
	PomodoroPreferencesPluginsPage* self;
	gboolean success = FALSE;
	gboolean result;
#line 437 "../src/preferences-dialog.vala"
	self = _data8_->self;
#line 438 "../src/preferences-dialog.vala"
	success = state == peas_plugin_info_is_loaded (_data8_->plugin_info);
#line 440 "../src/preferences-dialog.vala"
	result = !success;
#line 440 "../src/preferences-dialog.vala"
	return result;
#line 2287 "preferences-dialog.c"
}

static gboolean
___lambda25__gtk_switch_state_set (GtkSwitch* _sender,
                                   gboolean state,
                                   gpointer self)
{
	gboolean result;
	result = __lambda25_ (self, state);
#line 437 "../src/preferences-dialog.vala"
	return result;
#line 2299 "preferences-dialog.c"
}

static GtkListBoxRow*
pomodoro_preferences_plugins_page_create_row (PomodoroPreferencesPluginsPage* self,
                                              PeasPluginInfo* plugin_info)
{
	Block8Data* _data8_;
	PeasPluginInfo* _tmp0_;
	GtkLabel* name_label = NULL;
	const gchar* _tmp1_;
	GtkLabel* _tmp2_;
	GtkStyleContext* _tmp3_;
	GtkLabel* description_label = NULL;
	const gchar* _tmp4_;
	GtkLabel* _tmp5_;
	GtkStyleContext* _tmp6_;
	GtkStyleContext* _tmp7_;
	GtkSwitch* _tmp8_;
	GHashTable* _tmp9_;
	const gchar* _tmp10_;
	gchar* _tmp11_;
	GtkBox* vbox = NULL;
	GtkBox* _tmp12_;
	GtkBox* hbox = NULL;
	GtkBox* _tmp13_;
	GtkListBoxRow* row = NULL;
	GtkListBoxRow* _tmp14_;
	const gchar* _tmp15_;
	gchar* _tmp16_;
	GtkListBoxRow* result;
#line 420 "../src/preferences-dialog.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 420 "../src/preferences-dialog.vala"
	g_return_val_if_fail (plugin_info != NULL, NULL);
#line 420 "../src/preferences-dialog.vala"
	_data8_ = g_slice_new0 (Block8Data);
#line 420 "../src/preferences-dialog.vala"
	_data8_->_ref_count_ = 1;
#line 420 "../src/preferences-dialog.vala"
	_data8_->self = g_object_ref (self);
#line 420 "../src/preferences-dialog.vala"
	_tmp0_ = __vala_PeasPluginInfo_copy0 (plugin_info);
#line 420 "../src/preferences-dialog.vala"
	__vala_PeasPluginInfo_free0 (_data8_->plugin_info);
#line 420 "../src/preferences-dialog.vala"
	_data8_->plugin_info = _tmp0_;
#line 422 "../src/preferences-dialog.vala"
	_tmp1_ = peas_plugin_info_get_name (_data8_->plugin_info);
#line 422 "../src/preferences-dialog.vala"
	_tmp2_ = (GtkLabel*) gtk_label_new (_tmp1_);
#line 422 "../src/preferences-dialog.vala"
	g_object_ref_sink (_tmp2_);
#line 422 "../src/preferences-dialog.vala"
	name_label = _tmp2_;
#line 423 "../src/preferences-dialog.vala"
	_tmp3_ = gtk_widget_get_style_context ((GtkWidget*) name_label);
#line 423 "../src/preferences-dialog.vala"
	gtk_style_context_add_class (_tmp3_, "pomodoro-plugin-name");
#line 424 "../src/preferences-dialog.vala"
	gtk_widget_set_halign ((GtkWidget*) name_label, GTK_ALIGN_START);
#line 426 "../src/preferences-dialog.vala"
	_tmp4_ = peas_plugin_info_get_description (_data8_->plugin_info);
#line 426 "../src/preferences-dialog.vala"
	_tmp5_ = (GtkLabel*) gtk_label_new (_tmp4_);
#line 426 "../src/preferences-dialog.vala"
	g_object_ref_sink (_tmp5_);
#line 426 "../src/preferences-dialog.vala"
	description_label = _tmp5_;
#line 427 "../src/preferences-dialog.vala"
	_tmp6_ = gtk_widget_get_style_context ((GtkWidget*) description_label);
#line 427 "../src/preferences-dialog.vala"
	gtk_style_context_add_class (_tmp6_, "dim-label");
#line 428 "../src/preferences-dialog.vala"
	_tmp7_ = gtk_widget_get_style_context ((GtkWidget*) description_label);
#line 428 "../src/preferences-dialog.vala"
	gtk_style_context_add_class (_tmp7_, "pomodoro-plugin-description");
#line 429 "../src/preferences-dialog.vala"
	gtk_widget_set_halign ((GtkWidget*) description_label, GTK_ALIGN_START);
#line 431 "../src/preferences-dialog.vala"
	_tmp8_ = (GtkSwitch*) gtk_switch_new ();
#line 431 "../src/preferences-dialog.vala"
	g_object_ref_sink (_tmp8_);
#line 431 "../src/preferences-dialog.vala"
	_data8_->toggle = _tmp8_;
#line 432 "../src/preferences-dialog.vala"
	gtk_widget_set_valign ((GtkWidget*) _data8_->toggle, GTK_ALIGN_CENTER);
#line 433 "../src/preferences-dialog.vala"
	gtk_switch_set_state (_data8_->toggle, peas_plugin_info_is_loaded (_data8_->plugin_info));
#line 434 "../src/preferences-dialog.vala"
	g_signal_connect_data ((GObject*) _data8_->toggle, "notify::active", (GCallback) ___lambda24__g_object_notify, block8_data_ref (_data8_), (GClosureNotify) block8_data_unref, 0);
#line 437 "../src/preferences-dialog.vala"
	g_signal_connect_data (_data8_->toggle, "state-set", (GCallback) ___lambda25__gtk_switch_state_set, block8_data_ref (_data8_), (GClosureNotify) block8_data_unref, 0);
#line 443 "../src/preferences-dialog.vala"
	_tmp9_ = self->priv->toggles;
#line 443 "../src/preferences-dialog.vala"
	_tmp10_ = peas_plugin_info_get_module_name (_data8_->plugin_info);
#line 443 "../src/preferences-dialog.vala"
	_tmp11_ = g_strdup (_tmp10_);
#line 443 "../src/preferences-dialog.vala"
	g_hash_table_insert (_tmp9_, _tmp11_, _data8_->toggle);
#line 445 "../src/preferences-dialog.vala"
	_tmp12_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_VERTICAL, 0);
#line 445 "../src/preferences-dialog.vala"
	g_object_ref_sink (_tmp12_);
#line 445 "../src/preferences-dialog.vala"
	vbox = _tmp12_;
#line 446 "../src/preferences-dialog.vala"
	gtk_box_pack_start (vbox, (GtkWidget*) name_label, FALSE, FALSE, (guint) 0);
#line 447 "../src/preferences-dialog.vala"
	gtk_box_pack_start (vbox, (GtkWidget*) description_label, FALSE, FALSE, (guint) 0);
#line 449 "../src/preferences-dialog.vala"
	_tmp13_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_HORIZONTAL, 30);
#line 449 "../src/preferences-dialog.vala"
	g_object_ref_sink (_tmp13_);
#line 449 "../src/preferences-dialog.vala"
	hbox = _tmp13_;
#line 450 "../src/preferences-dialog.vala"
	gtk_box_pack_start (hbox, (GtkWidget*) vbox, TRUE, TRUE, (guint) 0);
#line 451 "../src/preferences-dialog.vala"
	gtk_box_pack_start (hbox, (GtkWidget*) _data8_->toggle, FALSE, TRUE, (guint) 0);
#line 453 "../src/preferences-dialog.vala"
	_tmp14_ = (GtkListBoxRow*) gtk_list_box_row_new ();
#line 453 "../src/preferences-dialog.vala"
	g_object_ref_sink (_tmp14_);
#line 453 "../src/preferences-dialog.vala"
	row = _tmp14_;
#line 454 "../src/preferences-dialog.vala"
	_tmp15_ = peas_plugin_info_get_name (_data8_->plugin_info);
#line 454 "../src/preferences-dialog.vala"
	_tmp16_ = g_strdup (_tmp15_);
#line 454 "../src/preferences-dialog.vala"
	g_object_set_data_full ((GObject*) row, "name", _tmp16_, g_free);
#line 455 "../src/preferences-dialog.vala"
	gtk_list_box_row_set_activatable (row, FALSE);
#line 456 "../src/preferences-dialog.vala"
	gtk_container_add ((GtkContainer*) row, (GtkWidget*) hbox);
#line 457 "../src/preferences-dialog.vala"
	gtk_widget_show_all ((GtkWidget*) row);
#line 459 "../src/preferences-dialog.vala"
	result = row;
#line 459 "../src/preferences-dialog.vala"
	_g_object_unref0 (hbox);
#line 459 "../src/preferences-dialog.vala"
	_g_object_unref0 (vbox);
#line 459 "../src/preferences-dialog.vala"
	_g_object_unref0 (description_label);
#line 459 "../src/preferences-dialog.vala"
	_g_object_unref0 (name_label);
#line 459 "../src/preferences-dialog.vala"
	block8_data_unref (_data8_);
#line 459 "../src/preferences-dialog.vala"
	_data8_ = NULL;
#line 459 "../src/preferences-dialog.vala"
	return result;
#line 2454 "preferences-dialog.c"
}

static gboolean
pomodoro_preferences_plugins_page_is_legacy_plugin (PomodoroPreferencesPluginsPage* self,
                                                    const gchar* plugin_name)
{
	gboolean result;
#line 462 "../src/preferences-dialog.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 462 "../src/preferences-dialog.vala"
	g_return_val_if_fail (plugin_name != NULL, FALSE);
#line 2466 "preferences-dialog.c"
	{
		const gchar** name_collection = NULL;
		gint name_collection_length1 = 0;
		gint _name_collection_size_ = 0;
		gint name_it = 0;
#line 464 "../src/preferences-dialog.vala"
		name_collection = POMODORO_APPLICATION_LEGACY_PLUGINS;
#line 464 "../src/preferences-dialog.vala"
		name_collection_length1 = G_N_ELEMENTS (POMODORO_APPLICATION_LEGACY_PLUGINS);
#line 464 "../src/preferences-dialog.vala"
		for (name_it = 0; name_it < name_collection_length1; name_it = name_it + 1) {
#line 2478 "preferences-dialog.c"
			const gchar* name = NULL;
#line 464 "../src/preferences-dialog.vala"
			name = name_collection[name_it];
#line 2482 "preferences-dialog.c"
			{
				const gchar* _tmp0_;
#line 466 "../src/preferences-dialog.vala"
				_tmp0_ = name;
#line 466 "../src/preferences-dialog.vala"
				if (g_strcmp0 (_tmp0_, plugin_name) == 0) {
#line 467 "../src/preferences-dialog.vala"
					result = TRUE;
#line 467 "../src/preferences-dialog.vala"
					return result;
#line 2493 "preferences-dialog.c"
				}
			}
		}
	}
#line 471 "../src/preferences-dialog.vala"
	result = FALSE;
#line 471 "../src/preferences-dialog.vala"
	return result;
#line 2502 "preferences-dialog.c"
}

static void
pomodoro_preferences_plugins_page_populate (PomodoroPreferencesPluginsPage* self)
{
	PeasEngine* _tmp0_;
	PeasEngine* _tmp1_;
	GList* _tmp2_;
#line 474 "../src/preferences-dialog.vala"
	g_return_if_fail (self != NULL);
#line 476 "../src/preferences-dialog.vala"
	_tmp0_ = self->priv->engine;
#line 476 "../src/preferences-dialog.vala"
	peas_engine_rescan_plugins (_tmp0_);
#line 478 "../src/preferences-dialog.vala"
	_tmp1_ = self->priv->engine;
#line 478 "../src/preferences-dialog.vala"
	_tmp2_ = peas_engine_get_plugin_list (_tmp1_);
#line 2521 "preferences-dialog.c"
	{
		GList* plugin_info_collection = NULL;
		GList* plugin_info_it = NULL;
#line 478 "../src/preferences-dialog.vala"
		plugin_info_collection = _tmp2_;
#line 478 "../src/preferences-dialog.vala"
		for (plugin_info_it = plugin_info_collection; plugin_info_it != NULL; plugin_info_it = plugin_info_it->next) {
#line 2529 "preferences-dialog.c"
			PeasPluginInfo* _tmp3_;
			PeasPluginInfo* plugin_info = NULL;
#line 478 "../src/preferences-dialog.vala"
			_tmp3_ = __vala_PeasPluginInfo_copy0 ((PeasPluginInfo*) plugin_info_it->data);
#line 478 "../src/preferences-dialog.vala"
			plugin_info = _tmp3_;
#line 2536 "preferences-dialog.c"
			{
				PeasPluginInfo* _tmp4_;
				PeasPluginInfo* _tmp5_;
				const gchar* _tmp6_;
				GtkListBoxRow* row = NULL;
				PeasPluginInfo* _tmp7_;
				GtkListBoxRow* _tmp8_;
				GtkListBox* _tmp9_;
				GtkListBoxRow* _tmp10_;
#line 480 "../src/preferences-dialog.vala"
				_tmp4_ = plugin_info;
#line 480 "../src/preferences-dialog.vala"
				if (peas_plugin_info_is_hidden (_tmp4_)) {
#line 481 "../src/preferences-dialog.vala"
					__vala_PeasPluginInfo_free0 (plugin_info);
#line 481 "../src/preferences-dialog.vala"
					continue;
#line 2554 "preferences-dialog.c"
				}
#line 484 "../src/preferences-dialog.vala"
				_tmp5_ = plugin_info;
#line 484 "../src/preferences-dialog.vala"
				_tmp6_ = peas_plugin_info_get_module_name (_tmp5_);
#line 484 "../src/preferences-dialog.vala"
				if (pomodoro_preferences_plugins_page_is_legacy_plugin (self, _tmp6_)) {
#line 485 "../src/preferences-dialog.vala"
					__vala_PeasPluginInfo_free0 (plugin_info);
#line 485 "../src/preferences-dialog.vala"
					continue;
#line 2566 "preferences-dialog.c"
				}
#line 488 "../src/preferences-dialog.vala"
				_tmp7_ = plugin_info;
#line 488 "../src/preferences-dialog.vala"
				_tmp8_ = pomodoro_preferences_plugins_page_create_row (self, _tmp7_);
#line 488 "../src/preferences-dialog.vala"
				row = _tmp8_;
#line 490 "../src/preferences-dialog.vala"
				_tmp9_ = self->priv->plugins_listbox;
#line 490 "../src/preferences-dialog.vala"
				_tmp10_ = row;
#line 490 "../src/preferences-dialog.vala"
				gtk_list_box_insert (_tmp9_, (GtkWidget*) _tmp10_, -1);
#line 478 "../src/preferences-dialog.vala"
				_g_object_unref0 (row);
#line 478 "../src/preferences-dialog.vala"
				__vala_PeasPluginInfo_free0 (plugin_info);
#line 2584 "preferences-dialog.c"
			}
		}
	}
}

PomodoroPreferencesPluginsPage*
pomodoro_preferences_plugins_page_construct (GType object_type)
{
	PomodoroPreferencesPluginsPage * self = NULL;
#line 326 "../src/preferences-dialog.vala"
	self = (PomodoroPreferencesPluginsPage*) g_object_new (object_type, NULL);
#line 326 "../src/preferences-dialog.vala"
	return self;
#line 2598 "preferences-dialog.c"
}

PomodoroPreferencesPluginsPage*
pomodoro_preferences_plugins_page_new (void)
{
#line 326 "../src/preferences-dialog.vala"
	return pomodoro_preferences_plugins_page_construct (POMODORO_TYPE_PREFERENCES_PLUGINS_PAGE);
#line 2606 "preferences-dialog.c"
}

static void
_pomodoro_preferences_plugins_page_on_settings_changed_g_settings_changed (GSettings* _sender,
                                                                           const gchar* key,
                                                                           gpointer self)
{
#line 339 "../src/preferences-dialog.vala"
	pomodoro_preferences_plugins_page_on_settings_changed ((PomodoroPreferencesPluginsPage*) self, _sender, key);
#line 2616 "preferences-dialog.c"
}

static void
_pomodoro_list_box_separator_func_gtk_list_box_update_header_func (GtkListBoxRow* row,
                                                                   GtkListBoxRow* before,
                                                                   gpointer self)
{
#line 343 "../src/preferences-dialog.vala"
	pomodoro_list_box_separator_func (row, before);
#line 2626 "preferences-dialog.c"
}

static gint
_pomodoro_preferences_plugins_page_list_box_sort_func_gtk_list_box_sort_func (GtkListBoxRow* row1,
                                                                              GtkListBoxRow* row2,
                                                                              gpointer self)
{
	gint result;
	result = pomodoro_preferences_plugins_page_list_box_sort_func (row1, row2);
#line 344 "../src/preferences-dialog.vala"
	return result;
#line 2638 "preferences-dialog.c"
}

static void
_g_free0_ (gpointer var)
{
#line 346 "../src/preferences-dialog.vala"
	var = (g_free (var), NULL);
#line 2646 "preferences-dialog.c"
}

static GObject *
pomodoro_preferences_plugins_page_constructor (GType type,
                                               guint n_construct_properties,
                                               GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	PomodoroPreferencesPluginsPage * self;
	GSettings* _tmp0_;
	GSettings* _tmp1_;
	GSettings* _tmp2_;
	PeasEngine* _tmp3_;
	PeasEngine* _tmp4_;
	GtkListBox* _tmp5_;
	GtkListBox* _tmp6_;
	GHashFunc _tmp7_;
	GEqualFunc _tmp8_;
	GHashTable* _tmp9_;
#line 335 "../src/preferences-dialog.vala"
	parent_class = G_OBJECT_CLASS (pomodoro_preferences_plugins_page_parent_class);
#line 335 "../src/preferences-dialog.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 335 "../src/preferences-dialog.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, POMODORO_TYPE_PREFERENCES_PLUGINS_PAGE, PomodoroPreferencesPluginsPage);
#line 337 "../src/preferences-dialog.vala"
	_tmp0_ = pomodoro_get_settings ();
#line 337 "../src/preferences-dialog.vala"
	_tmp1_ = g_settings_get_child (_tmp0_, "preferences");
#line 337 "../src/preferences-dialog.vala"
	_g_object_unref0 (self->priv->settings);
#line 337 "../src/preferences-dialog.vala"
	self->priv->settings = _tmp1_;
#line 339 "../src/preferences-dialog.vala"
	_tmp2_ = self->priv->settings;
#line 339 "../src/preferences-dialog.vala"
	g_signal_connect_object (_tmp2_, "changed::enabled-plugins", (GCallback) _pomodoro_preferences_plugins_page_on_settings_changed_g_settings_changed, self, 0);
#line 341 "../src/preferences-dialog.vala"
	_tmp3_ = peas_engine_get_default ();
#line 341 "../src/preferences-dialog.vala"
	_tmp4_ = _g_object_ref0 (_tmp3_);
#line 341 "../src/preferences-dialog.vala"
	_g_object_unref0 (self->priv->engine);
#line 341 "../src/preferences-dialog.vala"
	self->priv->engine = _tmp4_;
#line 343 "../src/preferences-dialog.vala"
	_tmp5_ = self->priv->plugins_listbox;
#line 343 "../src/preferences-dialog.vala"
	gtk_list_box_set_header_func (_tmp5_, _pomodoro_list_box_separator_func_gtk_list_box_update_header_func, NULL, NULL);
#line 344 "../src/preferences-dialog.vala"
	_tmp6_ = self->priv->plugins_listbox;
#line 344 "../src/preferences-dialog.vala"
	gtk_list_box_set_sort_func (_tmp6_, _pomodoro_preferences_plugins_page_list_box_sort_func_gtk_list_box_sort_func, NULL, NULL);
#line 346 "../src/preferences-dialog.vala"
	_tmp7_ = g_str_hash;
#line 346 "../src/preferences-dialog.vala"
	_tmp8_ = g_str_equal;
#line 346 "../src/preferences-dialog.vala"
	_tmp9_ = g_hash_table_new_full (_tmp7_, _tmp8_, _g_free0_, NULL);
#line 346 "../src/preferences-dialog.vala"
	_g_hash_table_unref0 (self->priv->toggles);
#line 346 "../src/preferences-dialog.vala"
	self->priv->toggles = _tmp9_;
#line 348 "../src/preferences-dialog.vala"
	pomodoro_preferences_plugins_page_populate (self);
#line 335 "../src/preferences-dialog.vala"
	return obj;
#line 2715 "preferences-dialog.c"
}

static void
pomodoro_preferences_plugins_page_class_init (PomodoroPreferencesPluginsPageClass * klass,
                                              gpointer klass_data)
{
#line 326 "../src/preferences-dialog.vala"
	pomodoro_preferences_plugins_page_parent_class = g_type_class_peek_parent (klass);
#line 326 "../src/preferences-dialog.vala"
	g_type_class_adjust_private_offset (klass, &PomodoroPreferencesPluginsPage_private_offset);
#line 326 "../src/preferences-dialog.vala"
	G_OBJECT_CLASS (klass)->constructor = pomodoro_preferences_plugins_page_constructor;
#line 326 "../src/preferences-dialog.vala"
	G_OBJECT_CLASS (klass)->finalize = pomodoro_preferences_plugins_page_finalize;
#line 326 "../src/preferences-dialog.vala"
	gtk_widget_class_set_template_from_resource (GTK_WIDGET_CLASS (klass), "/org/gnome/pomodoro/preferences-plugins-page.ui");
#line 326 "../src/preferences-dialog.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "plugins_listbox", FALSE, PomodoroPreferencesPluginsPage_private_offset + G_STRUCT_OFFSET (PomodoroPreferencesPluginsPagePrivate, plugins_listbox));
#line 2734 "preferences-dialog.c"
}

static void
pomodoro_preferences_plugins_page_gtk_buildable_interface_init (GtkBuildableIface * iface,
                                                                gpointer iface_data)
{
#line 326 "../src/preferences-dialog.vala"
	pomodoro_preferences_plugins_page_gtk_buildable_parent_iface = g_type_interface_peek_parent (iface);
#line 2743 "preferences-dialog.c"
}

static void
pomodoro_preferences_plugins_page_pomodoro_preferences_page_interface_init (PomodoroPreferencesPageIface * iface,
                                                                            gpointer iface_data)
{
#line 326 "../src/preferences-dialog.vala"
	pomodoro_preferences_plugins_page_pomodoro_preferences_page_parent_iface = g_type_interface_peek_parent (iface);
#line 2752 "preferences-dialog.c"
}

static void
pomodoro_preferences_plugins_page_instance_init (PomodoroPreferencesPluginsPage * self,
                                                 gpointer klass)
{
#line 326 "../src/preferences-dialog.vala"
	self->priv = pomodoro_preferences_plugins_page_get_instance_private (self);
#line 326 "../src/preferences-dialog.vala"
	gtk_widget_init_template (GTK_WIDGET (self));
#line 2763 "preferences-dialog.c"
}

static void
pomodoro_preferences_plugins_page_finalize (GObject * obj)
{
	PomodoroPreferencesPluginsPage * self;
#line 326 "../src/preferences-dialog.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, POMODORO_TYPE_PREFERENCES_PLUGINS_PAGE, PomodoroPreferencesPluginsPage);
#line 331 "../src/preferences-dialog.vala"
	_g_object_unref0 (self->priv->settings);
#line 332 "../src/preferences-dialog.vala"
	_g_object_unref0 (self->priv->engine);
#line 333 "../src/preferences-dialog.vala"
	_g_hash_table_unref0 (self->priv->toggles);
#line 326 "../src/preferences-dialog.vala"
	G_OBJECT_CLASS (pomodoro_preferences_plugins_page_parent_class)->finalize (obj);
#line 2780 "preferences-dialog.c"
}

static GType
pomodoro_preferences_plugins_page_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (PomodoroPreferencesPluginsPageClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) pomodoro_preferences_plugins_page_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PomodoroPreferencesPluginsPage), 0, (GInstanceInitFunc) pomodoro_preferences_plugins_page_instance_init, NULL };
	static const GInterfaceInfo gtk_buildable_info = { (GInterfaceInitFunc) pomodoro_preferences_plugins_page_gtk_buildable_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	static const GInterfaceInfo pomodoro_preferences_page_info = { (GInterfaceInitFunc) pomodoro_preferences_plugins_page_pomodoro_preferences_page_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	GType pomodoro_preferences_plugins_page_type_id;
	pomodoro_preferences_plugins_page_type_id = g_type_register_static (gtk_scrolled_window_get_type (), "PomodoroPreferencesPluginsPage", &g_define_type_info, 0);
	g_type_add_interface_static (pomodoro_preferences_plugins_page_type_id, gtk_buildable_get_type (), &gtk_buildable_info);
	g_type_add_interface_static (pomodoro_preferences_plugins_page_type_id, POMODORO_TYPE_PREFERENCES_PAGE, &pomodoro_preferences_page_info);
	PomodoroPreferencesPluginsPage_private_offset = g_type_add_instance_private (pomodoro_preferences_plugins_page_type_id, sizeof (PomodoroPreferencesPluginsPagePrivate));
	return pomodoro_preferences_plugins_page_type_id;
}

GType
pomodoro_preferences_plugins_page_get_type (void)
{
	static volatile gsize pomodoro_preferences_plugins_page_type_id__once = 0;
	if (g_once_init_enter (&pomodoro_preferences_plugins_page_type_id__once)) {
		GType pomodoro_preferences_plugins_page_type_id;
		pomodoro_preferences_plugins_page_type_id = pomodoro_preferences_plugins_page_get_type_once ();
		g_once_init_leave (&pomodoro_preferences_plugins_page_type_id__once, pomodoro_preferences_plugins_page_type_id);
	}
	return pomodoro_preferences_plugins_page_type_id__once;
}

static inline gpointer
pomodoro_preferences_main_page_get_instance_private (PomodoroPreferencesMainPage* self)
{
	return G_STRUCT_MEMBER_P (self, PomodoroPreferencesMainPage_private_offset);
}

static Block9Data*
block9_data_ref (Block9Data* _data9_)
{
#line 536 "../src/preferences-dialog.vala"
	g_atomic_int_inc (&_data9_->_ref_count_);
#line 536 "../src/preferences-dialog.vala"
	return _data9_;
#line 2822 "preferences-dialog.c"
}

static void
block9_data_unref (void * _userdata_)
{
	Block9Data* _data9_;
	_data9_ = (Block9Data*) _userdata_;
#line 536 "../src/preferences-dialog.vala"
	if (g_atomic_int_dec_and_test (&_data9_->_ref_count_)) {
#line 2832 "preferences-dialog.c"
		PomodoroPreferencesMainPage* self;
#line 536 "../src/preferences-dialog.vala"
		self = _data9_->self;
#line 536 "../src/preferences-dialog.vala"
		_g_object_unref0 (_data9_->label);
#line 536 "../src/preferences-dialog.vala"
		_g_object_unref0 (_data9_->adjustment);
#line 536 "../src/preferences-dialog.vala"
		_g_object_unref0 (self);
#line 536 "../src/preferences-dialog.vala"
		g_slice_free (Block9Data, _data9_);
#line 2844 "preferences-dialog.c"
	}
}

static void
__lambda16_ (Block9Data* _data9_)
{
	PomodoroPreferencesMainPage* self;
	gdouble _tmp0_;
	gdouble _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
#line 554 "../src/preferences-dialog.vala"
	self = _data9_->self;
#line 555 "../src/preferences-dialog.vala"
	_tmp0_ = gtk_adjustment_get_value (_data9_->adjustment);
#line 555 "../src/preferences-dialog.vala"
	_tmp1_ = _tmp0_;
#line 555 "../src/preferences-dialog.vala"
	_tmp2_ = pomodoro_format_time ((gint) _tmp1_);
#line 555 "../src/preferences-dialog.vala"
	_tmp3_ = _tmp2_;
#line 555 "../src/preferences-dialog.vala"
	gtk_label_set_text (_data9_->label, _tmp3_);
#line 555 "../src/preferences-dialog.vala"
	_g_free0 (_tmp3_);
#line 2870 "preferences-dialog.c"
}

static void
___lambda16__gtk_adjustment_value_changed (GtkAdjustment* _sender,
                                           gpointer self)
{
#line 554 "../src/preferences-dialog.vala"
	__lambda16_ (self);
#line 2879 "preferences-dialog.c"
}

static PomodoroWidgetsLogScale*
pomodoro_preferences_main_page_setup_time_scale (PomodoroPreferencesMainPage* self,
                                                 GtkBuilder* builder,
                                                 const gchar* grid_name,
                                                 const gchar* label_name)
{
	Block9Data* _data9_;
	GtkAdjustment* _tmp0_;
	PomodoroWidgetsLogScale* scale = NULL;
	PomodoroWidgetsLogScale* _tmp1_;
	GtkGrid* grid = NULL;
	GObject* _tmp2_;
	GtkGrid* _tmp3_;
	GObject* _tmp4_;
	GtkLabel* _tmp5_;
	PomodoroWidgetsLogScale* unowned_scale = NULL;
	PomodoroWidgetsLogScale* result;
#line 536 "../src/preferences-dialog.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 536 "../src/preferences-dialog.vala"
	g_return_val_if_fail (builder != NULL, NULL);
#line 536 "../src/preferences-dialog.vala"
	g_return_val_if_fail (grid_name != NULL, NULL);
#line 536 "../src/preferences-dialog.vala"
	g_return_val_if_fail (label_name != NULL, NULL);
#line 536 "../src/preferences-dialog.vala"
	_data9_ = g_slice_new0 (Block9Data);
#line 536 "../src/preferences-dialog.vala"
	_data9_->_ref_count_ = 1;
#line 536 "../src/preferences-dialog.vala"
	_data9_->self = g_object_ref (self);
#line 540 "../src/preferences-dialog.vala"
	_tmp0_ = gtk_adjustment_new (0.0, POMODORO_TIMER_SCALE_LOWER, POMODORO_TIMER_SCALE_UPPER, 60.0, 300.0, 0.0);
#line 540 "../src/preferences-dialog.vala"
	g_object_ref_sink (_tmp0_);
#line 540 "../src/preferences-dialog.vala"
	_data9_->adjustment = _tmp0_;
#line 547 "../src/preferences-dialog.vala"
	_tmp1_ = pomodoro_widgets_log_scale_new (_data9_->adjustment, 2.0);
#line 547 "../src/preferences-dialog.vala"
	g_object_ref_sink (_tmp1_);
#line 547 "../src/preferences-dialog.vala"
	scale = _tmp1_;
#line 548 "../src/preferences-dialog.vala"
	gtk_widget_show ((GtkWidget*) scale);
#line 550 "../src/preferences-dialog.vala"
	_tmp2_ = gtk_builder_get_object (builder, grid_name);
#line 550 "../src/preferences-dialog.vala"
	_tmp3_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp2_, gtk_grid_get_type ()) ? ((GtkGrid*) _tmp2_) : NULL);
#line 550 "../src/preferences-dialog.vala"
	grid = _tmp3_;
#line 551 "../src/preferences-dialog.vala"
	gtk_grid_attach (grid, (GtkWidget*) scale, 0, 1, 2, 1);
#line 553 "../src/preferences-dialog.vala"
	_tmp4_ = gtk_builder_get_object (builder, label_name);
#line 553 "../src/preferences-dialog.vala"
	_tmp5_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp4_, gtk_label_get_type ()) ? ((GtkLabel*) _tmp4_) : NULL);
#line 553 "../src/preferences-dialog.vala"
	_data9_->label = _tmp5_;
#line 554 "../src/preferences-dialog.vala"
	g_signal_connect_data (_data9_->adjustment, "value-changed", (GCallback) ___lambda16__gtk_adjustment_value_changed, block9_data_ref (_data9_), (GClosureNotify) block9_data_unref, 0);
#line 558 "../src/preferences-dialog.vala"
	gtk_adjustment_value_changed (_data9_->adjustment);
#line 560 "../src/preferences-dialog.vala"
	unowned_scale = scale;
#line 562 "../src/preferences-dialog.vala"
	result = unowned_scale;
#line 562 "../src/preferences-dialog.vala"
	_g_object_unref0 (grid);
#line 562 "../src/preferences-dialog.vala"
	_g_object_unref0 (scale);
#line 562 "../src/preferences-dialog.vala"
	block9_data_unref (_data9_);
#line 562 "../src/preferences-dialog.vala"
	_data9_ = NULL;
#line 562 "../src/preferences-dialog.vala"
	return result;
#line 2959 "preferences-dialog.c"
}

static Block10Data*
block10_data_ref (Block10Data* _data10_)
{
#line 565 "../src/preferences-dialog.vala"
	g_atomic_int_inc (&_data10_->_ref_count_);
#line 565 "../src/preferences-dialog.vala"
	return _data10_;
#line 2969 "preferences-dialog.c"
}

static void
block10_data_unref (void * _userdata_)
{
	Block10Data* _data10_;
	_data10_ = (Block10Data*) _userdata_;
#line 565 "../src/preferences-dialog.vala"
	if (g_atomic_int_dec_and_test (&_data10_->_ref_count_)) {
#line 2979 "preferences-dialog.c"
		PomodoroPreferencesMainPage* self;
#line 565 "../src/preferences-dialog.vala"
		self = _data10_->self;
#line 565 "../src/preferences-dialog.vala"
		_g_object_unref0 (_data10_->accelerator_label);
#line 565 "../src/preferences-dialog.vala"
		_g_object_unref0 (self);
#line 565 "../src/preferences-dialog.vala"
		g_slice_free (Block10Data, _data10_);
#line 2989 "preferences-dialog.c"
	}
}

static void
__lambda17_ (Block10Data* _data10_)
{
	PomodoroPreferencesMainPage* self;
	gchar* _tmp0_ = NULL;
	PomodoroAccelerator* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gboolean _tmp5_;
#line 604 "../src/preferences-dialog.vala"
	self = _data10_->self;
#line 605 "../src/preferences-dialog.vala"
	_tmp1_ = self->priv->accelerator;
#line 605 "../src/preferences-dialog.vala"
	_tmp2_ = pomodoro_accelerator_get_display_name (_tmp1_);
#line 605 "../src/preferences-dialog.vala"
	_tmp3_ = _tmp2_;
#line 605 "../src/preferences-dialog.vala"
	_tmp4_ = _tmp3_;
#line 605 "../src/preferences-dialog.vala"
	_tmp5_ = g_strcmp0 (_tmp4_, "") != 0;
#line 605 "../src/preferences-dialog.vala"
	_g_free0 (_tmp4_);
#line 605 "../src/preferences-dialog.vala"
	if (_tmp5_) {
#line 3019 "preferences-dialog.c"
		PomodoroAccelerator* _tmp6_;
		gchar* _tmp7_;
		gchar* _tmp8_;
#line 606 "../src/preferences-dialog.vala"
		_tmp6_ = self->priv->accelerator;
#line 606 "../src/preferences-dialog.vala"
		_tmp7_ = pomodoro_accelerator_get_display_name (_tmp6_);
#line 606 "../src/preferences-dialog.vala"
		_tmp8_ = _tmp7_;
#line 606 "../src/preferences-dialog.vala"
		_g_free0 (_tmp0_);
#line 606 "../src/preferences-dialog.vala"
		_tmp0_ = _tmp8_;
#line 3033 "preferences-dialog.c"
	} else {
		gchar* _tmp9_;
#line 606 "../src/preferences-dialog.vala"
		_tmp9_ = g_strdup (_ ("Off"));
#line 606 "../src/preferences-dialog.vala"
		_g_free0 (_tmp0_);
#line 606 "../src/preferences-dialog.vala"
		_tmp0_ = _tmp9_;
#line 3042 "preferences-dialog.c"
	}
#line 605 "../src/preferences-dialog.vala"
	gtk_label_set_label (_data10_->accelerator_label, _tmp0_);
#line 604 "../src/preferences-dialog.vala"
	_g_free0 (_tmp0_);
#line 3048 "preferences-dialog.c"
}

static void
___lambda17__pomodoro_accelerator_changed (PomodoroAccelerator* _sender,
                                           gpointer self)
{
#line 604 "../src/preferences-dialog.vala"
	__lambda17_ (self);
#line 3057 "preferences-dialog.c"
}

static void
pomodoro_preferences_main_page_setup_timer_section (PomodoroPreferencesMainPage* self,
                                                    GtkBuilder* builder)
{
	Block10Data* _data10_;
	PomodoroWidgetsLogScale* pomodoro_scale = NULL;
	PomodoroWidgetsLogScale* _tmp0_;
	PomodoroWidgetsLogScale* _tmp1_;
	PomodoroWidgetsLogScale* short_break_scale = NULL;
	PomodoroWidgetsLogScale* _tmp2_;
	PomodoroWidgetsLogScale* _tmp3_;
	PomodoroWidgetsLogScale* long_break_scale = NULL;
	PomodoroWidgetsLogScale* _tmp4_;
	PomodoroWidgetsLogScale* _tmp5_;
	GtkSpinButton* long_break_interval_spinbutton = NULL;
	GObject* _tmp6_;
	GtkSpinButton* _tmp7_;
	GObject* _tmp8_;
	GtkLabel* _tmp9_;
	GSettings* _tmp10_;
	GtkAdjustment* _tmp11_;
	GtkAdjustment* _tmp12_;
	GSettings* _tmp13_;
	GtkAdjustment* _tmp14_;
	GtkAdjustment* _tmp15_;
	GSettings* _tmp16_;
	GtkAdjustment* _tmp17_;
	GtkAdjustment* _tmp18_;
	GSettings* _tmp19_;
	GtkAdjustment* _tmp20_;
	GtkAdjustment* _tmp21_;
	PomodoroAccelerator* _tmp22_;
	PomodoroAccelerator* _tmp23_;
	GSettings* _tmp24_;
	PomodoroAccelerator* _tmp25_;
#line 565 "../src/preferences-dialog.vala"
	g_return_if_fail (self != NULL);
#line 565 "../src/preferences-dialog.vala"
	g_return_if_fail (builder != NULL);
#line 565 "../src/preferences-dialog.vala"
	_data10_ = g_slice_new0 (Block10Data);
#line 565 "../src/preferences-dialog.vala"
	_data10_->_ref_count_ = 1;
#line 565 "../src/preferences-dialog.vala"
	_data10_->self = g_object_ref (self);
#line 567 "../src/preferences-dialog.vala"
	_tmp0_ = pomodoro_preferences_main_page_setup_time_scale (self, builder, "pomodoro_grid", "pomodoro_label");
#line 567 "../src/preferences-dialog.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 567 "../src/preferences-dialog.vala"
	pomodoro_scale = _tmp1_;
#line 571 "../src/preferences-dialog.vala"
	_tmp2_ = pomodoro_preferences_main_page_setup_time_scale (self, builder, "short_break_grid", "short_break_label");
#line 571 "../src/preferences-dialog.vala"
	_tmp3_ = _g_object_ref0 (_tmp2_);
#line 571 "../src/preferences-dialog.vala"
	short_break_scale = _tmp3_;
#line 575 "../src/preferences-dialog.vala"
	_tmp4_ = pomodoro_preferences_main_page_setup_time_scale (self, builder, "long_break_grid", "long_break_label");
#line 575 "../src/preferences-dialog.vala"
	_tmp5_ = _g_object_ref0 (_tmp4_);
#line 575 "../src/preferences-dialog.vala"
	long_break_scale = _tmp5_;
#line 579 "../src/preferences-dialog.vala"
	_tmp6_ = gtk_builder_get_object (builder, "long_break_interval_spinbutton");
#line 579 "../src/preferences-dialog.vala"
	_tmp7_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp6_, gtk_spin_button_get_type ()) ? ((GtkSpinButton*) _tmp6_) : NULL);
#line 579 "../src/preferences-dialog.vala"
	long_break_interval_spinbutton = _tmp7_;
#line 582 "../src/preferences-dialog.vala"
	_tmp8_ = gtk_builder_get_object (builder, "accelerator_label");
#line 582 "../src/preferences-dialog.vala"
	_tmp9_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp8_, gtk_label_get_type ()) ? ((GtkLabel*) _tmp8_) : NULL);
#line 582 "../src/preferences-dialog.vala"
	_data10_->accelerator_label = _tmp9_;
#line 586 "../src/preferences-dialog.vala"
	_tmp10_ = self->priv->settings;
#line 586 "../src/preferences-dialog.vala"
	_tmp11_ = pomodoro_widgets_log_scale_get_base_adjustment (pomodoro_scale);
#line 586 "../src/preferences-dialog.vala"
	_tmp12_ = _tmp11_;
#line 586 "../src/preferences-dialog.vala"
	g_settings_bind (_tmp10_, "pomodoro-duration", (GObject*) _tmp12_, "value", G_SETTINGS_BIND_DEFAULT);
#line 590 "../src/preferences-dialog.vala"
	_tmp13_ = self->priv->settings;
#line 590 "../src/preferences-dialog.vala"
	_tmp14_ = pomodoro_widgets_log_scale_get_base_adjustment (short_break_scale);
#line 590 "../src/preferences-dialog.vala"
	_tmp15_ = _tmp14_;
#line 590 "../src/preferences-dialog.vala"
	g_settings_bind (_tmp13_, "short-break-duration", (GObject*) _tmp15_, "value", G_SETTINGS_BIND_DEFAULT);
#line 594 "../src/preferences-dialog.vala"
	_tmp16_ = self->priv->settings;
#line 594 "../src/preferences-dialog.vala"
	_tmp17_ = pomodoro_widgets_log_scale_get_base_adjustment (long_break_scale);
#line 594 "../src/preferences-dialog.vala"
	_tmp18_ = _tmp17_;
#line 594 "../src/preferences-dialog.vala"
	g_settings_bind (_tmp16_, "long-break-duration", (GObject*) _tmp18_, "value", G_SETTINGS_BIND_DEFAULT);
#line 598 "../src/preferences-dialog.vala"
	_tmp19_ = self->priv->settings;
#line 598 "../src/preferences-dialog.vala"
	_tmp20_ = gtk_spin_button_get_adjustment (long_break_interval_spinbutton);
#line 598 "../src/preferences-dialog.vala"
	_tmp21_ = _tmp20_;
#line 598 "../src/preferences-dialog.vala"
	g_settings_bind (_tmp19_, "long-break-interval", (GObject*) _tmp21_, "value", G_SETTINGS_BIND_DEFAULT);
#line 603 "../src/preferences-dialog.vala"
	_tmp22_ = pomodoro_accelerator_new ();
#line 603 "../src/preferences-dialog.vala"
	_g_object_unref0 (self->priv->accelerator);
#line 603 "../src/preferences-dialog.vala"
	self->priv->accelerator = _tmp22_;
#line 604 "../src/preferences-dialog.vala"
	_tmp23_ = self->priv->accelerator;
#line 604 "../src/preferences-dialog.vala"
	g_signal_connect_data (_tmp23_, "changed", (GCallback) ___lambda17__pomodoro_accelerator_changed, block10_data_ref (_data10_), (GClosureNotify) block10_data_unref, 0);
#line 608 "../src/preferences-dialog.vala"
	_tmp24_ = self->priv->settings;
#line 608 "../src/preferences-dialog.vala"
	_tmp25_ = self->priv->accelerator;
#line 608 "../src/preferences-dialog.vala"
	g_settings_bind_with_mapping (_tmp24_, "toggle-timer-key", (GObject*) _tmp25_, "name", G_SETTINGS_BIND_DEFAULT, (GSettingsBindGetMapping) pomodoro_get_accelerator_mapping, (GSettingsBindSetMapping) pomodoro_set_accelerator_mapping, NULL, NULL);
#line 565 "../src/preferences-dialog.vala"
	_g_object_unref0 (long_break_interval_spinbutton);
#line 565 "../src/preferences-dialog.vala"
	_g_object_unref0 (long_break_scale);
#line 565 "../src/preferences-dialog.vala"
	_g_object_unref0 (short_break_scale);
#line 565 "../src/preferences-dialog.vala"
	_g_object_unref0 (pomodoro_scale);
#line 565 "../src/preferences-dialog.vala"
	block10_data_unref (_data10_);
#line 565 "../src/preferences-dialog.vala"
	_data10_ = NULL;
#line 3195 "preferences-dialog.c"
}

static void
pomodoro_preferences_main_page_setup_notifications_section (PomodoroPreferencesMainPage* self,
                                                            GtkBuilder* builder)
{
	GSettings* _tmp0_;
	GObject* _tmp1_;
#line 619 "../src/preferences-dialog.vala"
	g_return_if_fail (self != NULL);
#line 619 "../src/preferences-dialog.vala"
	g_return_if_fail (builder != NULL);
#line 621 "../src/preferences-dialog.vala"
	_tmp0_ = self->priv->settings;
#line 621 "../src/preferences-dialog.vala"
	_tmp1_ = gtk_builder_get_object (builder, "screen_notifications_toggle");
#line 621 "../src/preferences-dialog.vala"
	g_settings_bind (_tmp0_, "show-screen-notifications", _tmp1_, "active", G_SETTINGS_BIND_DEFAULT);
#line 3214 "preferences-dialog.c"
}

static void
pomodoro_preferences_main_page_setup_other_section (PomodoroPreferencesMainPage* self,
                                                    GtkBuilder* builder)
{
	GtkSwitch* pause_when_idle_toggle = NULL;
	GObject* _tmp0_;
	GtkSwitch* _tmp1_;
	GSettings* _tmp2_;
#line 627 "../src/preferences-dialog.vala"
	g_return_if_fail (self != NULL);
#line 627 "../src/preferences-dialog.vala"
	g_return_if_fail (builder != NULL);
#line 629 "../src/preferences-dialog.vala"
	_tmp0_ = gtk_builder_get_object (builder, "pause_when_idle_toggle");
#line 629 "../src/preferences-dialog.vala"
	_tmp1_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp0_, gtk_switch_get_type ()) ? ((GtkSwitch*) _tmp0_) : NULL);
#line 629 "../src/preferences-dialog.vala"
	pause_when_idle_toggle = _tmp1_;
#line 632 "../src/preferences-dialog.vala"
	_tmp2_ = self->priv->settings;
#line 632 "../src/preferences-dialog.vala"
	g_settings_bind (_tmp2_, "pause-when-idle", (GObject*) pause_when_idle_toggle, "active", G_SETTINGS_BIND_DEFAULT);
#line 627 "../src/preferences-dialog.vala"
	_g_object_unref0 (pause_when_idle_toggle);
#line 3241 "preferences-dialog.c"
}

static void
pomodoro_preferences_main_page_setup_plugins_section (PomodoroPreferencesMainPage* self,
                                                      GtkBuilder* builder)
{
#line 638 "../src/preferences-dialog.vala"
	g_return_if_fail (self != NULL);
#line 638 "../src/preferences-dialog.vala"
	g_return_if_fail (builder != NULL);
#line 3252 "preferences-dialog.c"
}

static void
pomodoro_preferences_main_page_real_parser_finished (GtkBuildable* base,
                                                     GtkBuilder* builder)
{
	PomodoroPreferencesMainPage * self;
	GSettings* _tmp0_;
	GSettings* _tmp1_;
#line 642 "../src/preferences-dialog.vala"
	self = (PomodoroPreferencesMainPage*) base;
#line 642 "../src/preferences-dialog.vala"
	g_return_if_fail (builder != NULL);
#line 644 "../src/preferences-dialog.vala"
	_tmp0_ = pomodoro_get_settings ();
#line 644 "../src/preferences-dialog.vala"
	_tmp1_ = g_settings_get_child (_tmp0_, "preferences");
#line 644 "../src/preferences-dialog.vala"
	_g_object_unref0 (self->priv->settings);
#line 644 "../src/preferences-dialog.vala"
	self->priv->settings = _tmp1_;
#line 647 "../src/preferences-dialog.vala"
	pomodoro_preferences_main_page_gtk_buildable_parent_iface->parser_finished ((GtkBuildable*) G_TYPE_CHECK_INSTANCE_CAST (self, gtk_scrolled_window_get_type (), GtkScrolledWindow), builder);
#line 649 "../src/preferences-dialog.vala"
	pomodoro_preferences_main_page_setup_timer_section (self, builder);
#line 650 "../src/preferences-dialog.vala"
	pomodoro_preferences_main_page_setup_notifications_section (self, builder);
#line 651 "../src/preferences-dialog.vala"
	pomodoro_preferences_main_page_setup_other_section (self, builder);
#line 652 "../src/preferences-dialog.vala"
	pomodoro_preferences_main_page_setup_plugins_section (self, builder);
#line 3284 "preferences-dialog.c"
}

static void
pomodoro_preferences_main_page_on_row_activated (PomodoroPreferencesMainPage* self,
                                                 GtkListBox* listbox,
                                                 GtkListBoxRow* row)
{
	PomodoroPreferencesDialog* preferences_dialog = NULL;
	PomodoroPreferencesDialog* _tmp0_;
	PomodoroPreferencesDialog* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
	GQuark _tmp6_ = 0U;
#line 661 "../src/preferences-dialog.vala"
	static GQuark _tmp5_label0 = 0;
#line 661 "../src/preferences-dialog.vala"
	static GQuark _tmp5_label1 = 0;
#line 656 "../src/preferences-dialog.vala"
	g_return_if_fail (self != NULL);
#line 656 "../src/preferences-dialog.vala"
	g_return_if_fail (listbox != NULL);
#line 656 "../src/preferences-dialog.vala"
	g_return_if_fail (row != NULL);
#line 659 "../src/preferences-dialog.vala"
	_tmp0_ = pomodoro_preferences_page_get_preferences_dialog ((PomodoroPreferencesPage*) self);
#line 659 "../src/preferences-dialog.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 659 "../src/preferences-dialog.vala"
	preferences_dialog = _tmp1_;
#line 661 "../src/preferences-dialog.vala"
	_tmp2_ = gtk_widget_get_name ((GtkWidget*) row);
#line 661 "../src/preferences-dialog.vala"
	_tmp3_ = _tmp2_;
#line 661 "../src/preferences-dialog.vala"
	_tmp4_ = _tmp3_;
#line 661 "../src/preferences-dialog.vala"
	_tmp6_ = (NULL == _tmp4_) ? 0 : g_quark_from_string (_tmp4_);
#line 661 "../src/preferences-dialog.vala"
	if (_tmp6_ == ((0 != _tmp5_label0) ? _tmp5_label0 : (_tmp5_label0 = g_quark_from_static_string ("keyboard-shortcut")))) {
#line 661 "../src/preferences-dialog.vala"
		switch (0) {
#line 3327 "preferences-dialog.c"
			default:
			{
				PomodoroPreferencesDialog* _tmp7_;
#line 664 "../src/preferences-dialog.vala"
				_tmp7_ = preferences_dialog;
#line 664 "../src/preferences-dialog.vala"
				pomodoro_preferences_dialog_set_page (_tmp7_, "keyboard-shortcut");
#line 665 "../src/preferences-dialog.vala"
				break;
#line 3337 "preferences-dialog.c"
			}
		}
	} else if (_tmp6_ == ((0 != _tmp5_label1) ? _tmp5_label1 : (_tmp5_label1 = g_quark_from_static_string ("plugins")))) {
#line 661 "../src/preferences-dialog.vala"
		switch (0) {
#line 3343 "preferences-dialog.c"
			default:
			{
				PomodoroPreferencesDialog* _tmp8_;
#line 668 "../src/preferences-dialog.vala"
				_tmp8_ = preferences_dialog;
#line 668 "../src/preferences-dialog.vala"
				pomodoro_preferences_dialog_set_page (_tmp8_, "plugins");
#line 669 "../src/preferences-dialog.vala"
				break;
#line 3353 "preferences-dialog.c"
			}
		}
	} else {
#line 661 "../src/preferences-dialog.vala"
		switch (0) {
#line 3359 "preferences-dialog.c"
			default:
			{
#line 672 "../src/preferences-dialog.vala"
				break;
#line 3364 "preferences-dialog.c"
			}
		}
	}
#line 656 "../src/preferences-dialog.vala"
	_g_object_unref0 (preferences_dialog);
#line 3370 "preferences-dialog.c"
}

static void
_pomodoro_preferences_main_page_on_row_activated_gtk_list_box_row_activated (GtkListBox* _sender,
                                                                             GtkListBoxRow* row,
                                                                             gpointer self)
{
#line 496 "../src/preferences-dialog.vala"
	pomodoro_preferences_main_page_on_row_activated ((PomodoroPreferencesMainPage*) self, _sender, row);
#line 3380 "preferences-dialog.c"
}

static void
pomodoro_preferences_main_page_update_capabilities (PomodoroPreferencesMainPage* self)
{
	PomodoroApplication* application = NULL;
	PomodoroApplication* _tmp0_;
	PomodoroApplication* _tmp1_;
	PomodoroCapabilityManager* capabilities = NULL;
	PomodoroCapabilityManager* _tmp2_;
	PomodoroCapabilityManager* _tmp3_;
	GtkListBoxRow* _tmp4_;
	GtkListBoxRow* _tmp5_;
#line 676 "../src/preferences-dialog.vala"
	g_return_if_fail (self != NULL);
#line 678 "../src/preferences-dialog.vala"
	_tmp0_ = pomodoro_application_get_default ();
#line 678 "../src/preferences-dialog.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 678 "../src/preferences-dialog.vala"
	application = _tmp1_;
#line 679 "../src/preferences-dialog.vala"
	_tmp2_ = application->capabilities;
#line 679 "../src/preferences-dialog.vala"
	_tmp3_ = _g_object_ref0 (_tmp2_);
#line 679 "../src/preferences-dialog.vala"
	capabilities = _tmp3_;
#line 681 "../src/preferences-dialog.vala"
	_tmp4_ = self->priv->listboxrow_accelerator;
#line 681 "../src/preferences-dialog.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp4_, pomodoro_capability_manager_has_enabled (capabilities, "accelerator"));
#line 682 "../src/preferences-dialog.vala"
	_tmp5_ = self->priv->listboxrow_idle_monitor;
#line 682 "../src/preferences-dialog.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp5_, pomodoro_capability_manager_has_enabled (capabilities, "idle-monitor"));
#line 676 "../src/preferences-dialog.vala"
	_g_object_unref0 (capabilities);
#line 676 "../src/preferences-dialog.vala"
	_g_object_unref0 (application);
#line 3420 "preferences-dialog.c"
}

static void
pomodoro_preferences_main_page_on_capability_enabled (PomodoroPreferencesMainPage* self,
                                                      const gchar* capability_name)
{
#line 685 "../src/preferences-dialog.vala"
	g_return_if_fail (self != NULL);
#line 685 "../src/preferences-dialog.vala"
	g_return_if_fail (capability_name != NULL);
#line 687 "../src/preferences-dialog.vala"
	pomodoro_preferences_main_page_update_capabilities (self);
#line 3433 "preferences-dialog.c"
}

static void
pomodoro_preferences_main_page_on_capability_disabled (PomodoroPreferencesMainPage* self,
                                                       const gchar* capability_name)
{
#line 690 "../src/preferences-dialog.vala"
	g_return_if_fail (self != NULL);
#line 690 "../src/preferences-dialog.vala"
	g_return_if_fail (capability_name != NULL);
#line 692 "../src/preferences-dialog.vala"
	pomodoro_preferences_main_page_update_capabilities (self);
#line 3446 "preferences-dialog.c"
}

static Block11Data*
block11_data_ref (Block11Data* _data11_)
{
#line 695 "../src/preferences-dialog.vala"
	g_atomic_int_inc (&_data11_->_ref_count_);
#line 695 "../src/preferences-dialog.vala"
	return _data11_;
#line 3456 "preferences-dialog.c"
}

static void
block11_data_unref (void * _userdata_)
{
	Block11Data* _data11_;
	_data11_ = (Block11Data*) _userdata_;
#line 695 "../src/preferences-dialog.vala"
	if (g_atomic_int_dec_and_test (&_data11_->_ref_count_)) {
#line 3466 "preferences-dialog.c"
		PomodoroPreferencesMainPage* self;
#line 695 "../src/preferences-dialog.vala"
		self = _data11_->self;
#line 695 "../src/preferences-dialog.vala"
		_g_object_unref0 (_data11_->listbox);
#line 695 "../src/preferences-dialog.vala"
		_g_object_unref0 (self);
#line 695 "../src/preferences-dialog.vala"
		g_slice_free (Block11Data, _data11_);
#line 3476 "preferences-dialog.c"
	}
}

static void
__lambda21_ (Block11Data* _data11_,
             GtkWidget* child)
{
	PomodoroPreferencesMainPage* self;
#line 697 "../src/preferences-dialog.vala"
	self = _data11_->self;
#line 697 "../src/preferences-dialog.vala"
	g_return_if_fail (child != NULL);
#line 698 "../src/preferences-dialog.vala"
	pomodoro_preferences_main_page_on_listbox_add (self, G_TYPE_CHECK_INSTANCE_TYPE (_data11_->listbox, gtk_widget_get_type ()) ? ((GtkWidget*) _data11_->listbox) : NULL, child);
#line 3491 "preferences-dialog.c"
}

static void
___lambda21__gtk_callback (GtkWidget* widget,
                           gpointer self)
{
#line 697 "../src/preferences-dialog.vala"
	__lambda21_ (self, widget);
#line 3500 "preferences-dialog.c"
}

static void
_pomodoro_preferences_main_page_on_listbox_add_gtk_container_add (GtkContainer* _sender,
                                                                  GtkWidget* widget,
                                                                  gpointer self)
{
#line 701 "../src/preferences-dialog.vala"
	pomodoro_preferences_main_page_on_listbox_add ((PomodoroPreferencesMainPage*) self, _sender, widget);
#line 3510 "preferences-dialog.c"
}

static void
_pomodoro_preferences_main_page_on_listbox_remove_gtk_container_remove (GtkContainer* _sender,
                                                                        GtkWidget* widget,
                                                                        gpointer self)
{
#line 702 "../src/preferences-dialog.vala"
	pomodoro_preferences_main_page_on_listbox_remove ((PomodoroPreferencesMainPage*) self, _sender, widget);
#line 3520 "preferences-dialog.c"
}

static void
pomodoro_preferences_main_page_setup_listbox (PomodoroPreferencesMainPage* self,
                                              GtkListBox* listbox)
{
	Block11Data* _data11_;
	GtkListBox* _tmp0_;
#line 695 "../src/preferences-dialog.vala"
	g_return_if_fail (self != NULL);
#line 695 "../src/preferences-dialog.vala"
	g_return_if_fail (listbox != NULL);
#line 695 "../src/preferences-dialog.vala"
	_data11_ = g_slice_new0 (Block11Data);
#line 695 "../src/preferences-dialog.vala"
	_data11_->_ref_count_ = 1;
#line 695 "../src/preferences-dialog.vala"
	_data11_->self = g_object_ref (self);
#line 695 "../src/preferences-dialog.vala"
	_tmp0_ = _g_object_ref0 (listbox);
#line 695 "../src/preferences-dialog.vala"
	_g_object_unref0 (_data11_->listbox);
#line 695 "../src/preferences-dialog.vala"
	_data11_->listbox = _tmp0_;
#line 697 "../src/preferences-dialog.vala"
	gtk_container_foreach ((GtkContainer*) _data11_->listbox, ___lambda21__gtk_callback, _data11_);
#line 701 "../src/preferences-dialog.vala"
	g_signal_connect_object ((GtkContainer*) _data11_->listbox, "add", (GCallback) _pomodoro_preferences_main_page_on_listbox_add_gtk_container_add, self, G_CONNECT_AFTER);
#line 702 "../src/preferences-dialog.vala"
	g_signal_connect_object ((GtkContainer*) _data11_->listbox, "remove", (GCallback) _pomodoro_preferences_main_page_on_listbox_remove_gtk_container_remove, self, G_CONNECT_AFTER);
#line 695 "../src/preferences-dialog.vala"
	block11_data_unref (_data11_);
#line 695 "../src/preferences-dialog.vala"
	_data11_ = NULL;
#line 3555 "preferences-dialog.c"
}

static Block12Data*
block12_data_ref (Block12Data* _data12_)
{
#line 705 "../src/preferences-dialog.vala"
	g_atomic_int_inc (&_data12_->_ref_count_);
#line 705 "../src/preferences-dialog.vala"
	return _data12_;
#line 3565 "preferences-dialog.c"
}

static void
block12_data_unref (void * _userdata_)
{
	Block12Data* _data12_;
	_data12_ = (Block12Data*) _userdata_;
#line 705 "../src/preferences-dialog.vala"
	if (g_atomic_int_dec_and_test (&_data12_->_ref_count_)) {
#line 3575 "preferences-dialog.c"
		PomodoroPreferencesMainPage* self;
#line 705 "../src/preferences-dialog.vala"
		self = _data12_->self;
#line 705 "../src/preferences-dialog.vala"
		_g_object_unref0 (self);
#line 705 "../src/preferences-dialog.vala"
		g_slice_free (Block12Data, _data12_);
#line 3583 "preferences-dialog.c"
	}
}

static void
___lambda22_ (Block12Data* _data12_,
              GtkWidget* child)
{
	PomodoroPreferencesMainPage* self;
	gboolean _tmp0_;
	gboolean _tmp1_;
#line 718 "../src/preferences-dialog.vala"
	self = _data12_->self;
#line 718 "../src/preferences-dialog.vala"
	g_return_if_fail (child != NULL);
#line 719 "../src/preferences-dialog.vala"
	_tmp0_ = gtk_widget_get_visible (child);
#line 719 "../src/preferences-dialog.vala"
	_tmp1_ = _tmp0_;
#line 719 "../src/preferences-dialog.vala"
	_data12_->visible |= _tmp1_;
#line 3604 "preferences-dialog.c"
}

static void
____lambda22__gtk_callback (GtkWidget* widget,
                            gpointer self)
{
#line 718 "../src/preferences-dialog.vala"
	___lambda22_ (self, widget);
#line 3613 "preferences-dialog.c"
}

static void
pomodoro_preferences_main_page_on_listboxrow_visible_notify (PomodoroPreferencesMainPage* self,
                                                             GObject* object,
                                                             GParamSpec* pspec)
{
	Block12Data* _data12_;
	GtkWidget* widget = NULL;
	GtkWidget* _tmp0_;
	GtkWidget* _tmp1_;
	GtkContainer* _tmp2_;
	GtkContainer* _tmp3_;
	GtkListBox* listbox = NULL;
	GtkWidget* _tmp4_;
	GtkListBox* _tmp5_;
	GtkWidget* _tmp6_;
	GtkContainer* _tmp7_;
	GtkContainer* _tmp8_;
#line 705 "../src/preferences-dialog.vala"
	g_return_if_fail (self != NULL);
#line 705 "../src/preferences-dialog.vala"
	g_return_if_fail (object != NULL);
#line 705 "../src/preferences-dialog.vala"
	g_return_if_fail (pspec != NULL);
#line 705 "../src/preferences-dialog.vala"
	_data12_ = g_slice_new0 (Block12Data);
#line 705 "../src/preferences-dialog.vala"
	_data12_->_ref_count_ = 1;
#line 705 "../src/preferences-dialog.vala"
	_data12_->self = g_object_ref (self);
#line 708 "../src/preferences-dialog.vala"
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (object, gtk_widget_get_type ()) ? ((GtkWidget*) object) : NULL);
#line 708 "../src/preferences-dialog.vala"
	widget = _tmp0_;
#line 709 "../src/preferences-dialog.vala"
	_tmp1_ = widget;
#line 709 "../src/preferences-dialog.vala"
	_tmp2_ = gtk_widget_get_parent (_tmp1_);
#line 709 "../src/preferences-dialog.vala"
	_tmp3_ = _tmp2_;
#line 709 "../src/preferences-dialog.vala"
	if (_tmp3_ == NULL) {
#line 710 "../src/preferences-dialog.vala"
		_g_object_unref0 (widget);
#line 710 "../src/preferences-dialog.vala"
		block12_data_unref (_data12_);
#line 710 "../src/preferences-dialog.vala"
		_data12_ = NULL;
#line 710 "../src/preferences-dialog.vala"
		return;
#line 3665 "preferences-dialog.c"
	}
#line 713 "../src/preferences-dialog.vala"
	_tmp4_ = widget;
#line 713 "../src/preferences-dialog.vala"
	_tmp5_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp4_, gtk_list_box_get_type ()) ? ((GtkListBox*) _tmp4_) : NULL);
#line 713 "../src/preferences-dialog.vala"
	listbox = _tmp5_;
#line 714 "../src/preferences-dialog.vala"
	_data12_->visible = FALSE;
#line 716 "../src/preferences-dialog.vala"
	_tmp6_ = widget;
#line 716 "../src/preferences-dialog.vala"
	_tmp7_ = gtk_widget_get_parent (_tmp6_);
#line 716 "../src/preferences-dialog.vala"
	_tmp8_ = _tmp7_;
#line 716 "../src/preferences-dialog.vala"
	if (_tmp8_ != NULL) {
#line 3683 "preferences-dialog.c"
		GtkListBox* _tmp9_;
		GtkWidget* _tmp10_;
		GtkContainer* _tmp11_;
		GtkContainer* _tmp12_;
		gboolean _tmp13_;
		gboolean _tmp14_;
#line 718 "../src/preferences-dialog.vala"
		_tmp9_ = listbox;
#line 718 "../src/preferences-dialog.vala"
		gtk_container_foreach ((GtkContainer*) _tmp9_, ____lambda22__gtk_callback, _data12_);
#line 722 "../src/preferences-dialog.vala"
		_tmp10_ = widget;
#line 722 "../src/preferences-dialog.vala"
		_tmp11_ = gtk_widget_get_parent (_tmp10_);
#line 722 "../src/preferences-dialog.vala"
		_tmp12_ = _tmp11_;
#line 722 "../src/preferences-dialog.vala"
		_tmp13_ = gtk_widget_get_visible ((GtkWidget*) _tmp12_);
#line 722 "../src/preferences-dialog.vala"
		_tmp14_ = _tmp13_;
#line 722 "../src/preferences-dialog.vala"
		if (_tmp14_ != _data12_->visible) {
#line 3706 "preferences-dialog.c"
			GtkWidget* _tmp15_;
			GtkContainer* _tmp16_;
			GtkContainer* _tmp17_;
#line 723 "../src/preferences-dialog.vala"
			_tmp15_ = widget;
#line 723 "../src/preferences-dialog.vala"
			_tmp16_ = gtk_widget_get_parent (_tmp15_);
#line 723 "../src/preferences-dialog.vala"
			_tmp17_ = _tmp16_;
#line 723 "../src/preferences-dialog.vala"
			gtk_widget_set_visible ((GtkWidget*) _tmp17_, _data12_->visible);
#line 3718 "preferences-dialog.c"
		}
	}
#line 705 "../src/preferences-dialog.vala"
	_g_object_unref0 (listbox);
#line 705 "../src/preferences-dialog.vala"
	_g_object_unref0 (widget);
#line 705 "../src/preferences-dialog.vala"
	block12_data_unref (_data12_);
#line 705 "../src/preferences-dialog.vala"
	_data12_ = NULL;
#line 3729 "preferences-dialog.c"
}

static void
_pomodoro_preferences_main_page_on_listboxrow_visible_notify_g_object_notify (GObject* _sender,
                                                                              GParamSpec* pspec,
                                                                              gpointer self)
{
#line 732 "../src/preferences-dialog.vala"
	pomodoro_preferences_main_page_on_listboxrow_visible_notify ((PomodoroPreferencesMainPage*) self, _sender, pspec);
#line 3739 "preferences-dialog.c"
}

static void
pomodoro_preferences_main_page_on_listbox_add (PomodoroPreferencesMainPage* self,
                                               GtkWidget* widget,
                                               GtkWidget* child)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GtkContainer* _tmp2_;
	GtkContainer* _tmp3_;
#line 729 "../src/preferences-dialog.vala"
	g_return_if_fail (self != NULL);
#line 729 "../src/preferences-dialog.vala"
	g_return_if_fail (widget != NULL);
#line 729 "../src/preferences-dialog.vala"
	g_return_if_fail (child != NULL);
#line 732 "../src/preferences-dialog.vala"
	g_signal_connect_object ((GObject*) child, "notify::visible", (GCallback) _pomodoro_preferences_main_page_on_listboxrow_visible_notify_g_object_notify, self, 0);
#line 734 "../src/preferences-dialog.vala"
	_tmp2_ = gtk_widget_get_parent (widget);
#line 734 "../src/preferences-dialog.vala"
	_tmp3_ = _tmp2_;
#line 734 "../src/preferences-dialog.vala"
	if (_tmp3_ != NULL) {
#line 3765 "preferences-dialog.c"
		GtkContainer* _tmp4_;
		GtkContainer* _tmp5_;
		gboolean _tmp6_;
		gboolean _tmp7_;
#line 734 "../src/preferences-dialog.vala"
		_tmp4_ = gtk_widget_get_parent (widget);
#line 734 "../src/preferences-dialog.vala"
		_tmp5_ = _tmp4_;
#line 734 "../src/preferences-dialog.vala"
		_tmp6_ = gtk_widget_get_visible ((GtkWidget*) _tmp5_);
#line 734 "../src/preferences-dialog.vala"
		_tmp7_ = _tmp6_;
#line 734 "../src/preferences-dialog.vala"
		_tmp1_ = !_tmp7_;
#line 3780 "preferences-dialog.c"
	} else {
#line 734 "../src/preferences-dialog.vala"
		_tmp1_ = FALSE;
#line 3784 "preferences-dialog.c"
	}
#line 734 "../src/preferences-dialog.vala"
	if (_tmp1_) {
#line 3788 "preferences-dialog.c"
		gboolean _tmp8_;
		gboolean _tmp9_;
#line 734 "../src/preferences-dialog.vala"
		_tmp8_ = gtk_widget_get_visible (child);
#line 734 "../src/preferences-dialog.vala"
		_tmp9_ = _tmp8_;
#line 734 "../src/preferences-dialog.vala"
		_tmp0_ = _tmp9_;
#line 3797 "preferences-dialog.c"
	} else {
#line 734 "../src/preferences-dialog.vala"
		_tmp0_ = FALSE;
#line 3801 "preferences-dialog.c"
	}
#line 734 "../src/preferences-dialog.vala"
	if (_tmp0_) {
#line 3805 "preferences-dialog.c"
		GtkContainer* _tmp10_;
		GtkContainer* _tmp11_;
#line 735 "../src/preferences-dialog.vala"
		_tmp10_ = gtk_widget_get_parent (widget);
#line 735 "../src/preferences-dialog.vala"
		_tmp11_ = _tmp10_;
#line 735 "../src/preferences-dialog.vala"
		gtk_widget_set_visible ((GtkWidget*) _tmp11_, TRUE);
#line 3814 "preferences-dialog.c"
	}
}

static Block13Data*
block13_data_ref (Block13Data* _data13_)
{
#line 744 "../src/preferences-dialog.vala"
	g_atomic_int_inc (&_data13_->_ref_count_);
#line 744 "../src/preferences-dialog.vala"
	return _data13_;
#line 3825 "preferences-dialog.c"
}

static void
block13_data_unref (void * _userdata_)
{
	Block13Data* _data13_;
	_data13_ = (Block13Data*) _userdata_;
#line 744 "../src/preferences-dialog.vala"
	if (g_atomic_int_dec_and_test (&_data13_->_ref_count_)) {
#line 3835 "preferences-dialog.c"
		PomodoroPreferencesMainPage* self;
#line 744 "../src/preferences-dialog.vala"
		self = _data13_->self;
#line 744 "../src/preferences-dialog.vala"
		_g_object_unref0 (self);
#line 744 "../src/preferences-dialog.vala"
		g_slice_free (Block13Data, _data13_);
#line 3843 "preferences-dialog.c"
	}
}

static void
___lambda23_ (Block13Data* _data13_,
              GtkWidget* child)
{
	PomodoroPreferencesMainPage* self;
	gboolean _tmp0_;
	gboolean _tmp1_;
#line 749 "../src/preferences-dialog.vala"
	self = _data13_->self;
#line 749 "../src/preferences-dialog.vala"
	g_return_if_fail (child != NULL);
#line 750 "../src/preferences-dialog.vala"
	_tmp0_ = gtk_widget_get_visible (child);
#line 750 "../src/preferences-dialog.vala"
	_tmp1_ = _tmp0_;
#line 750 "../src/preferences-dialog.vala"
	_data13_->visible |= _tmp1_;
#line 3864 "preferences-dialog.c"
}

static void
____lambda23__gtk_callback (GtkWidget* widget,
                            gpointer self)
{
#line 749 "../src/preferences-dialog.vala"
	___lambda23_ (self, widget);
#line 3873 "preferences-dialog.c"
}

static void
pomodoro_preferences_main_page_on_listbox_remove (PomodoroPreferencesMainPage* self,
                                                  GtkWidget* widget,
                                                  GtkWidget* child)
{
	guint _tmp0_;
	GQuark _tmp1_;
	GtkContainer* _tmp2_;
	GtkContainer* _tmp3_;
#line 739 "../src/preferences-dialog.vala"
	g_return_if_fail (self != NULL);
#line 739 "../src/preferences-dialog.vala"
	g_return_if_fail (widget != NULL);
#line 739 "../src/preferences-dialog.vala"
	g_return_if_fail (child != NULL);
#line 742 "../src/preferences-dialog.vala"
	g_signal_parse_name ("notify::visible", G_TYPE_OBJECT, &_tmp0_, &_tmp1_, TRUE);
#line 742 "../src/preferences-dialog.vala"
	g_signal_handlers_disconnect_matched ((GObject*) child, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_DETAIL | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp0_, _tmp1_, NULL, (GCallback) _pomodoro_preferences_main_page_on_listboxrow_visible_notify_g_object_notify, self);
#line 744 "../src/preferences-dialog.vala"
	_tmp2_ = gtk_widget_get_parent (widget);
#line 744 "../src/preferences-dialog.vala"
	_tmp3_ = _tmp2_;
#line 744 "../src/preferences-dialog.vala"
	if (_tmp3_ != NULL) {
#line 3901 "preferences-dialog.c"
		Block13Data* _data13_;
		GtkListBox* listbox = NULL;
		GtkListBox* _tmp4_;
		GtkListBox* _tmp5_;
		GtkContainer* _tmp6_;
		GtkContainer* _tmp7_;
		gboolean _tmp8_;
		gboolean _tmp9_;
#line 744 "../src/preferences-dialog.vala"
		_data13_ = g_slice_new0 (Block13Data);
#line 744 "../src/preferences-dialog.vala"
		_data13_->_ref_count_ = 1;
#line 744 "../src/preferences-dialog.vala"
		_data13_->self = g_object_ref (self);
#line 746 "../src/preferences-dialog.vala"
		_tmp4_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (widget, gtk_list_box_get_type ()) ? ((GtkListBox*) widget) : NULL);
#line 746 "../src/preferences-dialog.vala"
		listbox = _tmp4_;
#line 747 "../src/preferences-dialog.vala"
		_data13_->visible = FALSE;
#line 749 "../src/preferences-dialog.vala"
		_tmp5_ = listbox;
#line 749 "../src/preferences-dialog.vala"
		gtk_container_foreach ((GtkContainer*) _tmp5_, ____lambda23__gtk_callback, _data13_);
#line 753 "../src/preferences-dialog.vala"
		_tmp6_ = gtk_widget_get_parent (widget);
#line 753 "../src/preferences-dialog.vala"
		_tmp7_ = _tmp6_;
#line 753 "../src/preferences-dialog.vala"
		_tmp8_ = gtk_widget_get_visible ((GtkWidget*) _tmp7_);
#line 753 "../src/preferences-dialog.vala"
		_tmp9_ = _tmp8_;
#line 753 "../src/preferences-dialog.vala"
		if (_tmp9_ != _data13_->visible) {
#line 3936 "preferences-dialog.c"
			GtkContainer* _tmp10_;
			GtkContainer* _tmp11_;
#line 754 "../src/preferences-dialog.vala"
			_tmp10_ = gtk_widget_get_parent (widget);
#line 754 "../src/preferences-dialog.vala"
			_tmp11_ = _tmp10_;
#line 754 "../src/preferences-dialog.vala"
			gtk_widget_set_visible ((GtkWidget*) _tmp11_, _data13_->visible);
#line 3945 "preferences-dialog.c"
		}
#line 744 "../src/preferences-dialog.vala"
		_g_object_unref0 (listbox);
#line 744 "../src/preferences-dialog.vala"
		block13_data_unref (_data13_);
#line 744 "../src/preferences-dialog.vala"
		_data13_ = NULL;
#line 3953 "preferences-dialog.c"
	}
}

static void
_pomodoro_preferences_main_page_on_capability_enabled_pomodoro_capability_manager_capability_enabled (PomodoroCapabilityManager* _sender,
                                                                                                      const gchar* capability_name,
                                                                                                      gpointer self)
{
#line 762 "../src/preferences-dialog.vala"
	pomodoro_preferences_main_page_on_capability_enabled ((PomodoroPreferencesMainPage*) self, capability_name);
#line 3964 "preferences-dialog.c"
}

static void
_pomodoro_preferences_main_page_on_capability_disabled_pomodoro_capability_manager_capability_disabled (PomodoroCapabilityManager* _sender,
                                                                                                        const gchar* capability_name,
                                                                                                        gpointer self)
{
#line 763 "../src/preferences-dialog.vala"
	pomodoro_preferences_main_page_on_capability_disabled ((PomodoroPreferencesMainPage*) self, capability_name);
#line 3974 "preferences-dialog.c"
}

static void
pomodoro_preferences_main_page_real_dispose (GObject* base)
{
	PomodoroPreferencesMainPage * self;
	PomodoroApplication* application = NULL;
	PomodoroApplication* _tmp0_;
	PomodoroApplication* _tmp1_;
	PomodoroCapabilityManager* _tmp2_;
	guint _tmp3_;
	PomodoroCapabilityManager* _tmp4_;
	guint _tmp5_;
#line 759 "../src/preferences-dialog.vala"
	self = (PomodoroPreferencesMainPage*) base;
#line 761 "../src/preferences-dialog.vala"
	_tmp0_ = pomodoro_application_get_default ();
#line 761 "../src/preferences-dialog.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 761 "../src/preferences-dialog.vala"
	application = _tmp1_;
#line 762 "../src/preferences-dialog.vala"
	_tmp2_ = application->capabilities;
#line 762 "../src/preferences-dialog.vala"
	g_signal_parse_name ("capability-enabled", POMODORO_TYPE_CAPABILITY_MANAGER, &_tmp3_, NULL, FALSE);
#line 762 "../src/preferences-dialog.vala"
	g_signal_handlers_disconnect_matched (_tmp2_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp3_, 0, NULL, (GCallback) _pomodoro_preferences_main_page_on_capability_enabled_pomodoro_capability_manager_capability_enabled, self);
#line 763 "../src/preferences-dialog.vala"
	_tmp4_ = application->capabilities;
#line 763 "../src/preferences-dialog.vala"
	g_signal_parse_name ("capability-disabled", POMODORO_TYPE_CAPABILITY_MANAGER, &_tmp5_, NULL, FALSE);
#line 763 "../src/preferences-dialog.vala"
	g_signal_handlers_disconnect_matched (_tmp4_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp5_, 0, NULL, (GCallback) _pomodoro_preferences_main_page_on_capability_disabled_pomodoro_capability_manager_capability_disabled, self);
#line 765 "../src/preferences-dialog.vala"
	G_OBJECT_CLASS (pomodoro_preferences_main_page_parent_class)->dispose ((GObject*) G_TYPE_CHECK_INSTANCE_CAST (self, gtk_scrolled_window_get_type (), GtkScrolledWindow));
#line 759 "../src/preferences-dialog.vala"
	_g_object_unref0 (application);
#line 4012 "preferences-dialog.c"
}

PomodoroPreferencesMainPage*
pomodoro_preferences_main_page_construct (GType object_type)
{
	PomodoroPreferencesMainPage * self = NULL;
#line 496 "../src/preferences-dialog.vala"
	self = (PomodoroPreferencesMainPage*) g_object_new (object_type, NULL);
#line 496 "../src/preferences-dialog.vala"
	return self;
#line 4023 "preferences-dialog.c"
}

PomodoroPreferencesMainPage*
pomodoro_preferences_main_page_new (void)
{
#line 496 "../src/preferences-dialog.vala"
	return pomodoro_preferences_main_page_construct (POMODORO_TYPE_PREFERENCES_MAIN_PAGE);
#line 4031 "preferences-dialog.c"
}

static GObject *
pomodoro_preferences_main_page_constructor (GType type,
                                            guint n_construct_properties,
                                            GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	PomodoroPreferencesMainPage * self;
	GtkListBox* _tmp0_;
	GtkListBox* _tmp1_;
	GtkListBox* _tmp2_;
	GtkListBox* _tmp3_;
	PomodoroApplication* application = NULL;
	PomodoroApplication* _tmp4_;
	PomodoroApplication* _tmp5_;
	PomodoroApplication* _tmp6_;
	PomodoroCapabilityManager* _tmp7_;
	PomodoroApplication* _tmp8_;
	PomodoroCapabilityManager* _tmp9_;
	GtkListBox* _tmp10_;
#line 519 "../src/preferences-dialog.vala"
	parent_class = G_OBJECT_CLASS (pomodoro_preferences_main_page_parent_class);
#line 519 "../src/preferences-dialog.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 519 "../src/preferences-dialog.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, POMODORO_TYPE_PREFERENCES_MAIN_PAGE, PomodoroPreferencesMainPage);
#line 521 "../src/preferences-dialog.vala"
	_tmp0_ = self->timer_listbox;
#line 521 "../src/preferences-dialog.vala"
	gtk_list_box_set_header_func (_tmp0_, _pomodoro_list_box_separator_func_gtk_list_box_update_header_func, NULL, NULL);
#line 522 "../src/preferences-dialog.vala"
	_tmp1_ = self->notifications_listbox;
#line 522 "../src/preferences-dialog.vala"
	gtk_list_box_set_header_func (_tmp1_, _pomodoro_list_box_separator_func_gtk_list_box_update_header_func, NULL, NULL);
#line 523 "../src/preferences-dialog.vala"
	_tmp2_ = self->desktop_listbox;
#line 523 "../src/preferences-dialog.vala"
	gtk_list_box_set_header_func (_tmp2_, _pomodoro_list_box_separator_func_gtk_list_box_update_header_func, NULL, NULL);
#line 524 "../src/preferences-dialog.vala"
	_tmp3_ = self->plugins_listbox;
#line 524 "../src/preferences-dialog.vala"
	gtk_list_box_set_header_func (_tmp3_, _pomodoro_list_box_separator_func_gtk_list_box_update_header_func, NULL, NULL);
#line 526 "../src/preferences-dialog.vala"
	_tmp4_ = pomodoro_application_get_default ();
#line 526 "../src/preferences-dialog.vala"
	_tmp5_ = _g_object_ref0 (_tmp4_);
#line 526 "../src/preferences-dialog.vala"
	application = _tmp5_;
#line 527 "../src/preferences-dialog.vala"
	_tmp6_ = application;
#line 527 "../src/preferences-dialog.vala"
	_tmp7_ = _tmp6_->capabilities;
#line 527 "../src/preferences-dialog.vala"
	g_signal_connect_object (_tmp7_, "capability-enabled", (GCallback) _pomodoro_preferences_main_page_on_capability_enabled_pomodoro_capability_manager_capability_enabled, self, 0);
#line 528 "../src/preferences-dialog.vala"
	_tmp8_ = application;
#line 528 "../src/preferences-dialog.vala"
	_tmp9_ = _tmp8_->capabilities;
#line 528 "../src/preferences-dialog.vala"
	g_signal_connect_object (_tmp9_, "capability-disabled", (GCallback) _pomodoro_preferences_main_page_on_capability_disabled_pomodoro_capability_manager_capability_disabled, self, 0);
#line 530 "../src/preferences-dialog.vala"
	pomodoro_preferences_main_page_update_capabilities (self);
#line 533 "../src/preferences-dialog.vala"
	_tmp10_ = self->desktop_listbox;
#line 533 "../src/preferences-dialog.vala"
	pomodoro_preferences_main_page_setup_listbox (self, _tmp10_);
#line 519 "../src/preferences-dialog.vala"
	_g_object_unref0 (application);
#line 519 "../src/preferences-dialog.vala"
	return obj;
#line 4104 "preferences-dialog.c"
}

static void
pomodoro_preferences_main_page_class_init (PomodoroPreferencesMainPageClass * klass,
                                           gpointer klass_data)
{
#line 496 "../src/preferences-dialog.vala"
	pomodoro_preferences_main_page_parent_class = g_type_class_peek_parent (klass);
#line 496 "../src/preferences-dialog.vala"
	g_type_class_adjust_private_offset (klass, &PomodoroPreferencesMainPage_private_offset);
#line 496 "../src/preferences-dialog.vala"
	((GObjectClass *) klass)->dispose = (void (*) (GObject*)) pomodoro_preferences_main_page_real_dispose;
#line 496 "../src/preferences-dialog.vala"
	G_OBJECT_CLASS (klass)->constructor = pomodoro_preferences_main_page_constructor;
#line 496 "../src/preferences-dialog.vala"
	G_OBJECT_CLASS (klass)->finalize = pomodoro_preferences_main_page_finalize;
#line 496 "../src/preferences-dialog.vala"
	gtk_widget_class_set_template_from_resource (GTK_WIDGET_CLASS (klass), "/org/gnome/pomodoro/preferences-main-page.ui");
#line 496 "../src/preferences-dialog.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "box", FALSE, G_STRUCT_OFFSET (PomodoroPreferencesMainPage, box));
#line 496 "../src/preferences-dialog.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "timer_listbox", FALSE, G_STRUCT_OFFSET (PomodoroPreferencesMainPage, timer_listbox));
#line 496 "../src/preferences-dialog.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "notifications_listbox", FALSE, G_STRUCT_OFFSET (PomodoroPreferencesMainPage, notifications_listbox));
#line 496 "../src/preferences-dialog.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "desktop_listbox", FALSE, G_STRUCT_OFFSET (PomodoroPreferencesMainPage, desktop_listbox));
#line 496 "../src/preferences-dialog.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "plugins_listbox", FALSE, G_STRUCT_OFFSET (PomodoroPreferencesMainPage, plugins_listbox));
#line 496 "../src/preferences-dialog.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "lisboxrow_sizegroup", FALSE, G_STRUCT_OFFSET (PomodoroPreferencesMainPage, lisboxrow_sizegroup));
#line 496 "../src/preferences-dialog.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "listboxrow_accelerator", FALSE, PomodoroPreferencesMainPage_private_offset + G_STRUCT_OFFSET (PomodoroPreferencesMainPagePrivate, listboxrow_accelerator));
#line 496 "../src/preferences-dialog.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "listboxrow_idle_monitor", FALSE, PomodoroPreferencesMainPage_private_offset + G_STRUCT_OFFSET (PomodoroPreferencesMainPagePrivate, listboxrow_idle_monitor));
#line 496 "../src/preferences-dialog.vala"
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "on_row_activated", G_CALLBACK(_pomodoro_preferences_main_page_on_row_activated_gtk_list_box_row_activated));
#line 4141 "preferences-dialog.c"
}

static void
pomodoro_preferences_main_page_gtk_buildable_interface_init (GtkBuildableIface * iface,
                                                             gpointer iface_data)
{
#line 496 "../src/preferences-dialog.vala"
	pomodoro_preferences_main_page_gtk_buildable_parent_iface = g_type_interface_peek_parent (iface);
#line 496 "../src/preferences-dialog.vala"
	iface->parser_finished = (void (*) (GtkBuildable*, GtkBuilder*)) pomodoro_preferences_main_page_real_parser_finished;
#line 4152 "preferences-dialog.c"
}

static void
pomodoro_preferences_main_page_pomodoro_preferences_page_interface_init (PomodoroPreferencesPageIface * iface,
                                                                         gpointer iface_data)
{
#line 496 "../src/preferences-dialog.vala"
	pomodoro_preferences_main_page_pomodoro_preferences_page_parent_iface = g_type_interface_peek_parent (iface);
#line 4161 "preferences-dialog.c"
}

static void
pomodoro_preferences_main_page_instance_init (PomodoroPreferencesMainPage * self,
                                              gpointer klass)
{
#line 496 "../src/preferences-dialog.vala"
	self->priv = pomodoro_preferences_main_page_get_instance_private (self);
#line 496 "../src/preferences-dialog.vala"
	gtk_widget_init_template (GTK_WIDGET (self));
#line 4172 "preferences-dialog.c"
}

static void
pomodoro_preferences_main_page_finalize (GObject * obj)
{
	PomodoroPreferencesMainPage * self;
#line 496 "../src/preferences-dialog.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, POMODORO_TYPE_PREFERENCES_MAIN_PAGE, PomodoroPreferencesMainPage);
#line 516 "../src/preferences-dialog.vala"
	_g_object_unref0 (self->priv->settings);
#line 517 "../src/preferences-dialog.vala"
	_g_object_unref0 (self->priv->accelerator);
#line 496 "../src/preferences-dialog.vala"
	G_OBJECT_CLASS (pomodoro_preferences_main_page_parent_class)->finalize (obj);
#line 4187 "preferences-dialog.c"
}

static GType
pomodoro_preferences_main_page_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (PomodoroPreferencesMainPageClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) pomodoro_preferences_main_page_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PomodoroPreferencesMainPage), 0, (GInstanceInitFunc) pomodoro_preferences_main_page_instance_init, NULL };
	static const GInterfaceInfo gtk_buildable_info = { (GInterfaceInitFunc) pomodoro_preferences_main_page_gtk_buildable_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	static const GInterfaceInfo pomodoro_preferences_page_info = { (GInterfaceInitFunc) pomodoro_preferences_main_page_pomodoro_preferences_page_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	GType pomodoro_preferences_main_page_type_id;
	pomodoro_preferences_main_page_type_id = g_type_register_static (gtk_scrolled_window_get_type (), "PomodoroPreferencesMainPage", &g_define_type_info, 0);
	g_type_add_interface_static (pomodoro_preferences_main_page_type_id, gtk_buildable_get_type (), &gtk_buildable_info);
	g_type_add_interface_static (pomodoro_preferences_main_page_type_id, POMODORO_TYPE_PREFERENCES_PAGE, &pomodoro_preferences_page_info);
	PomodoroPreferencesMainPage_private_offset = g_type_add_instance_private (pomodoro_preferences_main_page_type_id, sizeof (PomodoroPreferencesMainPagePrivate));
	return pomodoro_preferences_main_page_type_id;
}

GType
pomodoro_preferences_main_page_get_type (void)
{
	static volatile gsize pomodoro_preferences_main_page_type_id__once = 0;
	if (g_once_init_enter (&pomodoro_preferences_main_page_type_id__once)) {
		GType pomodoro_preferences_main_page_type_id;
		pomodoro_preferences_main_page_type_id = pomodoro_preferences_main_page_get_type_once ();
		g_once_init_leave (&pomodoro_preferences_main_page_type_id__once, pomodoro_preferences_main_page_type_id);
	}
	return pomodoro_preferences_main_page_type_id__once;
}

static inline gpointer
pomodoro_preferences_dialog_get_instance_private (PomodoroPreferencesDialog* self)
{
	return G_STRUCT_MEMBER_P (self, PomodoroPreferencesDialog_private_offset);
}

static void
_pomodoro_preferences_dialog_on_back_activate_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                GVariant* parameter,
                                                                                gpointer self)
{
#line 775 "../src/preferences-dialog.vala"
	pomodoro_preferences_dialog_on_back_activate ((PomodoroPreferencesDialog*) self, action, parameter);
#line 4229 "preferences-dialog.c"
}

static inline void
_g_list_free__g_free0_ (GList* self)
{
#line 789 "../src/preferences-dialog.vala"
	g_list_free_full (self, (GDestroyNotify) _g_free0_);
#line 4237 "preferences-dialog.c"
}

PomodoroPreferencesDialog*
pomodoro_preferences_dialog_get_default (void)
{
	PomodoroPreferencesDialog* _tmp0_;
	PomodoroPreferencesDialog* _tmp1_;
	PomodoroPreferencesDialog* result;
#line 849 "../src/preferences-dialog.vala"
	_tmp0_ = pomodoro_preferences_dialog_instance;
#line 849 "../src/preferences-dialog.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 849 "../src/preferences-dialog.vala"
	result = _tmp1_;
#line 849 "../src/preferences-dialog.vala"
	return result;
#line 4254 "preferences-dialog.c"
}

static void
pomodoro_preferences_dialog_real_parser_finished (GtkBuildable* base,
                                                  GtkBuilder* builder)
{
	PomodoroPreferencesDialog * self;
#line 852 "../src/preferences-dialog.vala"
	self = (PomodoroPreferencesDialog*) base;
#line 852 "../src/preferences-dialog.vala"
	g_return_if_fail (builder != NULL);
#line 854 "../src/preferences-dialog.vala"
	pomodoro_preferences_dialog_gtk_buildable_parent_iface->parser_finished ((GtkBuildable*) G_TYPE_CHECK_INSTANCE_CAST (self, gtk_application_window_get_type (), GtkApplicationWindow), builder);
#line 4268 "preferences-dialog.c"
}

static void
__lambda15_ (PomodoroPreferencesDialog* self,
             GtkWidget* child)
{
	GtkButton* _tmp0_;
#line 871 "../src/preferences-dialog.vala"
	g_return_if_fail (child != NULL);
#line 872 "../src/preferences-dialog.vala"
	_tmp0_ = self->priv->back_button;
#line 872 "../src/preferences-dialog.vala"
	if (child != G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, gtk_widget_get_type (), GtkWidget)) {
#line 4282 "preferences-dialog.c"
		GtkHeaderBar* _tmp1_;
#line 873 "../src/preferences-dialog.vala"
		_tmp1_ = self->priv->header_bar;
#line 873 "../src/preferences-dialog.vala"
		gtk_container_remove ((GtkContainer*) _tmp1_, child);
#line 4288 "preferences-dialog.c"
	}
}

static void
___lambda15__gtk_callback (GtkWidget* widget,
                           gpointer self)
{
#line 870 "../src/preferences-dialog.vala"
	__lambda15_ ((PomodoroPreferencesDialog*) self, widget);
#line 4298 "preferences-dialog.c"
}

static void
pomodoro_preferences_dialog_on_page_notify (PomodoroPreferencesDialog* self,
                                            PomodoroPreferencesPage* page)
{
	gchar* name = NULL;
	gchar* title = NULL;
	GtkStack* _tmp0_;
	gchar* _tmp1_ = NULL;
	gchar* _tmp2_ = NULL;
	GtkHeaderBar* _tmp3_;
	GtkButton* _tmp4_;
	GList* _tmp5_;
	GtkHeaderBar* _tmp6_;
	GtkHeaderBar* _tmp7_;
#line 857 "../src/preferences-dialog.vala"
	g_return_if_fail (self != NULL);
#line 857 "../src/preferences-dialog.vala"
	g_return_if_fail (page != NULL);
#line 862 "../src/preferences-dialog.vala"
	_tmp0_ = self->priv->stack;
#line 862 "../src/preferences-dialog.vala"
	gtk_container_child_get ((GtkContainer*) _tmp0_, (GtkWidget*) page, "name", &_tmp1_, "title", &_tmp2_, NULL);
#line 862 "../src/preferences-dialog.vala"
	_g_free0 (name);
#line 862 "../src/preferences-dialog.vala"
	name = _tmp1_;
#line 862 "../src/preferences-dialog.vala"
	_g_free0 (title);
#line 862 "../src/preferences-dialog.vala"
	title = _tmp2_;
#line 865 "../src/preferences-dialog.vala"
	pomodoro_preferences_dialog_history_push (self, name);
#line 867 "../src/preferences-dialog.vala"
	_tmp3_ = self->priv->header_bar;
#line 867 "../src/preferences-dialog.vala"
	gtk_header_bar_set_title (_tmp3_, title);
#line 868 "../src/preferences-dialog.vala"
	_tmp4_ = self->priv->back_button;
#line 868 "../src/preferences-dialog.vala"
	_tmp5_ = self->priv->history;
#line 868 "../src/preferences-dialog.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp4_, g_list_length (_tmp5_) > ((guint) 1));
#line 870 "../src/preferences-dialog.vala"
	_tmp6_ = self->priv->header_bar;
#line 870 "../src/preferences-dialog.vala"
	gtk_container_forall ((GtkContainer*) _tmp6_, ___lambda15__gtk_callback, self);
#line 877 "../src/preferences-dialog.vala"
	_tmp7_ = self->priv->header_bar;
#line 877 "../src/preferences-dialog.vala"
	pomodoro_preferences_page_configure_header_bar (page, _tmp7_);
#line 857 "../src/preferences-dialog.vala"
	_g_free0 (title);
#line 857 "../src/preferences-dialog.vala"
	_g_free0 (name);
#line 4355 "preferences-dialog.c"
}

static void
pomodoro_preferences_dialog_on_visible_child_notify (PomodoroPreferencesDialog* self)
{
	gint window_width = 0;
	gint window_height = 0;
	gint header_bar_height = 0;
	gint page_height = 0;
	PomodoroPreferencesPage* page = NULL;
	GtkStack* _tmp0_;
	GtkWidget* _tmp1_;
	GtkWidget* _tmp2_;
	PomodoroPreferencesPage* _tmp3_;
	PomodoroPreferencesPage* _tmp4_;
	gint _tmp5_ = 0;
	gint _tmp6_ = 0;
	GtkHeaderBar* _tmp7_;
	gint _tmp8_ = 0;
	PomodoroPreferencesPage* _tmp9_;
	gint _tmp10_ = 0;
	PomodoroPreferencesPage* _tmp11_;
#line 880 "../src/preferences-dialog.vala"
	g_return_if_fail (self != NULL);
#line 882 "../src/preferences-dialog.vala"
	window_width = 0;
#line 883 "../src/preferences-dialog.vala"
	window_height = 0;
#line 884 "../src/preferences-dialog.vala"
	header_bar_height = 0;
#line 885 "../src/preferences-dialog.vala"
	page_height = 0;
#line 886 "../src/preferences-dialog.vala"
	_tmp0_ = self->priv->stack;
#line 886 "../src/preferences-dialog.vala"
	_tmp1_ = gtk_stack_get_visible_child (_tmp0_);
#line 886 "../src/preferences-dialog.vala"
	_tmp2_ = _tmp1_;
#line 886 "../src/preferences-dialog.vala"
	_tmp3_ = _g_object_ref0 (POMODORO_IS_PREFERENCES_PAGE (_tmp2_) ? ((PomodoroPreferencesPage*) _tmp2_) : NULL);
#line 886 "../src/preferences-dialog.vala"
	page = _tmp3_;
#line 888 "../src/preferences-dialog.vala"
	_tmp4_ = page;
#line 888 "../src/preferences-dialog.vala"
	pomodoro_preferences_dialog_on_page_notify (self, _tmp4_);
#line 890 "../src/preferences-dialog.vala"
	gtk_window_get_size ((GtkWindow*) self, &_tmp5_, &_tmp6_);
#line 890 "../src/preferences-dialog.vala"
	window_width = _tmp5_;
#line 890 "../src/preferences-dialog.vala"
	window_height = _tmp6_;
#line 893 "../src/preferences-dialog.vala"
	_tmp7_ = self->priv->header_bar;
#line 893 "../src/preferences-dialog.vala"
	gtk_widget_get_preferred_height ((GtkWidget*) _tmp7_, NULL, &_tmp8_);
#line 893 "../src/preferences-dialog.vala"
	header_bar_height = _tmp8_;
#line 896 "../src/preferences-dialog.vala"
	_tmp9_ = page;
#line 896 "../src/preferences-dialog.vala"
	gtk_widget_get_preferred_height_for_width ((GtkWidget*) _tmp9_, window_width, NULL, &_tmp10_);
#line 896 "../src/preferences-dialog.vala"
	page_height = _tmp10_;
#line 900 "../src/preferences-dialog.vala"
	_tmp11_ = page;
#line 900 "../src/preferences-dialog.vala"
	if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp11_, gtk_scrolled_window_get_type ())) {
#line 4424 "preferences-dialog.c"
		GtkScrolledWindow* scrolled_window = NULL;
		PomodoroPreferencesPage* _tmp12_;
		GtkScrolledWindow* _tmp13_;
		GtkScrolledWindow* _tmp14_;
#line 901 "../src/preferences-dialog.vala"
		_tmp12_ = page;
#line 901 "../src/preferences-dialog.vala"
		_tmp13_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp12_, gtk_scrolled_window_get_type ()) ? ((GtkScrolledWindow*) _tmp12_) : NULL);
#line 901 "../src/preferences-dialog.vala"
		scrolled_window = _tmp13_;
#line 902 "../src/preferences-dialog.vala"
		_tmp14_ = scrolled_window;
#line 902 "../src/preferences-dialog.vala"
		gtk_scrolled_window_set_min_content_height (_tmp14_, MIN (page_height, POMODORO_PREFERENCES_DIALOG_DEFAULT_HEIGHT));
#line 904 "../src/preferences-dialog.vala"
		gtk_window_resize ((GtkWindow*) self, window_width, header_bar_height + POMODORO_PREFERENCES_DIALOG_DEFAULT_HEIGHT);
#line 900 "../src/preferences-dialog.vala"
		_g_object_unref0 (scrolled_window);
#line 4443 "preferences-dialog.c"
	} else {
#line 907 "../src/preferences-dialog.vala"
		gtk_window_resize ((GtkWindow*) self, window_width, header_bar_height + page_height);
#line 4447 "preferences-dialog.c"
	}
#line 880 "../src/preferences-dialog.vala"
	_g_object_unref0 (page);
#line 4451 "preferences-dialog.c"
}

static void
pomodoro_preferences_dialog_on_back_activate (PomodoroPreferencesDialog* self,
                                              GSimpleAction* action,
                                              GVariant* parameter)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
#line 911 "../src/preferences-dialog.vala"
	g_return_if_fail (self != NULL);
#line 911 "../src/preferences-dialog.vala"
	g_return_if_fail (action != NULL);
#line 914 "../src/preferences-dialog.vala"
	_tmp0_ = pomodoro_preferences_dialog_history_pop (self);
#line 914 "../src/preferences-dialog.vala"
	_tmp1_ = _tmp0_;
#line 914 "../src/preferences-dialog.vala"
	_g_free0 (_tmp1_);
#line 4471 "preferences-dialog.c"
}

static gpointer
_pomodoro_preferences_dialog_page_meta_dup0 (gpointer self)
{
#line 928 "../src/preferences-dialog.vala"
	return self ? pomodoro_preferences_dialog_page_meta_dup (self) : NULL;
#line 4479 "preferences-dialog.c"
}

PomodoroPreferencesPage*
pomodoro_preferences_dialog_get_page (PomodoroPreferencesDialog* self,
                                      const gchar* name)
{
	GtkStack* _tmp0_;
	gboolean _tmp6_ = FALSE;
	GHashTable* _tmp7_;
	PomodoroPreferencesPage* result;
#line 917 "../src/preferences-dialog.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 917 "../src/preferences-dialog.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 919 "../src/preferences-dialog.vala"
	_tmp0_ = self->priv->stack;
#line 919 "../src/preferences-dialog.vala"
	if (_tmp0_ != NULL) {
#line 4498 "preferences-dialog.c"
		GtkWidget* page_widget = NULL;
		GtkStack* _tmp1_;
		GtkWidget* _tmp2_;
		GtkWidget* _tmp3_;
		GtkWidget* _tmp4_;
#line 920 "../src/preferences-dialog.vala"
		_tmp1_ = self->priv->stack;
#line 920 "../src/preferences-dialog.vala"
		_tmp2_ = gtk_stack_get_child_by_name (_tmp1_, name);
#line 920 "../src/preferences-dialog.vala"
		_tmp3_ = _g_object_ref0 (_tmp2_);
#line 920 "../src/preferences-dialog.vala"
		page_widget = _tmp3_;
#line 922 "../src/preferences-dialog.vala"
		_tmp4_ = page_widget;
#line 922 "../src/preferences-dialog.vala"
		if (_tmp4_ != NULL) {
#line 4516 "preferences-dialog.c"
			GtkWidget* _tmp5_;
#line 923 "../src/preferences-dialog.vala"
			_tmp5_ = page_widget;
#line 923 "../src/preferences-dialog.vala"
			result = POMODORO_IS_PREFERENCES_PAGE (_tmp5_) ? ((PomodoroPreferencesPage*) _tmp5_) : NULL;
#line 923 "../src/preferences-dialog.vala"
			_g_object_unref0 (page_widget);
#line 923 "../src/preferences-dialog.vala"
			return result;
#line 4526 "preferences-dialog.c"
		}
#line 919 "../src/preferences-dialog.vala"
		_g_object_unref0 (page_widget);
#line 4530 "preferences-dialog.c"
	}
#line 927 "../src/preferences-dialog.vala"
	_tmp7_ = self->priv->pages;
#line 927 "../src/preferences-dialog.vala"
	if (_tmp7_ != NULL) {
#line 4536 "preferences-dialog.c"
		GHashTable* _tmp8_;
#line 927 "../src/preferences-dialog.vala"
		_tmp8_ = self->priv->pages;
#line 927 "../src/preferences-dialog.vala"
		_tmp6_ = g_hash_table_contains (_tmp8_, name);
#line 4542 "preferences-dialog.c"
	} else {
#line 927 "../src/preferences-dialog.vala"
		_tmp6_ = FALSE;
#line 4546 "preferences-dialog.c"
	}
#line 927 "../src/preferences-dialog.vala"
	if (_tmp6_) {
#line 4550 "preferences-dialog.c"
		PomodoroPreferencesDialogPageMeta* meta = NULL;
		GHashTable* _tmp9_;
		gconstpointer _tmp10_;
		PomodoroPreferencesDialogPageMeta* _tmp11_;
		PomodoroPreferencesPage* page = NULL;
		PomodoroPreferencesDialogPageMeta* _tmp12_;
		GObject* _tmp13_;
		GObject* _tmp14_;
		PomodoroPreferencesPage* _tmp15_;
		GtkStack* _tmp16_;
		PomodoroPreferencesPage* _tmp17_;
		PomodoroPreferencesDialogPageMeta* _tmp18_;
		const gchar* _tmp19_;
		PomodoroPreferencesDialogPageMeta* _tmp20_;
		const gchar* _tmp21_;
		PomodoroPreferencesPage* _tmp22_;
#line 928 "../src/preferences-dialog.vala"
		_tmp9_ = self->priv->pages;
#line 928 "../src/preferences-dialog.vala"
		_tmp10_ = g_hash_table_lookup (_tmp9_, name);
#line 928 "../src/preferences-dialog.vala"
		_tmp11_ = _pomodoro_preferences_dialog_page_meta_dup0 ((PomodoroPreferencesDialogPageMeta*) _tmp10_);
#line 928 "../src/preferences-dialog.vala"
		meta = _tmp11_;
#line 929 "../src/preferences-dialog.vala"
		_tmp12_ = meta;
#line 929 "../src/preferences-dialog.vala"
		_tmp13_ = g_object_new ((*_tmp12_).type, NULL);
#line 929 "../src/preferences-dialog.vala"
		_tmp14_ = G_IS_INITIALLY_UNOWNED (_tmp13_) ? g_object_ref_sink (_tmp13_) : _tmp13_;
#line 929 "../src/preferences-dialog.vala"
		_tmp15_ = POMODORO_IS_PREFERENCES_PAGE (_tmp14_) ? ((PomodoroPreferencesPage*) _tmp14_) : NULL;
#line 929 "../src/preferences-dialog.vala"
		if (_tmp15_ == NULL) {
#line 929 "../src/preferences-dialog.vala"
			_g_object_unref0 (_tmp14_);
#line 4587 "preferences-dialog.c"
		}
#line 929 "../src/preferences-dialog.vala"
		page = _tmp15_;
#line 931 "../src/preferences-dialog.vala"
		_tmp16_ = self->priv->stack;
#line 931 "../src/preferences-dialog.vala"
		_tmp17_ = page;
#line 931 "../src/preferences-dialog.vala"
		_tmp18_ = meta;
#line 931 "../src/preferences-dialog.vala"
		_tmp19_ = (*_tmp18_).name;
#line 931 "../src/preferences-dialog.vala"
		_tmp20_ = meta;
#line 931 "../src/preferences-dialog.vala"
		_tmp21_ = (*_tmp20_).title;
#line 931 "../src/preferences-dialog.vala"
		gtk_stack_add_titled (_tmp16_, G_TYPE_CHECK_INSTANCE_TYPE (_tmp17_, gtk_widget_get_type ()) ? ((GtkWidget*) _tmp17_) : NULL, _tmp19_, _tmp21_);
#line 935 "../src/preferences-dialog.vala"
		_tmp22_ = page;
#line 935 "../src/preferences-dialog.vala"
		result = POMODORO_IS_PREFERENCES_PAGE (_tmp22_) ? ((PomodoroPreferencesPage*) _tmp22_) : NULL;
#line 935 "../src/preferences-dialog.vala"
		_g_object_unref0 (page);
#line 935 "../src/preferences-dialog.vala"
		_pomodoro_preferences_dialog_page_meta_free0 (meta);
#line 935 "../src/preferences-dialog.vala"
		return result;
#line 4615 "preferences-dialog.c"
	}
#line 938 "../src/preferences-dialog.vala"
	result = NULL;
#line 938 "../src/preferences-dialog.vala"
	return result;
#line 4621 "preferences-dialog.c"
}

static void
pomodoro_preferences_dialog_history_clear (PomodoroPreferencesDialog* self)
{
#line 941 "../src/preferences-dialog.vala"
	g_return_if_fail (self != NULL);
#line 943 "../src/preferences-dialog.vala"
	(self->priv->history == NULL) ? NULL : (self->priv->history = (_g_list_free__g_free0_ (self->priv->history), NULL));
#line 943 "../src/preferences-dialog.vala"
	self->priv->history = NULL;
#line 4633 "preferences-dialog.c"
}

static void
pomodoro_preferences_dialog_history_push (PomodoroPreferencesDialog* self,
                                          const gchar* name)
{
	gchar* _tmp16_;
#line 946 "../src/preferences-dialog.vala"
	g_return_if_fail (self != NULL);
#line 946 "../src/preferences-dialog.vala"
	g_return_if_fail (name != NULL);
#line 948 "../src/preferences-dialog.vala"
	if (g_strcmp0 (name, "main") == 0) {
#line 949 "../src/preferences-dialog.vala"
		pomodoro_preferences_dialog_history_clear (self);
#line 4649 "preferences-dialog.c"
	} else {
		GList* last = NULL;
		GList* _tmp0_;
		GList* _tmp1_;
		gboolean _tmp2_ = FALSE;
		GList* _tmp3_;
		gboolean _tmp6_ = FALSE;
		gboolean _tmp7_ = FALSE;
		GList* _tmp8_;
#line 952 "../src/preferences-dialog.vala"
		_tmp0_ = self->priv->history;
#line 952 "../src/preferences-dialog.vala"
		_tmp1_ = g_list_last (_tmp0_);
#line 952 "../src/preferences-dialog.vala"
		last = _tmp1_;
#line 955 "../src/preferences-dialog.vala"
		_tmp3_ = last;
#line 955 "../src/preferences-dialog.vala"
		if (_tmp3_ != NULL) {
#line 4669 "preferences-dialog.c"
			GList* _tmp4_;
			gconstpointer _tmp5_;
#line 955 "../src/preferences-dialog.vala"
			_tmp4_ = last;
#line 955 "../src/preferences-dialog.vala"
			_tmp5_ = _tmp4_->data;
#line 955 "../src/preferences-dialog.vala"
			_tmp2_ = g_strcmp0 ((const gchar*) _tmp5_, name) == 0;
#line 4678 "preferences-dialog.c"
		} else {
#line 955 "../src/preferences-dialog.vala"
			_tmp2_ = FALSE;
#line 4682 "preferences-dialog.c"
		}
#line 955 "../src/preferences-dialog.vala"
		if (_tmp2_) {
#line 956 "../src/preferences-dialog.vala"
			return;
#line 4688 "preferences-dialog.c"
		}
#line 960 "../src/preferences-dialog.vala"
		_tmp8_ = last;
#line 960 "../src/preferences-dialog.vala"
		if (_tmp8_ != NULL) {
#line 4694 "preferences-dialog.c"
			GList* _tmp9_;
			GList* _tmp10_;
#line 960 "../src/preferences-dialog.vala"
			_tmp9_ = last;
#line 960 "../src/preferences-dialog.vala"
			_tmp10_ = _tmp9_->prev;
#line 960 "../src/preferences-dialog.vala"
			_tmp7_ = _tmp10_ != NULL;
#line 4703 "preferences-dialog.c"
		} else {
#line 960 "../src/preferences-dialog.vala"
			_tmp7_ = FALSE;
#line 4707 "preferences-dialog.c"
		}
#line 960 "../src/preferences-dialog.vala"
		if (_tmp7_) {
#line 4711 "preferences-dialog.c"
			GList* _tmp11_;
			GList* _tmp12_;
			gconstpointer _tmp13_;
#line 960 "../src/preferences-dialog.vala"
			_tmp11_ = last;
#line 960 "../src/preferences-dialog.vala"
			_tmp12_ = _tmp11_->prev;
#line 960 "../src/preferences-dialog.vala"
			_tmp13_ = _tmp12_->data;
#line 960 "../src/preferences-dialog.vala"
			_tmp6_ = g_strcmp0 ((const gchar*) _tmp13_, name) == 0;
#line 4723 "preferences-dialog.c"
		} else {
#line 960 "../src/preferences-dialog.vala"
			_tmp6_ = FALSE;
#line 4727 "preferences-dialog.c"
		}
#line 960 "../src/preferences-dialog.vala"
		if (_tmp6_) {
#line 4731 "preferences-dialog.c"
			gchar* _tmp14_;
			gchar* _tmp15_;
#line 961 "../src/preferences-dialog.vala"
			_tmp14_ = pomodoro_preferences_dialog_history_pop (self);
#line 961 "../src/preferences-dialog.vala"
			_tmp15_ = _tmp14_;
#line 961 "../src/preferences-dialog.vala"
			_g_free0 (_tmp15_);
#line 963 "../src/preferences-dialog.vala"
			return;
#line 4742 "preferences-dialog.c"
		}
	}
#line 967 "../src/preferences-dialog.vala"
	_tmp16_ = g_strdup (name);
#line 967 "../src/preferences-dialog.vala"
	self->priv->history = g_list_append (self->priv->history, _tmp16_);
#line 4749 "preferences-dialog.c"
}

static gchar*
pomodoro_preferences_dialog_history_pop (PomodoroPreferencesDialog* self)
{
	GList* last = NULL;
	GList* _tmp0_;
	GList* _tmp1_;
	gchar* last_name = NULL;
	gchar* next_name = NULL;
	gchar* _tmp2_;
	GList* _tmp3_;
	GList* _tmp10_;
	const gchar* _tmp14_;
	gchar* result;
#line 970 "../src/preferences-dialog.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 972 "../src/preferences-dialog.vala"
	_tmp0_ = self->priv->history;
#line 972 "../src/preferences-dialog.vala"
	_tmp1_ = g_list_last (_tmp0_);
#line 972 "../src/preferences-dialog.vala"
	last = _tmp1_;
#line 974 "../src/preferences-dialog.vala"
	last_name = NULL;
#line 975 "../src/preferences-dialog.vala"
	_tmp2_ = g_strdup ("main");
#line 975 "../src/preferences-dialog.vala"
	next_name = _tmp2_;
#line 977 "../src/preferences-dialog.vala"
	_tmp3_ = last;
#line 977 "../src/preferences-dialog.vala"
	if (_tmp3_ != NULL) {
#line 4783 "preferences-dialog.c"
		GList* _tmp4_;
		gconstpointer _tmp5_;
		gchar* _tmp6_;
		GList* _tmp7_;
		GList* _tmp8_;
		GList* _tmp9_;
#line 978 "../src/preferences-dialog.vala"
		_tmp4_ = last;
#line 978 "../src/preferences-dialog.vala"
		_tmp5_ = _tmp4_->data;
#line 978 "../src/preferences-dialog.vala"
		_tmp6_ = g_strdup ((const gchar*) _tmp5_);
#line 978 "../src/preferences-dialog.vala"
		_g_free0 (last_name);
#line 978 "../src/preferences-dialog.vala"
		last_name = _tmp6_;
#line 980 "../src/preferences-dialog.vala"
		_tmp7_ = last;
#line 980 "../src/preferences-dialog.vala"
		self->priv->history = g_list_delete_link (self->priv->history, _tmp7_);
#line 981 "../src/preferences-dialog.vala"
		_tmp8_ = self->priv->history;
#line 981 "../src/preferences-dialog.vala"
		_tmp9_ = g_list_last (_tmp8_);
#line 981 "../src/preferences-dialog.vala"
		last = _tmp9_;
#line 4810 "preferences-dialog.c"
	}
#line 984 "../src/preferences-dialog.vala"
	_tmp10_ = last;
#line 984 "../src/preferences-dialog.vala"
	if (_tmp10_ != NULL) {
#line 4816 "preferences-dialog.c"
		GList* _tmp11_;
		gconstpointer _tmp12_;
		gchar* _tmp13_;
#line 985 "../src/preferences-dialog.vala"
		_tmp11_ = last;
#line 985 "../src/preferences-dialog.vala"
		_tmp12_ = _tmp11_->data;
#line 985 "../src/preferences-dialog.vala"
		_tmp13_ = g_strdup ((const gchar*) _tmp12_);
#line 985 "../src/preferences-dialog.vala"
		_g_free0 (next_name);
#line 985 "../src/preferences-dialog.vala"
		next_name = _tmp13_;
#line 4830 "preferences-dialog.c"
	}
#line 988 "../src/preferences-dialog.vala"
	_tmp14_ = next_name;
#line 988 "../src/preferences-dialog.vala"
	pomodoro_preferences_dialog_set_page (self, _tmp14_);
#line 990 "../src/preferences-dialog.vala"
	result = last_name;
#line 990 "../src/preferences-dialog.vala"
	_g_free0 (next_name);
#line 990 "../src/preferences-dialog.vala"
	return result;
#line 4842 "preferences-dialog.c"
}

void
pomodoro_preferences_dialog_add_page (PomodoroPreferencesDialog* self,
                                      const gchar* name,
                                      const gchar* title,
                                      GType type)
{
	PomodoroPreferencesDialogPageMeta meta = {0};
	gchar* _tmp0_;
	gchar* _tmp1_;
	PomodoroPreferencesDialogPageMeta _tmp2_ = {0};
	GHashTable* _tmp3_;
	gchar* _tmp4_;
	PomodoroPreferencesDialogPageMeta _tmp5_;
	PomodoroPreferencesDialogPageMeta _tmp6_;
	PomodoroPreferencesDialogPageMeta* _tmp7_;
#line 993 "../src/preferences-dialog.vala"
	g_return_if_fail (self != NULL);
#line 993 "../src/preferences-dialog.vala"
	g_return_if_fail (name != NULL);
#line 993 "../src/preferences-dialog.vala"
	g_return_if_fail (title != NULL);
#line 993 "../src/preferences-dialog.vala"
	_vala_return_if_fail (g_type_is_a (type, POMODORO_TYPE_PREFERENCES_PAGE), "type.is_a (typeof (Pomodoro.PreferencesPage))");
#line 998 "../src/preferences-dialog.vala"
	_tmp0_ = g_strdup (name);
#line 998 "../src/preferences-dialog.vala"
	_tmp1_ = g_strdup (title);
#line 998 "../src/preferences-dialog.vala"
	memset (&_tmp2_, 0, sizeof (PomodoroPreferencesDialogPageMeta));
#line 998 "../src/preferences-dialog.vala"
	_g_free0 (_tmp2_.name);
#line 998 "../src/preferences-dialog.vala"
	_tmp2_.name = _tmp0_;
#line 998 "../src/preferences-dialog.vala"
	_g_free0 (_tmp2_.title);
#line 998 "../src/preferences-dialog.vala"
	_tmp2_.title = _tmp1_;
#line 998 "../src/preferences-dialog.vala"
	_tmp2_.type = type;
#line 998 "../src/preferences-dialog.vala"
	meta = _tmp2_;
#line 1004 "../src/preferences-dialog.vala"
	_tmp3_ = self->priv->pages;
#line 1004 "../src/preferences-dialog.vala"
	_tmp4_ = g_strdup (name);
#line 1004 "../src/preferences-dialog.vala"
	_tmp5_ = meta;
#line 1004 "../src/preferences-dialog.vala"
	_tmp6_ = _tmp5_;
#line 1004 "../src/preferences-dialog.vala"
	_tmp7_ = _pomodoro_preferences_dialog_page_meta_dup0 (&_tmp6_);
#line 1004 "../src/preferences-dialog.vala"
	g_hash_table_insert (_tmp3_, _tmp4_, _tmp7_);
#line 993 "../src/preferences-dialog.vala"
	pomodoro_preferences_dialog_page_meta_destroy (&meta);
#line 4900 "preferences-dialog.c"
}

void
pomodoro_preferences_dialog_remove_page (PomodoroPreferencesDialog* self,
                                         const gchar* name)
{
	GtkStack* _tmp0_;
	GHashTable* _tmp9_;
#line 1007 "../src/preferences-dialog.vala"
	g_return_if_fail (self != NULL);
#line 1007 "../src/preferences-dialog.vala"
	g_return_if_fail (name != NULL);
#line 1009 "../src/preferences-dialog.vala"
	_tmp0_ = self->priv->stack;
#line 1009 "../src/preferences-dialog.vala"
	if (_tmp0_ != NULL) {
#line 4917 "preferences-dialog.c"
		GtkWidget* child = NULL;
		GtkStack* _tmp1_;
		GtkWidget* _tmp2_;
		GtkWidget* _tmp3_;
		GtkStack* _tmp4_;
		const gchar* _tmp5_;
		GtkWidget* _tmp6_;
#line 1011 "../src/preferences-dialog.vala"
		_tmp1_ = self->priv->stack;
#line 1011 "../src/preferences-dialog.vala"
		_tmp2_ = gtk_stack_get_child_by_name (_tmp1_, name);
#line 1011 "../src/preferences-dialog.vala"
		_tmp3_ = _g_object_ref0 (_tmp2_);
#line 1011 "../src/preferences-dialog.vala"
		child = _tmp3_;
#line 1013 "../src/preferences-dialog.vala"
		_tmp4_ = self->priv->stack;
#line 1013 "../src/preferences-dialog.vala"
		_tmp5_ = gtk_stack_get_visible_child_name (_tmp4_);
#line 1013 "../src/preferences-dialog.vala"
		if (g_strcmp0 (_tmp5_, name) == 0) {
#line 1014 "../src/preferences-dialog.vala"
			pomodoro_preferences_dialog_set_page (self, "main");
#line 4941 "preferences-dialog.c"
		}
#line 1017 "../src/preferences-dialog.vala"
		_tmp6_ = child;
#line 1017 "../src/preferences-dialog.vala"
		if (_tmp6_ != NULL) {
#line 4947 "preferences-dialog.c"
			GtkStack* _tmp7_;
			GtkWidget* _tmp8_;
#line 1018 "../src/preferences-dialog.vala"
			_tmp7_ = self->priv->stack;
#line 1018 "../src/preferences-dialog.vala"
			_tmp8_ = child;
#line 1018 "../src/preferences-dialog.vala"
			gtk_container_remove ((GtkContainer*) _tmp7_, _tmp8_);
#line 4956 "preferences-dialog.c"
		}
#line 1009 "../src/preferences-dialog.vala"
		_g_object_unref0 (child);
#line 4960 "preferences-dialog.c"
	}
#line 1022 "../src/preferences-dialog.vala"
	_tmp9_ = self->priv->pages;
#line 1022 "../src/preferences-dialog.vala"
	g_hash_table_remove (_tmp9_, name);
#line 4966 "preferences-dialog.c"
}

void
pomodoro_preferences_dialog_set_page (PomodoroPreferencesDialog* self,
                                      const gchar* name)
{
	PomodoroPreferencesPage* page = NULL;
	PomodoroPreferencesPage* _tmp0_;
	PomodoroPreferencesPage* _tmp1_;
	PomodoroPreferencesPage* _tmp2_;
#line 1025 "../src/preferences-dialog.vala"
	g_return_if_fail (self != NULL);
#line 1025 "../src/preferences-dialog.vala"
	g_return_if_fail (name != NULL);
#line 1027 "../src/preferences-dialog.vala"
	_tmp0_ = pomodoro_preferences_dialog_get_page (self, name);
#line 1027 "../src/preferences-dialog.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 1027 "../src/preferences-dialog.vala"
	page = _tmp1_;
#line 1029 "../src/preferences-dialog.vala"
	_tmp2_ = page;
#line 1029 "../src/preferences-dialog.vala"
	if (_tmp2_ != NULL) {
#line 4991 "preferences-dialog.c"
		GtkStack* _tmp3_;
#line 1030 "../src/preferences-dialog.vala"
		_tmp3_ = self->priv->stack;
#line 1030 "../src/preferences-dialog.vala"
		gtk_stack_set_visible_child_name (_tmp3_, name);
#line 4997 "preferences-dialog.c"
	} else {
#line 1033 "../src/preferences-dialog.vala"
		g_warning ("preferences-dialog.vala:1033: Could not change page to \"%s\"", name);
#line 5001 "preferences-dialog.c"
	}
#line 1025 "../src/preferences-dialog.vala"
	_g_object_unref0 (page);
#line 5005 "preferences-dialog.c"
}

PomodoroPreferencesDialog*
pomodoro_preferences_dialog_construct (GType object_type)
{
	PomodoroPreferencesDialog * self = NULL;
#line 770 "../src/preferences-dialog.vala"
	self = (PomodoroPreferencesDialog*) g_object_new (object_type, NULL);
#line 770 "../src/preferences-dialog.vala"
	return self;
#line 5016 "preferences-dialog.c"
}

PomodoroPreferencesDialog*
pomodoro_preferences_dialog_new (void)
{
#line 770 "../src/preferences-dialog.vala"
	return pomodoro_preferences_dialog_construct (POMODORO_TYPE_PREFERENCES_DIALOG);
#line 5024 "preferences-dialog.c"
}

static void
pomodoro_preferences_dialog_page_meta_copy (const PomodoroPreferencesDialogPageMeta* self,
                                            PomodoroPreferencesDialogPageMeta* dest)
{
	const gchar* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
#line 792 "../src/preferences-dialog.vala"
	(*dest).type = (*self).type;
#line 792 "../src/preferences-dialog.vala"
	_tmp0_ = (*self).name;
#line 792 "../src/preferences-dialog.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 792 "../src/preferences-dialog.vala"
	_g_free0 ((*dest).name);
#line 792 "../src/preferences-dialog.vala"
	(*dest).name = _tmp1_;
#line 792 "../src/preferences-dialog.vala"
	_tmp2_ = (*self).title;
#line 792 "../src/preferences-dialog.vala"
	_tmp3_ = g_strdup (_tmp2_);
#line 792 "../src/preferences-dialog.vala"
	_g_free0 ((*dest).title);
#line 792 "../src/preferences-dialog.vala"
	(*dest).title = _tmp3_;
#line 5053 "preferences-dialog.c"
}

static void
pomodoro_preferences_dialog_page_meta_destroy (PomodoroPreferencesDialogPageMeta* self)
{
#line 795 "../src/preferences-dialog.vala"
	_g_free0 ((*self).name);
#line 796 "../src/preferences-dialog.vala"
	_g_free0 ((*self).title);
#line 5063 "preferences-dialog.c"
}

static PomodoroPreferencesDialogPageMeta*
pomodoro_preferences_dialog_page_meta_dup (const PomodoroPreferencesDialogPageMeta* self)
{
	PomodoroPreferencesDialogPageMeta* dup;
#line 792 "../src/preferences-dialog.vala"
	dup = g_new0 (PomodoroPreferencesDialogPageMeta, 1);
#line 792 "../src/preferences-dialog.vala"
	pomodoro_preferences_dialog_page_meta_copy (self, dup);
#line 792 "../src/preferences-dialog.vala"
	return dup;
#line 5076 "preferences-dialog.c"
}

static void
pomodoro_preferences_dialog_page_meta_free (PomodoroPreferencesDialogPageMeta* self)
{
#line 792 "../src/preferences-dialog.vala"
	pomodoro_preferences_dialog_page_meta_destroy (self);
#line 792 "../src/preferences-dialog.vala"
	g_free (self);
#line 5086 "preferences-dialog.c"
}

static GType
pomodoro_preferences_dialog_page_meta_get_type_once (void)
{
	GType pomodoro_preferences_dialog_page_meta_type_id;
	pomodoro_preferences_dialog_page_meta_type_id = g_boxed_type_register_static ("PomodoroPreferencesDialogPageMeta", (GBoxedCopyFunc) pomodoro_preferences_dialog_page_meta_dup, (GBoxedFreeFunc) pomodoro_preferences_dialog_page_meta_free);
	return pomodoro_preferences_dialog_page_meta_type_id;
}

static GType
pomodoro_preferences_dialog_page_meta_get_type (void)
{
	static volatile gsize pomodoro_preferences_dialog_page_meta_type_id__once = 0;
	if (g_once_init_enter (&pomodoro_preferences_dialog_page_meta_type_id__once)) {
		GType pomodoro_preferences_dialog_page_meta_type_id;
		pomodoro_preferences_dialog_page_meta_type_id = pomodoro_preferences_dialog_page_meta_get_type_once ();
		g_once_init_leave (&pomodoro_preferences_dialog_page_meta_type_id__once, pomodoro_preferences_dialog_page_meta_type_id);
	}
	return pomodoro_preferences_dialog_page_meta_type_id__once;
}

static void
_pomodoro_preferences_dialog_page_meta_free0_ (gpointer var)
{
#line 813 "../src/preferences-dialog.vala"
	(var == NULL) ? NULL : (var = (pomodoro_preferences_dialog_page_meta_free (var), NULL));
#line 5114 "preferences-dialog.c"
}

static void
_pomodoro_preferences_dialog_on_visible_child_notify_g_object_notify (GObject* _sender,
                                                                      GParamSpec* pspec,
                                                                      gpointer self)
{
#line 837 "../src/preferences-dialog.vala"
	pomodoro_preferences_dialog_on_visible_child_notify ((PomodoroPreferencesDialog*) self);
#line 5124 "preferences-dialog.c"
}

static GObject *
pomodoro_preferences_dialog_constructor (GType type,
                                         guint n_construct_properties,
                                         GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	PomodoroPreferencesDialog * self;
	GdkGeometry geometry = {0};
	GdkGeometry _tmp0_ = {0};
	GdkGeometry _tmp1_;
	GHashFunc _tmp2_;
	GEqualFunc _tmp3_;
	GHashTable* _tmp4_;
	PeasEngine* _tmp5_;
	PeasExtensionSet* _tmp6_;
	GtkStack* _tmp7_;
#line 799 "../src/preferences-dialog.vala"
	parent_class = G_OBJECT_CLASS (pomodoro_preferences_dialog_parent_class);
#line 799 "../src/preferences-dialog.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 799 "../src/preferences-dialog.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, POMODORO_TYPE_PREFERENCES_DIALOG, PomodoroPreferencesDialog);
#line 801 "../src/preferences-dialog.vala"
	pomodoro_preferences_dialog_instance = self;
#line 803 "../src/preferences-dialog.vala"
	memset (&_tmp0_, 0, sizeof (GdkGeometry));
#line 803 "../src/preferences-dialog.vala"
	_tmp0_.min_width = POMODORO_PREFERENCES_DIALOG_DEFAULT_WIDTH;
#line 803 "../src/preferences-dialog.vala"
	_tmp0_.max_width = -1;
#line 803 "../src/preferences-dialog.vala"
	_tmp0_.min_height = 300;
#line 803 "../src/preferences-dialog.vala"
	_tmp0_.max_height = -1;
#line 803 "../src/preferences-dialog.vala"
	geometry = _tmp0_;
#line 809 "../src/preferences-dialog.vala"
	_tmp1_ = geometry;
#line 809 "../src/preferences-dialog.vala"
	gtk_window_set_geometry_hints ((GtkWindow*) self, (GtkWidget*) self, &_tmp1_, GDK_HINT_MIN_SIZE);
#line 813 "../src/preferences-dialog.vala"
	_tmp2_ = g_str_hash;
#line 813 "../src/preferences-dialog.vala"
	_tmp3_ = g_str_equal;
#line 813 "../src/preferences-dialog.vala"
	_tmp4_ = g_hash_table_new_full (_tmp2_, _tmp3_, _g_free0_, _pomodoro_preferences_dialog_page_meta_free0_);
#line 813 "../src/preferences-dialog.vala"
	_g_hash_table_unref0 (self->priv->pages);
#line 813 "../src/preferences-dialog.vala"
	self->priv->pages = _tmp4_;
#line 815 "../src/preferences-dialog.vala"
	pomodoro_preferences_dialog_add_page (self, "main", _ ("Preferences"), POMODORO_TYPE_PREFERENCES_MAIN_PAGE);
#line 819 "../src/preferences-dialog.vala"
	pomodoro_preferences_dialog_add_page (self, "plugins", _ ("Plugins"), POMODORO_TYPE_PREFERENCES_PLUGINS_PAGE);
#line 823 "../src/preferences-dialog.vala"
	pomodoro_preferences_dialog_add_page (self, "keyboard-shortcut", _ ("Keyboard Shortcut"), POMODORO_TYPE_PREFERENCES_KEYBOARD_SHORTCUT_PAGE);
#line 827 "../src/preferences-dialog.vala"
	g_action_map_add_action_entries ((GActionMap*) self, POMODORO_PREFERENCES_DIALOG_ACTION_ENTRIES, (gint) G_N_ELEMENTS (POMODORO_PREFERENCES_DIALOG_ACTION_ENTRIES), self);
#line 829 "../src/preferences-dialog.vala"
	pomodoro_preferences_dialog_history_clear (self);
#line 831 "../src/preferences-dialog.vala"
	pomodoro_preferences_dialog_set_page (self, "main");
#line 834 "../src/preferences-dialog.vala"
	_tmp5_ = peas_engine_get_default ();
#line 834 "../src/preferences-dialog.vala"
	_tmp6_ = peas_extension_set_new (_tmp5_, POMODORO_TYPE_PREFERENCES_DIALOG_EXTENSION, NULL);
#line 834 "../src/preferences-dialog.vala"
	_g_object_unref0 (self->priv->extensions);
#line 834 "../src/preferences-dialog.vala"
	self->priv->extensions = _tmp6_;
#line 837 "../src/preferences-dialog.vala"
	_tmp7_ = self->priv->stack;
#line 837 "../src/preferences-dialog.vala"
	g_signal_connect_object ((GObject*) _tmp7_, "notify::visible-child", (GCallback) _pomodoro_preferences_dialog_on_visible_child_notify_g_object_notify, self, 0);
#line 839 "../src/preferences-dialog.vala"
	pomodoro_preferences_dialog_on_visible_child_notify (self);
#line 799 "../src/preferences-dialog.vala"
	return obj;
#line 5206 "preferences-dialog.c"
}

static void
pomodoro_preferences_dialog_class_init (PomodoroPreferencesDialogClass * klass,
                                        gpointer klass_data)
{
#line 770 "../src/preferences-dialog.vala"
	pomodoro_preferences_dialog_parent_class = g_type_class_peek_parent (klass);
#line 770 "../src/preferences-dialog.vala"
	g_type_class_adjust_private_offset (klass, &PomodoroPreferencesDialog_private_offset);
#line 770 "../src/preferences-dialog.vala"
	G_OBJECT_CLASS (klass)->constructor = pomodoro_preferences_dialog_constructor;
#line 770 "../src/preferences-dialog.vala"
	G_OBJECT_CLASS (klass)->finalize = pomodoro_preferences_dialog_finalize;
#line 770 "../src/preferences-dialog.vala"
	gtk_widget_class_set_template_from_resource (GTK_WIDGET_CLASS (klass), "/org/gnome/pomodoro/preferences.ui");
#line 770 "../src/preferences-dialog.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "header_bar", FALSE, PomodoroPreferencesDialog_private_offset + G_STRUCT_OFFSET (PomodoroPreferencesDialogPrivate, header_bar));
#line 770 "../src/preferences-dialog.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "stack", FALSE, PomodoroPreferencesDialog_private_offset + G_STRUCT_OFFSET (PomodoroPreferencesDialogPrivate, stack));
#line 770 "../src/preferences-dialog.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "back_button", FALSE, PomodoroPreferencesDialog_private_offset + G_STRUCT_OFFSET (PomodoroPreferencesDialogPrivate, back_button));
#line 5229 "preferences-dialog.c"
}

static void
pomodoro_preferences_dialog_gtk_buildable_interface_init (GtkBuildableIface * iface,
                                                          gpointer iface_data)
{
#line 917 "../src/preferences-dialog.vala"
	pomodoro_preferences_dialog_gtk_buildable_parent_iface = g_type_interface_peek_parent (iface);
#line 917 "../src/preferences-dialog.vala"
	iface->parser_finished = (void (*) (GtkBuildable*, GtkBuilder*)) pomodoro_preferences_dialog_real_parser_finished;
#line 5240 "preferences-dialog.c"
}

static void
pomodoro_preferences_dialog_instance_init (PomodoroPreferencesDialog * self,
                                           gpointer klass)
{
#line 770 "../src/preferences-dialog.vala"
	self->priv = pomodoro_preferences_dialog_get_instance_private (self);
#line 917 "../src/preferences-dialog.vala"
	gtk_widget_init_template (GTK_WIDGET (self));
#line 5251 "preferences-dialog.c"
}

static void
pomodoro_preferences_dialog_finalize (GObject * obj)
{
	PomodoroPreferencesDialog * self;
#line 770 "../src/preferences-dialog.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, POMODORO_TYPE_PREFERENCES_DIALOG, PomodoroPreferencesDialog);
#line 844 "../src/preferences-dialog.vala"
	pomodoro_preferences_dialog_instance = self;
#line 788 "../src/preferences-dialog.vala"
	_g_hash_table_unref0 (self->priv->pages);
#line 789 "../src/preferences-dialog.vala"
	(self->priv->history == NULL) ? NULL : (self->priv->history = (_g_list_free__g_free0_ (self->priv->history), NULL));
#line 790 "../src/preferences-dialog.vala"
	_g_object_unref0 (self->priv->extensions);
#line 917 "../src/preferences-dialog.vala"
	G_OBJECT_CLASS (pomodoro_preferences_dialog_parent_class)->finalize (obj);
#line 5270 "preferences-dialog.c"
}

static GType
pomodoro_preferences_dialog_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (PomodoroPreferencesDialogClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) pomodoro_preferences_dialog_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PomodoroPreferencesDialog), 0, (GInstanceInitFunc) pomodoro_preferences_dialog_instance_init, NULL };
	static const GInterfaceInfo gtk_buildable_info = { (GInterfaceInitFunc) pomodoro_preferences_dialog_gtk_buildable_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	GType pomodoro_preferences_dialog_type_id;
	pomodoro_preferences_dialog_type_id = g_type_register_static (gtk_application_window_get_type (), "PomodoroPreferencesDialog", &g_define_type_info, 0);
	g_type_add_interface_static (pomodoro_preferences_dialog_type_id, gtk_buildable_get_type (), &gtk_buildable_info);
	PomodoroPreferencesDialog_private_offset = g_type_add_instance_private (pomodoro_preferences_dialog_type_id, sizeof (PomodoroPreferencesDialogPrivate));
	return pomodoro_preferences_dialog_type_id;
}

GType
pomodoro_preferences_dialog_get_type (void)
{
	static volatile gsize pomodoro_preferences_dialog_type_id__once = 0;
	if (g_once_init_enter (&pomodoro_preferences_dialog_type_id__once)) {
		GType pomodoro_preferences_dialog_type_id;
		pomodoro_preferences_dialog_type_id = pomodoro_preferences_dialog_get_type_once ();
		g_once_init_leave (&pomodoro_preferences_dialog_type_id__once, pomodoro_preferences_dialog_type_id);
	}
	return pomodoro_preferences_dialog_type_id__once;
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
#line 770 "../src/preferences-dialog.vala"
	if ((array != NULL) && (destroy_func != NULL)) {
#line 5304 "preferences-dialog.c"
		gssize i;
#line 770 "../src/preferences-dialog.vala"
		for (i = 0; i < array_length; i = i + 1) {
#line 770 "../src/preferences-dialog.vala"
			if (((gpointer*) array)[i] != NULL) {
#line 770 "../src/preferences-dialog.vala"
				destroy_func (((gpointer*) array)[i]);
#line 5312 "preferences-dialog.c"
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
#line 770 "../src/preferences-dialog.vala"
	_vala_array_destroy (array, array_length, destroy_func);
#line 770 "../src/preferences-dialog.vala"
	g_free (array);
#line 5327 "preferences-dialog.c"
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
#line 770 "../src/preferences-dialog.vala"
	if (array) {
#line 770 "../src/preferences-dialog.vala"
		while (((gpointer*) array)[length]) {
#line 770 "../src/preferences-dialog.vala"
			length++;
#line 5341 "preferences-dialog.c"
		}
	}
#line 770 "../src/preferences-dialog.vala"
	return length;
#line 5346 "preferences-dialog.c"
}

